<?xml version="1.0" encoding="UTF-8"?>
<!--
Licensed Materials - Property of IBM

(C) Copyright IBM Corp. 2010, 2012 All Rights Reserved

US Government Users Restricted Rights - Use, duplicate or
disclosure restricted by GSA ADP Schedule Contract with
IBM Corp.
-->
<web-app id="WebApp_ID" version="2.4" xmlns="http://java.sun.com/xml/ns/j2ee" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://java.sun.com/xml/ns/j2ee http://java.sun.com/xml/ns/j2ee/web-app_2_4.xsd">
<display-name>com.ibm.scm.gui.rbce.portlet</display-name>
	<context-param>
		<param-name>com.ibm.ws.jsf.JSP_UPDATE_CHECK</param-name>
		<param-value>true</param-value>
		<description>Monitors Faces JSP files for modifications and synchronizes a running server with
the changes without restarting the server.  If this parameter is set to false or
removed from the deployment descriptor, any changes made to Faces JSP files may
not be seen by the server until it is restarted.  This parameter is usually set
to true while the Faces JSP files are being developed and debugged in order to
improve the performance of the development environment.</description>
	</context-param>
	<context-param>
		<param-name>com.ibm.ws.jsf.LOAD_FACES_CONFIG_AT_STARTUP</param-name>
		<param-value>true</param-value>
		<description></description>
	</context-param>
	<context-param>
		<param-name>com.ibm.faces.USE_HXCLIENT_FULL</param-name>
		<param-value>false</param-value>
		<description></description>
	</context-param>
	<context-param>
		<param-name>com.sun.faces.NUMBER_OF_VIEWS_IN_SESSION</param-name>
		<param-value>60</param-value>
		<description></description>
	</context-param>


	<listener>
		<listener-class>com.sun.faces.config.ConfigureListener</listener-class>
	</listener>

	<listener>
		<listener-class>com.ibm.scm.gui.rbce.base.SCMSessionListener</listener-class>
	</listener>
	<servlet>
		<servlet-name>JS Resource Servlet</servlet-name>
		<servlet-class>
		com.ibm.faces.webapp.JSResourceServlet</servlet-class>
		<load-on-startup>-1</load-on-startup>
	</servlet>
	<servlet>
		<servlet-name>SCM JS Resource Servlet</servlet-name>
		<servlet-class>com.ibm.scm.common.ui.webapp.SCMJSResServlet</servlet-class>
		<load-on-startup>-1</load-on-startup>
	</servlet>
	<servlet>
		<servlet-name>Faces Servlet</servlet-name>
		<servlet-class>
		javax.faces.webapp.FacesServlet</servlet-class>
		<load-on-startup>-1</load-on-startup>
	</servlet>
	<servlet>
		<servlet-name>
			ManageFabricBackupConfigurationServlet
		</servlet-name>
		<display-name>
			ManageFabricBackupConfigurationServlet
		</display-name>
		<description></description>
		<servlet-class>
			pagecode.page.fabric.ManageFabricBackupConfigurationServlet
		</servlet-class>
	</servlet>
	<servlet>
		<servlet-name>ManageFabricEditorServlet</servlet-name>
		<display-name>ManageFabricEditorServlet</display-name>
		<description></description>
		<servlet-class>
			pagecode.page.fabric.ManageFabricEditorServlet
		</servlet-class>
	</servlet>
	<servlet>
		<servlet-name>PhysicalLocateServlet</servlet-name>
		<display-name>PhysicalLocateServlet</display-name>
		<description></description>
		<servlet-class>
		pagecode.page.rbce.physical.PhysicalLocateServlet</servlet-class>
	</servlet>
	<servlet>
		<servlet-name>IntegratorRSSM</servlet-name>
		<display-name>IntegratorRSSM</display-name>
		<description></description>
		<servlet-class>
		com.ibm.scm.gui.rbce.integration.IntegratorRSSM</servlet-class>
	</servlet>
	<servlet>
		<servlet-name>IntegratorSASRSSM</servlet-name>
		<display-name>IntegratorSASRSSM</display-name>
		<description></description>
		<servlet-class>
		com.ibm.scm.gui.rbce.integration.IntegratorSASRSSM</servlet-class>
	</servlet>

	<servlet-mapping>
		<servlet-name>ManageFabricBackupConfigurationServlet</servlet-name>
		<url-pattern>/ManageFabricBackupConfigurationServlet</url-pattern>
	</servlet-mapping>
	<servlet-mapping>
		<servlet-name>ManageFabricEditorServlet</servlet-name>
		<url-pattern>/ManageFabricEditorServlet</url-pattern>
	</servlet-mapping>
	<servlet-mapping>
		<servlet-name>JS Resource Servlet</servlet-name>
		<url-pattern>/.ibmjsfres/*</url-pattern>
	</servlet-mapping>
	<servlet-mapping>
		<servlet-name>SCM JS Resource Servlet</servlet-name>
		<url-pattern>/.SCMJSRes/*</url-pattern>
	</servlet-mapping>
	<servlet-mapping>
		<servlet-name>Faces Servlet</servlet-name>
		<url-pattern>/faces/*</url-pattern>
	</servlet-mapping>
	<servlet-mapping>
		<servlet-name>Faces Servlet</servlet-name>
		<url-pattern>*.faces</url-pattern>
	</servlet-mapping>
	<servlet-mapping>
			<servlet-name>PhysicalLocateServlet</servlet-name>
			<url-pattern>/PhysicalLocateServlet</url-pattern>
	</servlet-mapping>
	<servlet-mapping>
		<servlet-name>IntegratorRSSM</servlet-name>
		<url-pattern>/IntegratorRSSM</url-pattern>
	</servlet-mapping>
	<servlet-mapping>
		<servlet-name>IntegratorSASRSSM</servlet-name>
		<url-pattern>/IntegratorSASRSSM</url-pattern>
	</servlet-mapping>


	<welcome-file-list>
		<welcome-file>index.html</welcome-file>
		<welcome-file>index.htm</welcome-file>
		<welcome-file>index.jsp</welcome-file>
		<welcome-file>default.html</welcome-file>
		<welcome-file>default.htm</welcome-file>
		<welcome-file>default.jsp</welcome-file>
	</welcome-file-list>
	<error-page>
		<exception-type>java.lang.Throwable</exception-type>
		<location>faces/page/rbce/error/ErrorPageWrapper.jsp</location>
	</error-page>
	
    <session-config>
        <session-timeout>-1</session-timeout>
    </session-config>
    <security-constraint>
		<display-name>PROTECTED</display-name>
		<web-resource-collection>
			<web-resource-name>PROTECTED</web-resource-name>
			<url-pattern>/*</url-pattern>
		</web-resource-collection>
		<auth-constraint>
			<description />
			<role-name>user.anyone</role-name>
		</auth-constraint>
	</security-constraint>
	<login-config>
		<auth-method>FORM</auth-method>
		<form-login-config>
			<form-login-page>/../ibm/console/</form-login-page>
			<form-error-page>/../ibm/console/</form-error-page>
		</form-login-config>
	</login-config>
	<security-role>
		<role-name>user.anyone</role-name>
	</security-role>
</web-app>
