/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// ShutDownAndRecover.js


var controllerRadios = new Array();

function controllerObj(connected,inservice,message){
 this.connected = connected;
 this.inservice = inservice;
 this.msg = message;
}

function ShutDownAndRecover_valueChange(){
	document.getElementById(namespace_g + "myForm").submit();	
}

function setNewController(obj){
	controllerRadios.push(obj);
}

var browser=navigator.appName;

var CTLR_SINGLE = 0;
var CTLR_MULTI = 1;
var CTLR_STANDALONE = 2;

var ACTION_OPTIONS = ["SERVICE","REBOOT","BRINGONLINE","REMOVAL"];
var CONTROLLER_OPTIONS = ["SINGLE","MULTI","STANDALONE"];

var confirm_indicators = {
		SERVICE : namespace_g + "myForm:contr_confirm_msg_indicator_shutdown_service",
		REMOVAL : namespace_g + "myForm:contr_confirm_msg_indicator_prepare_removal",
		REBOOT : namespace_g + "myForm:contr_confirm_msg_indicator_reboot",
		BRINGONLINE : namespace_g + "myForm:contr_confirm_msg_indicator_bring_online"
};

var confirm_titles = {
		SERVICE : {
			SINGLE : namespace_g + "myForm:contr_confirm_msg_title_shutdown_service_single",
			MULTI : namespace_g + "myForm:contr_confirm_msg_title_shutdown_service_dual",
			STANDALONE : namespace_g + "myForm:contr_confirm_msg_title_shutdown_service_single"
		},
		REMOVAL : {
			SINGLE : namespace_g + "myForm:contr_confirm_msg_title_prepare_removal_single",
			MULTI : namespace_g + "myForm:contr_confirm_msg_title_prepare_removal_dual",
			STANDALONE : namespace_g + "myForm:contr_confirm_msg_title_prepare_removal_single"
		},
		REBOOT : {
			SINGLE : namespace_g + "myForm:contr_confirm_msg_title_reboot_single",
			MULTI : namespace_g + "myForm:contr_confirm_msg_title_reboot_dual",
			STANDALONE : namespace_g + "myForm:contr_confirm_msg_title_reboot_single"
		},
		BRINGONLINE : {
			SINGLE : namespace_g + "myForm:contr_confirm_msg_title_bring_online_single",
			STANDALONE : namespace_g + "myForm:contr_confirm_msg_title_bring_online_single"
		}
};

var confirm_contents = {
		SERVICE : {
			SINGLE : namespace_g + "myForm:contr_confirm_msg_content_shutdown_service_single_of_dual",
			MULTI : namespace_g + "myForm:contr_confirm_msg_content_shutdown_service_both_of_dual",
			STANDALONE : namespace_g + "myForm:contr_confirm_msg_content_shutdown_service_single_of_single"
		},
		REMOVAL : {
			SINGLE : namespace_g + "myForm:contr_confirm_msg_content_prepare_removal_single_of_dual",
			MULTI : namespace_g + "myForm:contr_confirm_msg_content_prepare_removal_both_of_dual",
			STANDALONE : namespace_g + "myForm:contr_confirm_msg_content_prepare_removal_single_of_single"
		},
		REBOOT : {
			SINGLE : namespace_g + "myForm:contr_confirm_msg_content_reboot_single_of_dual",
			MULTI : namespace_g + "myForm:contr_confirm_msg_content_reboot_both_of_dual",
			STANDALONE : namespace_g + "myForm:contr_confirm_msg_content_reboot_single_of_single"
		},
		BRINGONLINE : {
			SINGLE : null,
			STANDALONE : null
		}
};

function submitAction(){ 
	document.getElementById(namespace_g + "myForm:contr_confirm_indicator").style.display = "";
	document.getElementById(namespace_g + "myForm:refreshing_img_indicator").style.display = "";
	document.getElementById(namespace_g + "myForm:submit_btn").disabled = true;
	document.getElementById(namespace_g + "myForm:cancel_btn1").disabled = true;
	document.getElementById(namespace_g + "myForm:requestType").value="SUBMIT";
	document.getElementById(namespace_g + "myForm:onloadBehaviorBtn").click();
}

function ajaxStart(){
		controllerRadios = new Array();
		ACTION_SELECTED = 0;
		if(document.getElementById(namespace_g + "myForm:requestType").value=="INIT"){
			displayMainContents(false);
		}
}

var CONTROLLER_OPTION_NUMBER = 0;
function pageInit(){
	var controllerNumber = Number(document.getElementById(namespace_g + "myForm:controllerNumber").innerHTML);
	CONTROLLER_OPTION_NUMBER = controllerNumber > 1 ? controllerNumber + 1 : controllerNumber;
	var defaultAction = Number(document.getElementById(namespace_g + "myForm:defaultAction").innerHTML);
	var actions = document.getElementsByName("operate");
	for(var i = 0;i < actions.length;i ++){
		if(actions[i].checked){
			defaultAction = i + 1;			
		}
	}
	if(controllerNumber == 0){
		disabledAllActionItems();
	}
	
	actions[defaultAction - 1].click();
	
	if(document.getElementById(namespace_g + "myForm:requestType").value=="SUBMIT"){
		document.getElementById(namespace_g + "myForm:confirmDialogHiden").click();
		document.getElementById(namespace_g + "myForm:requestType").value=="INIT";
	    window.location.href = window.location.href;
	}
}

function disabledAllActionItems(){
	var actions = document.getElementsByName("operate");
	for(var i = 0;i < actions.length;i ++){
		actions[i].checked = false;
		actions[i].disabled = true;
	}
	var removeobj = document.getElementById("cbRemove");
	removeobj.checked = false;
	removeobj.disabled = true;
}

function displayConfirmMessage(index){
	//prepare for the action index in the maps.
	var actionindex = index - 1;
	
	//prepare for the controller selection index in the map.
	var controllers = getControllerRadioGroups();
	var ctlrindex = CTLR_SINGLE;
	if (controllers.length < 2) {
		ctlrindex = CTLR_STANDALONE; // set to standalone mode;
	} else if (controllers[2].checked) {
		ctlrindex = CTLR_MULTI;
	}
	
	//clear all messages
	document.getElementById(namespace_g + "myForm:contr_confirm_indicator").innerHTML = "";
	document.getElementById(namespace_g + "myForm:contr_confirm_msg_title").innerHTML = "";
	document.getElementById(namespace_g + "myForm:contr_confirm_msg_content").innerHTML = "";
	
	// confirm indicator message
	var indicator_message = document.getElementById(confirm_indicators[ACTION_OPTIONS[actionindex]]).innerHTML;
	document.getElementById(namespace_g + "myForm:contr_confirm_indicator").innerHTML = indicator_message
	
	// confirm title
	var title_message = document.getElementById(confirm_titles[ACTION_OPTIONS[actionindex]][CONTROLLER_OPTIONS[ctlrindex]]).innerHTML;
	document.getElementById(namespace_g + "myForm:contr_confirm_msg_title").innerHTML = title_message;
	
	// confirm controller strings
	var ctlTR1 = document.getElementById("trContr_name1");
	var ctlTR2 = document.getElementById("trContr_name2");
	var ctl1 = document.getElementById(namespace_g + "myForm:contr_name1");
	var ctl2 = document.getElementById(namespace_g + "myForm:contr_name2");
	
	ctlTR1.style.display = "none";
	ctlTR2.style.display = "none";
	
	var controller1Name = controllerRadios[0].msg;
	controller1Name = controller1Name.substring(0, controller1Name.indexOf('('));
	ctl1.innerHTML = controller1Name;
	
	if (controllers[0].checked || (controllers.length >= 2 && controllers[2].checked)) {
		ctlTR1.style.display = "";
	}
	
	if (controllerRadios.length > 1) {
		var controller2Name = controllerRadios[1].msg;
		controller2Name = controller2Name.substring(0, controller2Name.indexOf('('));
		ctl2.innerHTML = controller2Name;
		
		if (controllers[1].checked || (controllers.length >= 2 && controllers[2].checked)) {
			ctlTR2.style.display = "";
		}
	}
	
	//navigate away warning
	document.getElementById("notNavigateAwayWarningTr").style.display = "none";
	if ((index == DEFAULTACTION_SHUTDOWN_SERVICE || index == DEFAULTACTION_PREPARE_REMOVAL) && ctlrindex != CTLR_SINGLE || index == DEFAULTACTION_BRINGONLINE) {
		document.getElementById("notNavigateAwayWarningTr").style.display = "";		
	}

	//confirm content
	if (confirm_contents[ACTION_OPTIONS[actionindex]][CONTROLLER_OPTIONS[ctlrindex]] != null) {
		var content_message = document.getElementById(confirm_contents[ACTION_OPTIONS[actionindex]][CONTROLLER_OPTIONS[ctlrindex]]).innerHTML;
		document.getElementById(namespace_g + "myForm:contr_confirm_msg_content").innerHTML = content_message;
	} else {
		document.getElementById("contr_confirm_msg_row").style.display = "none";
	}
}

function onLoad_ShutDownAndRecover(){
	if(document.all){ // IE
			lazySendAjaxCall(); 
		}else{ // FF
			hX_5.addBehavior("#body", "onload", new hX_5.JSFBehaviorGeneric("action:get;", "target:"+ namespace_g +"myForm:ajaxpanel")); 
		}
}

function showConfirmMessage(){
	displayConfirmMessage(ACTION_SELECTED);
	document.getElementById(namespace_g + "myForm:submit_btn").disabled = false;
	document.getElementById(namespace_g + "myForm:cancel_btn1").disabled = false;
}
function removalAction() {
	var cbxobj = document.getElementById("cbRemove");
	if (cbxobj.checked) {
		document.getElementById(namespace_g + "myForm:submitRemoval").value = "true";
		ACTION_SELECTED = DEFAULTACTION_PREPARE_REMOVAL;
	} else {
		document.getElementById(namespace_g + "myForm:submitRemoval").value = "false";
		ACTION_SELECTED = DEFAULTACTION_SHUTDOWN_SERVICE;
	}
}
var ACTION_SELECTED = 0;
function controllerAction(thisObj){
	if(controllerRadios.length<1)
		return;
	var controllers = getControllerRadioGroups();
	ACTION_SELECTED = thisObj.value;
	document.getElementById(namespace_g + "myForm:submitAction").value=thisObj.value;
	document.getElementById("cbRemove").disabled = true;
	if(thisObj.value==DEFAULTACTION_SHUTDOWN_SERVICE){
		for (var i in controllerRadios) {
			if (!controllerRadios[i].inservice && controllerRadios[i].connected) {
				disableControllerItem(i, false);
			} else {
				disableControllerItem(i, true);
			}
		}
	    if(CONTROLLER_OPTION_NUMBER==3){
			if(!controllerRadios[0].inservice && !controllerRadios[1].inservice && controllerRadios[0].connected && controllerRadios[1].connected)
				disableControllerItem(2,false);
			else
				disableControllerItem(2,true);
		}
	    document.getElementById("cbRemove").disabled = false;
	    
	    if (document.getElementById("cbRemove").checked == true) {
	    	ACTION_SELECTED = DEFAULTACTION_PREPARE_REMOVAL;
	    }
	}else if(thisObj.value == DEFAULTACTION_SHUTDOWN_REBOOT){
		for (var j in controllerRadios) {
			if (controllerRadios[j].connected && !controllerRadios[j].inservice) {
				disableControllerItem(j, false);
			} else {
				disableControllerItem(j, true);
			}
		}
		   			
	    if(CONTROLLER_OPTION_NUMBER == 3) {
	    	var allnormal = true;
	    	allnormal = allnormal && controllerRadios[0].connected && !controllerRadios[0].inservice;
	    	allnormal = allnormal && controllerRadios[1].connected && !controllerRadios[1].inservice;
	    	disableControllerItem(2, !allnormal);
		}
	    
	    document.getElementById("cbRemove").checked = false;
	} else if (thisObj.value == DEFAULTACTION_BRINGONLINE){
		for (var k in controllerRadios) {
			if (controllerRadios[k].connected && controllerRadios[k].inservice) {
				disableControllerItem(k, false);
			} else {
				disableControllerItem(k, true);
			}
		}
		
		//disable both controller option
	    if(CONTROLLER_OPTION_NUMBER == 3) {
			disableControllerItem(2, true);
		}
		
		document.getElementById("cbRemove").checked = false;
	}
	  // need to judge if can disable the ok button
		unCheckAllController();
		document.getElementById(namespace_g + "myForm:action_ok_btn").disabled = true;
}
function unCheckAllController(){
	var controllers = getControllerRadioGroups();
	for(var i=0;i<controllers.length;i++){
		if(controllers[i].checked){
			controllers[i].checked = false;
		}
	}
}
function selectController(thisObj){
	var controllers = getControllerRadioGroups();
	for(var i=0;i<controllers.length;i++){
		if(controllers[i].checked){
			document.getElementById(namespace_g + "myForm:selectedController").value=i+1;
			break;
		}
	}
	document.getElementById(namespace_g + "myForm:action_ok_btn").disabled = false;
}

function disableAllController(){
	var controllers = getControllerRadioGroups();
	for(var i=0;i<controllers.length;i++){
		controllers[i].disabled = true;
	}
}

function disableControllerItem(index,flag){
	var controllers = getControllerRadioGroups();
		if(index>=CONTROLLER_OPTION_NUMBER)
			return;
		controllers[index].disabled = flag;
	if(index<2 && !controllerRadios[index].connected){
		controllers[index].disabled = true;
	}
}
function getControllerRadioGroups(){
 var ary = new Array();
 var controllers = document.getElementsByName("controller");
   for(var i=0;i<CONTROLLER_OPTION_NUMBER;i++){
		ary[i]= controllers[i];
	}
   return ary;
}
function gotoFirmwareUpdating(){
	document.getElementById(namespace_g + "myForm:cancel_btn").click();
}

function ajaxComplete(){
	if("SUBMIT" == document.getElementById(namespace_g + "myForm:requestType").value){
		displayMainContents(true);
		pageInit();
	}else{
	    initErrorMessage();
		innerMessagesInstance.display();
		displayMainContents(true);
		pageInit();
		disableRefreshButton(false);
		setLastRefreshStamp();
	}
	parent.resizeFrameHeight('dynamicFrame', 'dynamicFrame');	
}

//this method can efficiently fix broswer regression defect.(the hx_5_0_8's bug in newer broswer)
//we append the data and use js code to retrieve after the ajax.
function configController(){
	var jsattrs = document.getElementsByName("jsattr");
	for(var i=0;i<jsattrs.length;++i){
		var jsattr = jsattrs[i];
		var identifier = jsattr.getAttribute("identifier");
		var connected = (jsattr.getAttribute("connected").toLowerCase()) === "true";
		var inservice = (jsattr.getAttribute("inservice").toLowerCase()) === "true";
		
		setNewController(new controllerObj(connected,inservice,identifier));
	}
}

//this page can't close itself.so we call the parent page to close it.
function onCanelBtnClick(){
	//closeParentPortlet
	parent.document.getElementById(parent.namespace_g + 'myForm:closeCurrentPage').click();
}
