/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// domain.js
var tab = null;
var prefixTab = namespace_g + "myForm:tabbedPanelProperties:";
var subTabCount = 0;

// called by customOnLoad(loadFunc) method
function onLoad_ViewAllDomain(){     
	var treeTable = rbce.gui.domains.TreeTable.getInstance();	 
	var menu = rbce.gui.domains.Menu.getInstance();
	treeTable.addValueChangeListener(menu.getValueChangeListener());
}

function clickLinkStatus(thisObj){
	var url = null;
	
	// obtain selected object type
	var parentTDObj = thisObj.parentNode;
	while(parentTDObj.tagName.toLowerCase() != "td"){
		parentTDObj = parentTDObj.parentNode;
	}
	
	var spanObjs = parentTDObj.getElementsByTagName("span");
	click(parentTDObj.parentNode.parentNode.parentNode);	  

	if( spanObjs && spanObjs.length > 1){
		var type = spanObjs[1].innerHTML;

		// redirect to different page
		if( type && type != ""){
			if( type == "bladeCenter"){
			    document.getElementById(namespace_g + "myForm:hiddenbuttonpage:BladeCenterAction_PhysicalView").click();
			}else if( type == "storageSystem"){
			    document.getElementById(namespace_g + "myForm:hiddenbuttonpage:ViewAllBladeCenter_ActiveAlerts").click();
			}else if( type == "sasSwitch"){	
			    document.getElementById(namespace_g + "myForm:hiddenbuttonpage:BladeCenterAction_PhysicalView").click();
			}
		}
	}	
}

function onLoad_AddSwitch(){
	initErrorMessage();	
	document.getElementById(namespace_g + "myForm:sasIPAddress").focus();
	SCMJsManager.getAttrManager().executeBinding();
}

function onLoad_RAIDSubsystem(){
	subTabCount = 3;
	
	document.getElementById("primarycontroller_iframe").src=document.global_context_path + "/faces/page/rbce/domain/PrimaryControllerProperties.jsp";
	if (document.getElementById("secondarycontroller_iframe")) {
		document.getElementById("secondarycontroller_iframe").src=document.global_context_path + "/faces/page/rbce/domain/SecondaryControllerProperties.jsp";
		subTabCount = 4;
	}
	document.getElementById("advanced_iframe").src=document.global_context_path + "/faces/page/rbce/domain/RAIDAdvanced.jsp";
	document.getElementById("product_tab").src=document.global_context_path + "/faces/page/rbce/domain/ProductNumbers.jsp";
	
	// initial error message
	initErrorMessage();
	parent.stopWait('util_dialog');
}

/*
 * show error message for muti tab
 */ 
var loadSubTabTime = 0;
function showErrorMessageDomain() {
    loadSubTabTime ++;
    if( loadSubTabTime == Number(subTabCount)){
        loadSubTabTime = 0;
    	innerMessagesInstance.display();
	}
}

function onLoad_SwitchModule(){		
	document.getElementById("switch_iframe").src=document.global_context_path + "/faces/page/rbce/domain/SASSwitchProperties.jsp";
	document.getElementById("a_switch_iframe").src=document.global_context_path + "/faces/page/rbce/domain/SwitchAdvanced.jsp";
	document.getElementById("product_iframe").src=document.global_context_path + "/faces/page/rbce/domain/SwitchProductNumbers.jsp";			
	
	// initial error message
	subTabCount = 3;
	initErrorMessage();
	parent.stopWait('util_dialog');
}

function onLoad_RemoveBladeCenter(){
	stopParentWait('util_dialog');	
}

function onLoad_RemoveSASSwitch(){
	stopParentWait('util_dialog');
}

function onLoad_SASSwitchProperties(){
	// Call the common function to send the ajax request
	commonPageLoad();
	parent.stopWait('util_dialog');
}

function onLoad_SwitchAdvanced(){
	// Call the common function to send the ajax request
	commonPageLoad();
	parent.stopWait('util_dialog');
}

function onLoad_SwitchProductNumbers(){
	// Call the common function to send the ajax request
	commonPageLoad();
	parent.stopWait('util_dialog');
}
// add by Ting Wei
function onLoad_PrimaryControllerProperties(){
	// Call the common function to send the ajax request
	commonPageLoad();
}
function onLoad_SecondaryControllerProperties(){
	// Call the common function to send the ajax request
	commonPageLoad();
}

function onLoad_RAIDAdvanced(){
	// Call the common function to send the ajax request
	commonPageLoad();
	parent.document.getElementById(parent.namespace_g + 'myForm:confirm_dialog_left').disabled = false;
	parent.document.getElementById(parent.namespace_g + 'myForm:confirm_dialog_right').disabled = false;
}
function onLoad_ProductNumbers(){
	// Call the common function to send the ajax request
	commonPageLoad();	
}

function onLoad_WizardAddSwitch() {
	if (parent) {
		parent.refreshNext();
	}
	var userAdmin = document.getElementById(namespace_g + "myForm:userAdminFlag").innerHTML;
	if(userAdmin != "true"){
		parent.document.getElementById(parent.namespace_g + "myForm:btnNext").disabled = true;
	}
	document.getElementById(namespace_g + "myForm:sasIPAddress").focus();
	document.getElementsByTagName("body")[0].className = "wizardFrameBody";	
	// initial error message	
	initErrorMessage();	
	
	
}

function onLoad_WizardAddSwitchWaiting() {
	setTimeout(forwardToNextPage , 5);
	// initial error message	
	initErrorMessage();	
}

function onLoad_LocateHardware() {
	//parent.stopWait('util_dialog');
	stopWaitLocateDialog();
	parent.adjustLocateIEFrame();
	
	var state = document.getElementById(namespace_g + "myForm:locateStatus").innerHTML;
	if(state!="true"){
		document.getElementById(namespace_g + "myForm:close_Button_btn").value=document.getElementById(namespace_g + "myForm:CloseBtnLabel").innerHTML;
	}
	// initial error message	
	initErrorMessage();
	
	if ("SASSwitch" == parent.document.getElementById(namespace_g + "myForm:hiddenbuttonpage:selectedType").value) {
		document.getElementById(namespace_g + "myForm:vabc_locateDesc_11_sas").style.display = "";
	} else if ("StorageSystem" == parent.document.getElementById(namespace_g + "myForm:hiddenbuttonpage:selectedType").value) {
		document.getElementById(namespace_g + "myForm:vabc_locateDesc_11_raid").style.display = "";
	}
}


// locate off button
function checkLocateOnFailed(){
	var state = document.getElementById(namespace_g + "myForm:locateStatus").innerHTML;
	if(state!="true"){
	    // if locate on failed, try to close the dialog
		parent.document.getElementById(parent.namespace_g + 'myForm:locate_dialog_cloer').click();
	}else{
	   // if locate on succeed, try to send a ajax request to locate off
	  	document.getElementById(namespace_g + "myForm:close_Button_btn").disabled = true;
		document.getElementById("content_table").style.display = "none";
		document.getElementById("indicator_table").style.display = "";
		document.getElementById(namespace_g + "myForm:close_Button").click();
	}
}
function checkLocateOffFailed(){
	var state = document.getElementById(namespace_g + "myForm:locateStatus").innerHTML;
	if(state!="true"){
	    // if stop failed, do not close dialog, show error message to user
		document.getElementById(namespace_g + "myForm:close_Button_btn").disabled = false;
		document.getElementById("content_table").style.display = "";
		document.getElementById("indicator_table").style.display = "none";
		document.getElementById(namespace_g + "myForm:close_Button_btn").value=document.getElementById(namespace_g + "myForm:CloseBtnLabel").innerHTML;
	}else{
	  // if stop succeed, close dialog
		parent.document.getElementById(parent.namespace_g + 'myForm:locate_dialog_cloer').click();	
	}
}

function onLocateError() {
	document.getElementById(namespace_g + "myForm:close_Button_btn").disabled = false;
	document.getElementById("content_table").style.display = "";
	document.getElementById("indicator_table").style.display = "none";
}

function forwardToNextPage() {
	document.getElementById(namespace_g + "myForm:nextButton").click();
}


function showDialog(dialogName, clickEvent){
	var dialog = hX_5.getComponentById(dialogName);	
	if(dialog != null && clickEvent != null){
		dialog.show(clickEvent)
		dialog.redraw();
	}		
}

function closeDialog(dialogName, clickEvent){
	var	dialog = hX_5.getComponentById(dialogName);
	if(dialog != null && clickEvent != null){
		dialog.redraw();
		dialog.hide(clickEvent)
	}		
}

// set form target to a ralative 'top'
function setFormTarget2Top(submitForm){

	if(self!=top && (self.name=="mainFrame" || (self.parent && self.parent.name=="mainFrame") || (self.parent.parent && self.parent.parent.name=="mainFrame"))){
		submitForm.target="mainFrame";				
	}	
	else if(self!=top && (self.name=="basefrm" || (self.parent && self.parent.name=="basefrm") || (self.parent.parent && self.parent.parent.name=="basefrm"))){
		submitForm.target="basefrm";				
	}
	else {
		submitForm.target="_top";
	}
}

function setDomainFormTarget(thisEvent, targetName, width, height){
	var dialogObj;
	var iframeObj;
	cachedClickEvent = thisEvent;
					
	if( targetName == 'template_utility'){
	
	    if( document.getElementById('templ_waitDiv_utility')){
	   	    dialogObj = document.getElementById(namespace_g + "myForm:util_subview:util_dialog");
	   	    iframeObj = document.getElementById("templ_u_iframe");
		}else if( parent.document.getElementById('templ_waitDiv_utility')){
	   		dialogObj = parent.document.getElementById(parent.namespace_g + "myForm:util_subview:util_dialog");
	   		iframeObj = parent.document.getElementById("templ_u_iframe");
		}
   
	   	if( iframeObj.src != ''){
		   	iframeObj.src = '';
		}
		   
		if(width == null){	
			var width  = document.body.offsetWidth*0.80; //set a better pop-up width 
			dialogObj.style.width = width;
		}
		
		if(height == null){
			var height  = window.outerHeight*0.75; //set a better pop-up width 
			dialogObj.style.height = height;
	    }
		
		if(width != null){
			dialogObj.style.width = width;
			iframeObj.style.width = width * 0.95;				
		}
		
		if(height != null){
			dialogObj.style.height = height;
			iframeObj.style.height = height * 0.85;
		} 
	
	    document.getElementById(namespace_g + "myForm").target="templ_u_iframe";					
	}
	else{
		document.getElementById(namespace_g + "myForm").target="";
	}
	
	return true;
}


function stopParentWait(dialogId){		
	if(dialogId == 'util_dialog'){
	   if(document.getElementById('templ_waitDiv_utility')){
			document.getElementById('templ_waitDiv_utility').style.display = "none";
			document.getElementById('templ_u_iframe_div').style.visibility= "visible";
			
	   }else if(parent.document.getElementById('templ_waitDiv_utility')){
			parent.document.getElementById('templ_waitDiv_utility').style.display = "none";		
			parent.document.getElementById('templ_u_iframe_div').style.visibility= "visible";			
	   }
	}	
}


//clear the iframe src when closing the pannelDialog
function clearFrame(){
	var iframeObj;
	var iframeDIVObj;
	
	if( document.getElementById('templ_u_iframe')){
		iframeObj = document.getElementById("templ_u_iframe");
	   	iframeDIVObj = document.getElementById("templ_u_iframe_div");
	}else if( parent.document.getElementById('templ_u_iframe')){
		iframeObj = parent.document.getElementById("templ_u_iframe");
	   	iframeDIVObj = parent.document.getElementById("templ_u_iframe_div");
	}

	iframeObj.src = '';	
	document.getElementById(namespace_g + "myForm").target="";
}

function disableDialogButton(dialogname){	 
	if(dialogname == 'util_dialog'){ 	 
	   document.getElementById(namespace_g + "myForm:ok_Button").disabled = true;	  	   
	   document.getElementById(namespace_g + "myForm:cancel_Button").disabled = true;		
	   document.getElementById(namespace_g + "myForm:ok_Submit").click();	
	}			
	return true;	
}

// Properties JS Begin
// get the child iframe from parent iframe
function getFrame(iframeName){
    return eval("self." + iframeName);
}

function initRAIDAdvanced(){
	var mode = document.getElementById(namespace_g + "myForm:writeCacheMode_value").value;
	var writeCacheRadios = document.getElementsByName("writeCacheMode");
	if( mode == "0"){
	    writeCacheRadios[1].checked = true;
	}else if( mode == "1"){
		writeCacheRadios[0].checked = true;
	}
}

/**
 * Get the cache mode value and show the confirmation dialog
 *
 */
function doModifyCacheMode(){
    var radios = document.getElementsByName("writeCacheMode");
    for( var i=0;i<radios.length;i++){
   	     if( radios[i].checked){
   	        document.getElementById(namespace_g + "myForm:writeCacheMode_value").value = radios[i].value;
   	   }
    }
   
    var cacheMode = document.getElementById(namespace_g + "myForm:writeCacheMode_value").value;   
   	if(cacheMode == '1'){
		parent.document.getElementById("raidCacheReset").innerHTML = document.getElementById(namespace_g + 'myForm:RAIDAdvanced_Confirm_Enabled').innerHTML;
	}else{
		parent.document.getElementById("raidCacheReset").innerHTML = document.getElementById(namespace_g + 'myForm:RAIDAdvanced_Confirm_Disabled').innerHTML;
	}
    parent.document.getElementById(parent.namespace_g + 'myForm:confirm_Button').click();
}

/**
 * Submit the action of modifying the cache mode
 *
 */
function doOK_controller_Button(){
	var advanced_iframe = getFrame('advanced_iframe');
	advanced_iframe.document.getElementById(namespace_g + "myForm:modify_Button").disabled = true;
	advanced_iframe.document.getElementById(namespace_g + 'myForm:raid_advanced_Edit').click();
}

function validateIP(ip){
	var ipexpr = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;

  	if (!ipexpr.test(ip)) {
  		return false;
  	}
  	
  	var iparray = ip.match(ipexpr);
  	
  	if (iparray != null) {
			for (var i=1; i<5; i++) {
				var octet = iparray[i];
				if ((i == 1) || (i == 4)) {
					if ((octet <= 0) || (octet > 254)) {						
						return false;
					}
				}
				else {
					if (octet > 255 || octet < 0) {						
						return false;
					}	
				}
			}
	}
	 
  	return true;
}

function disableConfirmButtons(flag){
	document.getElementById(namespace_g + "myForm:confirm_dialog_left").disabled = flag;
	document.getElementById(namespace_g + "myForm:confirm_dialog_right").disabled = flag;
}

// Properties JS End 


var selectedObjectID = null;

// AddSwitch JS Begin 
function setPort(){ 
	var Letters = "1234567890";
	var adminobj = document.getElementById(namespace_g + "myForm:adminPort");
	var eventobj = document.getElementById(namespace_g + "myForm:advancedPort");
	var firmwareobj = document.getElementById(namespace_g + "myForm:firmwareDownloadPort");
	var portvalue = adminobj.value;
	var i; 
	var c; 
	for( i = 0; i < portvalue.length; i ++ ) 
	{ 
		c = portvalue.charAt( i ); 
		if (Letters.indexOf( c ) ==-1) 
		{ 
			adminobj.value = "";
			eventobj.value = "";
  			firmwareobj.value = "";	
			return;
		} 
	} 
	if( portvalue != ""){	
		eventobj.value = parseInt(adminobj.value)+1;
  		firmwareobj.value = parseInt(adminobj.value)+2;
  	}else{
  	    eventobj.value = "";
  		firmwareobj.value = "";	
  	}
} 

function setRAIDIPAddress(obj,event){
	var ipValid = true;
	var ip_format_error_div = document.getElementById("ip_format_error_div");
	if(ip_format_error_div){
		ip_format_error_div.style.display = 'none';
	}

	var nextInd = document.getElementById(namespace_g + "myForm:isNext");
	
  	var ipexpr = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
  	var sasipobj = document.getElementById(namespace_g + "myForm:sasIPAddress");
  	if (!ipexpr.test(sasipobj.value)) {
  		if(nextInd){
  			nextInd.value = "false";
  			if (parent) {
				parent.refreshNext();
			}	
		}
  		if(event && event.type == "blur"){
  			if(ip_format_error_div){
  				document.getElementById("ip_format_error_div").style.display = 'block';
  			}
  		}
  		ipValid = false;
  	}else{
  		var IPArray = sasipobj.value.match(ipexpr);
  		if (IPArray != null) {
			for (var i=1; i<5; i++) {
				var segment = IPArray[i];
				if (segment > 255) {
					if(nextInd){
						nextInd.value = "false";
  						if (parent) {
							parent.refreshNext();
						}
						ipValid =false;
					}	
					if(event && event.type == "blur"){
						if(ip_format_error_div){
							document.getElementById("ip_format_error_div").style.display = 'block';	
							ipValid =false;
						}	
					}				
				}	
			}
		}
  	}
  	
  	var nextable = addSwitch_checkInputfield();
  	if(nextInd){  	
  		if(nextable && ipValid){
  			nextInd.value = "true";
  			document.getElementById(namespace_g + "myForm:addSwitchValidationMsg").style.display="none";
  		}else{
  			nextInd.value = "false";
  			document.getElementById(namespace_g + "myForm:addSwitchValidationMsg").style.display="";
  		}
  		if(parent) {
			parent.refreshNext();
		}
	}else{
		if(nextable && ipValid){
			document.getElementById(namespace_g + "myForm:ok_Submit").disabled = false;
			document.getElementById(namespace_g + "myForm:addSwitchValidationMsg").style.display="none";
		}else{
			document.getElementById(namespace_g + "myForm:ok_Submit").disabled = true;
			document.getElementById(namespace_g + "myForm:addSwitchValidationMsg").style.display="";
		}
	}
	if(!ipValid){
		document.getElementById("ip_format_error_div").style.display = '';		
	}
}

function addSwitch_checkInputfield(){
	var saspassword = document.getElementById(namespace_g + "myForm:sasPassword").value.trim().length;
	var raidpassword = document.getElementById(namespace_g + "myForm:raidPassword").value.trim().length;
	var modulename = document.getElementById(namespace_g + "myForm:switchNickName").value.trim().length;
	var total = saspassword*raidpassword*modulename;
	
	if(total==0 || !isDeviceNameValid(document.getElementById(namespace_g + "myForm:switchNickName").value.trim())){
		return false;
	}else{
		return true;
	}
}

function AddSwitchValidation(){
		//var fileds = new Array(namespace_g + "myForm:sasIPAddress",namespace_g + "myForm:sasUserID",namespace_g + "myForm:sasPassword",namespace_g + "myForm:raidPassword",namespace_g + "myForm:switchNickName");
		var errorMsgs = new Array("addSwitchSASIPTR",
								  "addSwitchSASValidationTR",
								  "addSwitchRAIDValidationTR",
								  namespace_g + "myForm:addSwitchSASUserIDMsg",
								  namespace_g + "myForm:addSwitchSASPasswordMsg",
								  namespace_g + "myForm:addSwitchRAIDPasswordMsg",
								  "addSwitchNameTR");
		var userinputs = new Array(namespace_g + "myForm:sasIPAddress",namespace_g + "myForm:sasUserID",namespace_g + "myForm:sasPassword",namespace_g + "myForm:raidPassword",namespace_g + "myForm:switchNickName");
		//refresh next button in wizard
		this.refreshNextButton = function(){
		    if(document.getElementById(namespace_g + "myForm:isNext")!=null) {
			    parent.refreshNext();
			}			
		}
		
		
		this.checkFields = function() {
            this.diableErrorMsgs();
			var nextInd = document.getElementById(namespace_g + "myForm:isNext");
			
		  	var sasIp = document.getElementById(namespace_g + "myForm:sasIPAddress").value;
		  	if(isIPValidate(sasIp)){
		  		document.getElementById("addSwitchSASIPTR").style.display = 'none';  	
		  	}else{
				this.diableErrorMsgs();
		  		document.getElementById("addSwitchSASIPTR").style.display = '';  
		        this.refreshNextButton();	  		    
		  		document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
		  		return false;	  	
		  	}
		  	
			var modulename = document.getElementById(namespace_g + "myForm:switchNickName").value;			
			if(modulename.trim().length > 0 && !isDeviceNameValid(modulename)){
					this.diableErrorMsgs();
					document.getElementById("addSwitchNameTR").style.display="";
		        this.refreshNextButton();	  		    
		  		document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
				return false;
			}else{
				document.getElementById("addSwitchNameTR").style.display="none";	
			}
		  			  	
			var sasuseridobj = document.getElementById(namespace_g + "myForm:sasUserID");
			if (sasuseridobj.value.trim().length==0) {
  			    this.diableErrorMsgs();
				document.getElementById("addSwitchSASValidationTR").style.display = "";
				document.getElementById(namespace_g + "myForm:addSwitchSASUserIDMsg").style.display = "";
		        this.refreshNextButton();	  		    
		        document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();		    
				return false;
			}else{
				document.getElementById(namespace_g + "myForm:addSwitchSASUserIDMsg").style.display = "none";
			}
			
			var saspwdobj = document.getElementById(namespace_g + "myForm:sasPassword");
			if (saspwdobj.value.trim().length==0) {
				this.diableErrorMsgs();
				document.getElementById("addSwitchSASValidationTR").style.display = "";
				document.getElementById(namespace_g + "myForm:addSwitchSASPasswordMsg").style.display = "";
		        this.refreshNextButton();	  		    
		  		document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
				return false;
			}else{
				document.getElementById(namespace_g + "myForm:addSwitchSASPasswordMsg").style.display = "none";
			}
			
			var raidpwdobj = document.getElementById(namespace_g + "myForm:raidPassword");
			if (raidpwdobj.value.trim().length==0) {
				this.diableErrorMsgs();
				document.getElementById("addSwitchRAIDValidationTR").style.display = "";
				document.getElementById(namespace_g + "myForm:addSwitchRAIDPasswordMsg").style.display = "";
		        this.refreshNextButton();	  		    
		  		document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
				return false;
			}else{
				document.getElementById(namespace_g + "myForm:addSwitchRAIDPasswordMsg").style.display = "none";
			}
			//this method used be standalone and wizard (Add Switch), if nextInd existed, show it's invoked from wizard
			if(!nextInd){
				document.getElementById(namespace_g + "myForm:submit_Button").click(); //Implement the Ok Button
				document.getElementById(namespace_g + "myForm:ok_Submit").disabled = true;
				document.getElementById(namespace_g + "myForm:cancel_Button").disabled = true;
			}
			return true;
		}
		this.checkWizardButtonEnable = function(){
			if(this.checkWizardFieldsKeyup()){
				var nextInd = document.getElementById(namespace_g + "myForm:isNext");
				if(nextInd){
					nextInd.value = "true";
				
					if(parent) {
						parent.refreshNext();
					}
				}
			}else{
				var nextInd = document.getElementById(namespace_g + "myForm:isNext");
				if(nextInd){
					nextInd.value = "false";
				
					if(parent) {
						parent.refreshNext();
					}
				}
			}
		}
		this.checkWizardFieldsKeyup = function() {
			//it's not friendly that we show error message for keyup event
		  	var sasIp = document.getElementById(namespace_g + "myForm:sasIPAddress").value;
			var sasuseridobj = document.getElementById(namespace_g + "myForm:sasUserID");
			var saspwdobj = document.getElementById(namespace_g + "myForm:sasPassword");
			var raidpwdobj = document.getElementById(namespace_g + "myForm:raidPassword");
			var modulename = document.getElementById(namespace_g + "myForm:switchNickName").value;			
		  	if(!isIPValidate(sasIp) || (sasuseridobj.value.trim().length==0) || (saspwdobj.value.trim().length==0) ||
		  		(raidpwdobj.value.trim().length==0) || (modulename.trim().length > 0 && !isDeviceNameValid(modulename))){
		  		return false;
		  	}else{
		  		return true;	  	
		  	}
		}
		this.nextStep = function(){
		    if(this.checkWizardFieldsKeyup()){
			    document.getElementById(namespace_g + "myForm:submit_Button").click();	
			}    		
		}
		
		this.diableErrorMsgs = function(){
			for(var i=0;i<errorMsgs.length;i++){
				document.getElementById(errorMsgs[i]).style.display="none";
			}
		}
}

function CheckFields() {
//	setPort();
	setRAIDIPAddress();
	
	var errormsgobj = document.getElementById(namespace_g + "myForm:ErrorText"); // Implement the panelDialog msg id into it.

	var errorbtn = document.getElementById(namespace_g + "myForm:errorMessage_Button"); // Implement the button should be clicked when error occur.
	var ipobj = document.getElementById(namespace_g + "myForm:sasIPAddress");
	if (ipobj.value.trim().length==0) {
		errormsgobj.innerHTML = document.getElementById(namespace_g + "myForm:IPformatErrorMessage").innerHTML; // Implement the IP message outputText
		errorbtn.click();
		return;
	}
	
	var sasuseridobj = document.getElementById(namespace_g + "myForm:sasUserID");
	if (sasuseridobj.value.trim().length==0) {
		errormsgobj.innerHTML = document.getElementById(namespace_g + "myForm:SASUserIDErrorMessage").innerHTML; // Implement the User ID messsage outputText
		errorbtn.click();
		return;
	}
	var raiduseridobj = document.getElementById(namespace_g + "myForm:raidUserID");
	if (raiduseridobj.value.trim().length==0) {
		errormsgobj.innerHTML = document.getElementById(namespace_g + "myForm:RaidUserIDErrorMessage").innerHTML; // Implement the User ID messsage outputText
		errorbtn.click();
		return;
	}
	var saspwdobj = document.getElementById(namespace_g + "myForm:sasPassword");
	if (saspwdobj.value.trim().length==0) {
		errormsgobj.innerHTML = document.getElementById(namespace_g + "myForm:PasswordErrorMessage").innerHTML; // Implement the Password ID message outputText
		errorbtn.click();
		return;
	}
	var raidpwdobj = document.getElementById(namespace_g + "myForm:raidPassword");
	if (raidpwdobj.value.trim().length==0) {
		errormsgobj.innerHTML = document.getElementById(namespace_g + "myForm:PasswordErrorMessage").innerHTML; // Implement the Password ID message outputText
		errorbtn.click();
		return;
	}
	
/*	var adminobj = document.getElementById(namespace_g + "myForm:adminPort");
	if (adminobj.value.trim().length==0) {
		errormsgobj.innerHTML = document.getElementById(namespace_g + "myForm:PortErrorMessage").innerHTML; // Implement the Port Message outputText
		errorbtn.click();
		return;
	}*/
	
	document.getElementById(namespace_g + "myForm:submit_Button").click(); //Implement the Ok Button
}
var block_multi_click = false;
function ClickCancel()
{
	if (block_multi_click == false) {
		block_multi_click = true;
		document.getElementById(namespace_g + "myForm:cancel_Submit").click(); //Implement the cancel Button
	}
}

String.prototype.trim = function () {
    return this.replace(/^\s*/, "").replace(/\s*$/, "");
}


// AddSwitch JS End 

/*
 * Get the elements in the document by tag and the name
 * tag: the tag name of finding elments
 * name: the name of finding elements
 * @Note add this function as IE can not correctly support getElementsByName().
 */
function getElementsByTagAndName(tag,name){
	var elem = document.getElementsByTagName(tag);
	var arr = new Array();
	for( i = 0,iarr = 0; i < elem.length; i++){			
		 att = elem[i].getAttribute("name");
		 if( att == name){
		     arr[iarr++] = elem[i];
		 }
	}
	return arr;
}

function obtainRemoveTableTitle(){
	var title;
	var bladeCenterName = "";
	var firstSwitch = "";
	var secondSwitch = "";
	var IOBay3= "3";
	var IOBay4= "4";
	var sasType = document.getElementById(namespace_g + "myForm:ViewAllBladeCenter_SASModuleType").innerHTML;

	if( selectedGroupID != null){
		var ary = map[selectedGroupID];
		for( var k=0; k < ary.length; k++){
		 	 var obj = ary[k];	 	 
		 	 bladeCenterName = obj.bladeCenterName;

		 	if( obj.type == sasType){
		 		if( obj.location == IOBay3){
		 			firstSwitch = obj.name;
		 		}else if( obj.location == IOBay4){
		 			secondSwitch = obj.name;
		 		}		 	    
		 	}
		 } 	
		 
		 if(firstSwitch == "" || secondSwitch == ""){
		 	title = firstSwitch + secondSwitch;
		 }else{
		 	title = firstSwitch + ", " + secondSwitch;
		 }
		 
		 title = document.getElementById(namespace_g + "myForm:ViewAllBladeCenter_BladeCenterTitle").innerHTML + document.getElementById(namespace_g + "myForm:ViewAllBladeCenter_BladeCenterType").innerHTML + " - " + bladeCenterName + " (" + title + ")";
		 
	}
	
	return title;
}

function onLoad_RetryConnection(){
	initErrorMessage();
	parent.stopWait('util_dialog');	
}

function checkReConnectInputs(){
    
    if (document.getElementById(namespace_g + "myForm:selectedType").value == "SASSwitch") {
        var ipObj = document.getElementById(namespace_g + "myForm:SASIP");
        if (!isIPValidate(ipObj.value)) {
            document.getElementById(namespace_g + "myForm:SASIPErrorMessage").style.display = "block";
            document.getElementById(namespace_g + "myForm:SASUserIDErrorMessage").style.display = "none";
            document.getElementById(namespace_g + "myForm:SASPasswordErrorMessage").style.display = "none";
            return false;
        }
        var sasUserNameObj = document.getElementById(namespace_g + "myForm:sasUserid");
        if (null == sasUserNameObj || null == sasUserNameObj.value || 0 == sasUserNameObj.value.trim().length) {
            document.getElementById(namespace_g + "myForm:SASIPErrorMessage").style.display = "none";
            document.getElementById(namespace_g + "myForm:SASUserIDErrorMessage").style.display = "block";
            document.getElementById(namespace_g + "myForm:SASPasswordErrorMessage").style.display = "none";
            return false;
        }
        var pwdObj = document.getElementById(namespace_g + "myForm:SASPassword");
        if (null == pwdObj || null == pwdObj.value || 0 == pwdObj.value.trim().length) {
            document.getElementById(namespace_g + "myForm:SASIPErrorMessage").style.display = "none";
            document.getElementById(namespace_g + "myForm:SASUserIDErrorMessage").style.display = "none";
            document.getElementById(namespace_g + "myForm:SASPasswordErrorMessage").style.display = "block";
            return false;
        }
		document.getElementById(namespace_g + "myForm:SASIPErrorMessage").style.display = "none";
        document.getElementById(namespace_g + "myForm:SASUserIDErrorMessage").style.display = "none";
        document.getElementById(namespace_g + "myForm:SASPasswordErrorMessage").style.display = "none";
    }else if(document.getElementById(namespace_g + "myForm:selectedType").value == "StorageSystem"){
		var firstIPobj = document.getElementById(namespace_g + "myForm:raidIP1");
		if(!isIPValidate(firstIPobj.value)){
			document.getElementById(namespace_g + "myForm:radiIP1ErrorMessage").style.display = "block";
			document.getElementById(namespace_g + "myForm:radiIP2ErrorMessage").style.display = "none";
			document.getElementById(namespace_g + "myForm:raidPasswordErrorMessage").style.display = "none";
			return false;
		}
		var secIPobj = document.getElementById(namespace_g + "myForm:raidIP2");
		if(!isIPValidate(secIPobj.value)){
			document.getElementById(namespace_g + "myForm:radiIP1ErrorMessage").style.display = "none";
			document.getElementById(namespace_g + "myForm:radiIP2ErrorMessage").style.display = "block";
			document.getElementById(namespace_g + "myForm:raidPasswordErrorMessage").style.display = "none";
			return false;
		}
		var pwdObj = document.getElementById(namespace_g + "myForm:raidPassword");
        if (null == pwdObj || null == pwdObj.value || 0 == pwdObj.value.trim().length) {
            document.getElementById(namespace_g + "myForm:radiIP1ErrorMessage").style.display = "none";
			document.getElementById(namespace_g + "myForm:radiIP2ErrorMessage").style.display = "none";
			document.getElementById(namespace_g + "myForm:raidPasswordErrorMessage").style.display = "block";
            return false;
        }
		document.getElementById(namespace_g + "myForm:radiIP1ErrorMessage").style.display = "none";
		document.getElementById(namespace_g + "myForm:radiIP2ErrorMessage").style.display = "none";
		document.getElementById(namespace_g + "myForm:raidPasswordErrorMessage").style.display = "none";
	}
	document.getElementById(namespace_g + "myForm:button_submit_ajaxCall").click();
	return true;
}

function retryStart(){
	disableRetryButtons(true);
	if (document.getElementById(namespace_g + "myForm:selectedType").value == "SASSwitch") {
		document.getElementById("progress_div").style.height= 145;
	}else {
		document.getElementById("progress_div").style.height= 195;
	}
	document.getElementById("request_div").style.display = "none";
	document.getElementById("progress_div").style.display = "block";
}

function retryFinished(){
	disableRetryButtons(false);
	if("true" != document.getElementById(namespace_g + "myForm:isErrorOccured").innerHTML){
		parent.document.getElementById(namespace_g + 'myForm:dialog_closer').click();
		parent.document.getElementById(namespace_g + 'myForm:refreshBtn').click();
	}
	document.getElementById("request_div").style.display = "block";
	document.getElementById("progress_div").style.display = "none";
}

function disableRetryButtons(flag){
	if(flag){
		document.getElementById(namespace_g + "myForm:button_submit").disabled = true;
		document.getElementById(namespace_g + "myForm:cancel_button").disabled = true;
	}else{
		document.getElementById(namespace_g + "myForm:button_submit").disabled = false;
		document.getElementById(namespace_g + "myForm:cancel_button").disabled = false;
	}
}

function stopWaitLocateDialog() {
	if (parent.document.getElementById('locatedlg_waiting_table')) {
		parent.document.getElementById('locatedlg_waiting_table').style.display = "none";
		parent.document.getElementById('locate_panel_div').style.visibility = "visible";
   }
}

function adjustLocateDialogSize(varwidth , varheight) {
	var clientWidth = 0;
	var clientHeight = 0;
	
	var marginWidth = document.getElementById("locate_frame").marginWidth;
	var marginHeight = document.getElementById("locate_frame").marginHeight;
	
	var titleHeight = 18;
	var borderWidth = 2;
	
	if(typeof varwidth == "undefined" || varwidth == null || varwidth == ""){	
		clientWidth  = document.body.offsetWidth*0.80; //set a better pop-up width 
		document.getElementById(namespace_g + "myForm:locateHardware_Dialog").style.width = clientWidth;
	} else {
		clientWidth = varwidth;
		document.getElementById(namespace_g + "myForm:locateHardware_Dialog").style.width = (clientWidth + 2 * marginWidth + 2 * borderWidth);
		document.getElementById("locate_frame").style.width = (clientWidth + 2 * marginWidth);
	}
	
	if(typeof varheight == "undefined" || varheight == null || varheight == ""){
		clientHeight  = window.outerHeight*0.75; //set a better pop-up width 
		document.getElementById(namespace_g + "myForm:locateHardware_Dialog").style.height = clientHeight;
	} else {
		clientHeight = varheight;
		document.getElementById(namespace_g + "myForm:locateHardware_Dialog").style.height = (clientHeight + 2 * marginHeight + titleHeight + 2 * borderWidth);
		document.getElementById("locate_frame").style.height = (clientHeight + 2 * marginHeight);
	}
}

function setLocateUtilDialogTitle(titleString){
	document.getElementById(namespace_g + "myForm:locateHardware_Dialog_tb").lastChild.nodeValue = titleString;
	document.getElementById("locate_frame").title = titleString;
}

function adjustLocateIEFrame() {
	if (document.getElementById(namespace_g + "myForm:locateHardware_Dialog_if")) {
		var additionIFrame = document.getElementById(namespace_g + "myForm:locateHardware_Dialog_if");
		additionIFrame.style.height = document.getElementById("locate_frame").style.height;
	}
}
