/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// PhysicalLocate.js

var requestObject;

var locateWaitDivId;
var locateCloseDivId;
var closeModalButtonId;
var stopLocatingButtonId;
function startLocate(waitDivId, closeDivId, closeButtonId,stopBtnId)
{
	// Set up the variables
	locateWaitDivId = waitDivId;
	locateCloseDivId = closeDivId;
	closeModalButtonId = closeButtonId;
	stopLocatingButtonId = stopBtnId;
	
	// Show the wait DIV and hide the close DIV
	document.getElementById(locateWaitDivId).style.display = "block";
	document.getElementById(locateCloseDivId).style.display = "none";
	document.getElementById(namespace_g + stopLocatingButtonId).disabled = true;
	
	// Initiate AJAX
	requestObject = makeHttpRequestObject();

	requestObject.open("GET", document.global_context_path + "/faces/PhysicalLocateServlet?action=start&id=" + currentComponentId, true);
	
	requestObject.onreadystatechange = startLocateCallback;
		
	requestObject.send(null);
}

function stopLocate()
{
	// Show the wait DIV and hide the close DIV
	document.getElementById(locateWaitDivId).style.display = "block";
	document.getElementById(locateCloseDivId).style.display = "none";
	
	// Initiate AJAX
	requestObject = makeHttpRequestObject();

	requestObject.open("GET", document.global_context_path + "/faces/PhysicalLocateServlet?action=stop&id=" + currentComponentId, true);
	
	requestObject.onreadystatechange = stopLocateCallback;
		
	requestObject.send(null);
	document.getElementById(namespace_g + stopLocatingButtonId).disabled = true;
}

function startLocateCallback()
{
	if(requestObject.readyState == 4)
	{
		// The request is complete
		
		// Stop the loading message and show the close command
		var ret = requestObject.responseText;
		if(ret=="false"){
			document.getElementById(namespace_g + closeModalButtonId).click();
		}else{
			document.getElementById(namespace_g + stopLocatingButtonId).disabled = false;
		document.getElementById(locateWaitDivId).style.display = "none";
		document.getElementById(locateCloseDivId).style.display = "block";
		}
		innerMessagesInstance.display();
	}
}

function stopLocateCallback()
{
	if(requestObject.readyState == 4)
	{
		// The request is complete
		var ret = requestObject.responseText;
		innerMessagesInstance.display();
		// Hide the modal
		document.getElementById(namespace_g + closeModalButtonId).click();
	}
}

function makeHttpRequestObject() 
{
	var xmlreq = false;

	if (window.XMLHttpRequest) 
	{
    	// Create XMLHttpRequest object in non-Microsoft browsers
    	xmlreq = new XMLHttpRequest();
	}
	else if (window.ActiveXObject) 
			{			
			    // Create XMLHttpRequest via MS ActiveX
		      	xmlreq = new ActiveXObject("Microsoft.XMLHTTP");
		  	}
  	
	return xmlreq;
}
