/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// PhysicalResources.js

var PHYSICAL_RESOURCES_PAGE = current_context + "/faces/page/rbce/physical/PhysicalResources.jsp";
var DISK_PAGE = current_context + "/faces/page/rbce/physical/DiskInformationFrame.jsp";
var STORAGE_MODULE_PAGE = current_context + "/faces/page/rbce/physical/StorageModuleInformationFrame.jsp";
var CONTROLLER_PAGE = current_context + "/faces/page/rbce/physical/ControllerInformationFrame.jsp";
var SWITCH_PAGE = current_context + "/faces/page/rbce/physical/SwitchInformationFrame.jsp";
var BBU_PAGE = current_context + "/faces/page/rbce/physical/BBUInformationFrame.jsp";

var NOT_USABLE_DISK_TYPE = 0;
var UNCONFIGURED_DISK_TYPE = 1;
var CONFIGURED_DISK_TYPE = 2;
var DEDICATEDSPARE_DISK_TYPE = 3;
var GLOBALSPARE_DISK_TYPE = 4;
var STORAGE_MODULE_TYPE = 5;
var CONTROLLER_TYPE = 6;
var SWITCH_TYPE = 7;
var BBU_TYPE = 8;

var isCurrentDiskRoaming;

// A variable to keep track of what is shown in the information area
var stillShowingInitialMessage = true;

// A variable that holds the current displayed menu ID
var currentMenuDivId = "defaultMenuDIV";

// A variable that holds the current loading menu ID
var currentLoadingMenuDivId;

// Current resource ID
var currentComponentId;

//////////////////////////////////////// PHYSICAL VIEW SHELL /////////////////////////////////////////////
function initializeShell()
{
	resizeFrameHeight('staticLoadingFrame', 'staticLoadingFrame'); 
	resizeFrameWidth('staticLoadingFrame', 'staticLoadingFrame');
}

function startShellLoading()
{
	parent.document.getElementById('staticLoadingDiv').style.display='block'; 
	parent.document.getElementById('dynamicDiv').style.visibility='hidden';
	
	// Make the dynamic frame very small
	parent.document.getElementById('dynamicFrame').style.width = "1px";
	parent.document.getElementById('dynamicFrame').style.height = "1px";

	parent.resizeFrameHeight('staticLoadingFrame', 'staticLoadingFrame'); 
	parent.resizeFrameWidth('staticLoadingFrame', 'staticLoadingFrame');
	
	document.getElementById(namespace_g + 'lastRefreshTimestamp').innerHTML = document.getElementById(namespace_g + "hiddenNLSRefreshingData").value;
}

function stopShellLoading()
{
	parent.document.getElementById('staticLoadingDiv').style.display='none'; 
	parent.document.getElementById('dynamicDiv').style.visibility='visible';
	
	parent.resizeFrameWidth("dynamicFrame", "dynamicFrame");
	parent.resizeFrameHeight("dynamicFrame", "dynamicFrame");
}

function refresh()
{
	startShellLoading();
	clearAllInnMessages();
	parent.document.getElementById('dynamicFrame').src = PHYSICAL_RESOURCES_PAGE;
}

//////////////////////////////////////// PHYSICAL VIEW SPECIFIC /////////////////////////////////////////////
var selectedPhysicalCellObject;
var selectedLogicalCellObject;

function overlapTables()
{
	// Browser specific offsets
	var topOffset = 0;
	var leftOffset = 0;
	if(navigator.appName == 'Microsoft Internet Explorer')
	{
		topOffset = 2;
		leftOffset = 1;
	}
	
	// FRONT VIEW
	frontY = getAbsoulteY(document.getElementById("frontBottomTable")) + topOffset;
	frontX = getAbsoulteX(document.getElementById("frontBottomTable")) + leftOffset;
	
	document.getElementById("frontMiddleTable").style.top = frontY;
	document.getElementById("frontMiddleTable").style.left = frontX;
	
	document.getElementById("frontTopTable").style.top = frontY;
	document.getElementById("frontTopTable").style.left = frontX;
	
	// BACK VIEW
	backY = getAbsoulteY(document.getElementById("backBottomTable")) + topOffset;
	backX = getAbsoulteX(document.getElementById("backBottomTable")) + leftOffset;
	
	document.getElementById("backMiddleTable").style.top = backY;
	document.getElementById("backMiddleTable").style.left = backX;
	
	document.getElementById("backTopTable").style.top = backY;
	document.getElementById("backTopTable").style.left = backX;
		
	// Show the last refresh
	document.getElementById(namespace_g + 'lastRefreshTimestamp').innerHTML = getLocalizedCurrentTimeStamp();
}

function physicalComponentMouseOver(physicalCellObject, applyToOtherView)
{
	if(physicalCellObject != selectedPhysicalCellObject)
	{
		physicalCellObject.className="hoveredPhysicalCell";
	
		if(applyToOtherView)
		{
			// Also take action on the other view
			logicalCellObject = document.getElementById(parseLogicalCellId(physicalCellObject.id));
			
			if(logicalCellObject)
			{
				// Make the call and avoid an endless loop
				logicalComponentMouseOver(logicalCellObject, false);
			}
		}
	}
}

function physicalComponentMouseOut(physicalCellObject, applyToOtherView)
{
	if(physicalCellObject != selectedPhysicalCellObject)
	{
		physicalCellObject.className="unhighlightedPhysicalCell";
		
		if(applyToOtherView)
		{
			// Also take action on the other view
			logicalCellObject = document.getElementById(parseLogicalCellId(physicalCellObject.id));
			
			if(logicalCellObject)
			{
				// Make the call and avoid an endless loop
				logicalComponentMouseOut(logicalCellObject, false);
			}
		}
	}
}

function physicalComponentClicked(physicalCellObject, applyToOtherView, componentType)
{
	// If they have clicked on the physical view switch the tab to this type of device
	// Note applyToOtherView tells us that the user clicked the physical view
	if(applyToOtherView)
	{
		selectTab(componentType);
	}

	// Unselect old (if it exists)
	if(selectedPhysicalCellObject)
	{
		selectedPhysicalCellObject.className="unhighlightedPhysicalCell";
			
	}		
	
	// Set the new selected
	selectedPhysicalCellObject = physicalCellObject;
	
	physicalCellObject.className="highlightedPhysicalCell";
	
	
	if(applyToOtherView)
	{
		// Also take action on the other view
		logicalCellObject = document.getElementById(parseLogicalCellId(physicalCellObject.id));
		
		if(logicalCellObject)
		{
			// Make the call and avoid an endless loop
			logicalComponentClicked(logicalCellObject, false, componentType);
		}
	}
}

//////////////////////////////////////// LOGICAL VIEW SPECIFIC /////////////////////////////////////////////

function logicalComponentMouseOver(logicalCellObject, applyToOtherView)
{
	if(logicalCellObject != selectedLogicalCellObject)
	{
		logicalCellObject.className="hoveredLogicalCell";
		
		if(applyToOtherView)
		{
			// Also take action on the other view
			physicalCellObject = document.getElementById(parsePhysicalCellId(logicalCellObject.id));
			
			if(physicalCellObject)
			{
				// Make the call and avoid an endless loop
				physicalComponentMouseOver(physicalCellObject, false);
			}
		}
	}
}

function logicalComponentMouseOut(logicalCellObject, applyToOtherView)
{
	if(logicalCellObject != selectedLogicalCellObject)
	{
		logicalCellObject.className="unhighlightedLogicalCell";
		
		if(applyToOtherView)
		{
			// Also take action on the other view
			physicalCellObject = document.getElementById(parsePhysicalCellId(logicalCellObject.id));
			
			if(physicalCellObject)
			{
				// Make the call and avoid an endless loop
				physicalComponentMouseOut(physicalCellObject, false);
			}
		}
	}
}

function logicalComponentClicked(logicalCellObject, applyToOtherView, componentType, dualController, serviceMode)
{
	// Unselect old (if it exists)
	if(selectedLogicalCellObject)
	{
		selectedLogicalCellObject.className="unhighlightedLogicalCell";
		selectedLogicalCellObject.title = selectedLogicalCellObject.attributes.getNamedItem("title_unselected").value;
		selectedLogicalCellObject.getElementsByTagName("img")[0].title = selectedLogicalCellObject.attributes.getNamedItem("title_unselected").value;
		selectedLogicalCellObject.getElementsByTagName("img")[0].alt = selectedLogicalCellObject.attributes.getNamedItem("title_unselected").value;
		
		// Hide the prepare for service message for a controller
		if(document.getElementById("prepareForService" + currentComponentId))
		{
			document.getElementById("prepareForService" + currentComponentId).style.display = "none";
		}
	}		
	
	// Set the new selected
	selectedLogicalCellObject = logicalCellObject;
	
	logicalCellObject.className="highlightedLogicalCell";
	logicalCellObject.title=logicalCellObject.attributes.getNamedItem("title_selected").value;
	logicalCellObject.getElementsByTagName("img")[0].title = logicalCellObject.attributes.getNamedItem("title_selected").value;
	logicalCellObject.getElementsByTagName("img")[0].alt = logicalCellObject.attributes.getNamedItem("title_selected").value;
	
	if(applyToOtherView)
	{
		selectTab(componentType);
		// Also take action on the other view
		physicalCellObject = document.getElementById(parsePhysicalCellId(logicalCellObject.id));
		
		if(physicalCellObject)
		{
			// Make the call and avoid an endless loop
			physicalComponentClicked(physicalCellObject, false, componentType);
		}
	}
	
	currentComponentId = parseComponentId(logicalCellObject.id);
	
	// Show the prepare for service message for a controller
	if(componentType == CONTROLLER_TYPE)
	{
	   if(document.getElementById("prepareForService" + currentComponentId))
		document.getElementById("prepareForService" + currentComponentId).style.display = "block";
	}
	
	// So the ID can be included in requests
	document.getElementById("currentSelectedComponentId").value = currentComponentId;
	
	// Show the information frame
	stillShowingInitialMessage = false;
	showInformationFrame(currentComponentId, componentType, dualController, serviceMode);
	ComponentClicked_Extending_Actions(currentComponentId);
	
}

function tabClicked()
{
	// Unselect both logical and physical views
	if(selectedLogicalCellObject)
	{
		selectedLogicalCellObject.className="unhighlightedLogicalCell";
		selectedLogicalCellObject.title = selectedLogicalCellObject.attributes.getNamedItem("title_unselected").value;
		selectedLogicalCellObject.getElementsByTagName("img")[0].title = selectedLogicalCellObject.attributes.getNamedItem("title_unselected").value;
		
		selectedLogicalCellObject = null;
	}
	
	if(selectedPhysicalCellObject)
	{
		selectedPhysicalCellObject.className="unhighlightedPhysicalCell";
		selectedPhysicalCellObject = null;
	}
	
	// Reset information area
	document.getElementById("initialInformationAreaDiv").style.display = "block";
	document.getElementById("loadingInformationAreaDiv").style.display = "none";
	document.getElementById("informationAreaFrameDiv").style.visibility = "hidden";
	stillShowingInitialMessage = true;
	
	// Reset menu to default
	document.getElementById(currentMenuDivId).style.display = "none";
	currentMenuDivId = "defaultMenuDIV";
	document.getElementById(currentMenuDivId).style.display = "block";
	
	return true;
}

// Set the menu enabled for the assimilate function
function setDiskAssimilate(isAssimilate) {
	isCurrentDiskRoaming = isAssimilate;
}

//////////////////////////////////////// INFORMATION AREA FUNCTIONS /////////////////////////////////////////////
function showInformationFrame(componentId, componentType, dualController, serviceMode)
{
	// Show the waiting loading message while the frame loads
	startInformationAreaWait();

	// Hide the previous menu
	document.getElementById(currentMenuDivId).style.display = "none";

	// Set the frame URL and display the correct menu
	switch(componentType)
	{
		case NOT_USABLE_DISK_TYPE : document.getElementById("informationAreaFrame").src = DISK_PAGE + "?id=" + componentId;
						 			currentLoadingMenuDivId = "diskMenuDIV";
						 			// Hide or show certain disk options depending on disk type
						 			document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink").style.display = "none";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink_disabled").style.display = "block";
						 			  
						 			  document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink").style.display = "none";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink_disabled").style.display = "block";

						 			  document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink").style.display = "none";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink_disabled").style.display = "block";
						 			break;
		case UNCONFIGURED_DISK_TYPE : document.getElementById("informationAreaFrame").src = DISK_PAGE + "?id=" + componentId;
						 			  currentLoadingMenuDivId = "diskMenuDIV";
						 			  // Hide or show certain disk options depending on disk type
						 			  document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink").style.display = "block";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink_disabled").style.display = "none";
						 			  
						 			  document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink").style.display = "none";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink_disabled").style.display = "block";

						 			  document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink").style.display = "none";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink_disabled").style.display = "block";
						 			  break;
		case CONFIGURED_DISK_TYPE : document.getElementById("informationAreaFrame").src = DISK_PAGE + "?id=" + componentId;
						 			currentLoadingMenuDivId = "diskMenuDIV";
						 			// Hide or show certain disk options depending on disk type
						 			document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink").style.display = "none";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink_disabled").style.display = "block";
						 			  
						 			  document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink").style.display = "none";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink_disabled").style.display = "block";

						 			  document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink").style.display = "block";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink_disabled").style.display = "none";

						 			break;
		case GLOBALSPARE_DISK_TYPE : document.getElementById("informationAreaFrame").src = DISK_PAGE + "?id=" + componentId;
						 			 currentLoadingMenuDivId = "diskMenuDIV";
						 			 // Hide or show certain disk options depending on disk type
						 		     document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink").style.display = "none";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink_disabled").style.display = "block";
						 			  
						 			  document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink").style.display = "block";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink_disabled").style.display = "none";

						 			  document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink").style.display = "none";
						 			  document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink_disabled").style.display = "block";
								 	 break;
		case DEDICATEDSPARE_DISK_TYPE : document.getElementById("informationAreaFrame").src = DISK_PAGE + "?id=" + componentId;
						 				currentLoadingMenuDivId = "diskMenuDIV";
						 				// Hide or show certain disk options depending on disk type
						 			    document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink").style.display = "none";
						 			 	document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink_disabled").style.display = "block";
						 			  
						 			  	document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink").style.display = "none";
						 			  	document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink_disabled").style.display = "block";

										  document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink").style.display = "none";
										  document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink_disabled").style.display = "block";
						 				break;				 				 				 
		case BBU_TYPE : document.getElementById("informationAreaFrame").src = BBU_PAGE + "?id=" + componentId;
						currentLoadingMenuDivId = "bbuMenuDIV";
						break;
		case SWITCH_TYPE : document.getElementById("informationAreaFrame").src = SWITCH_PAGE + "?id=" + componentId;
						  if(componentId.indexOf('BLSASSwitch')>=0){
                            // the switch is connected
						   	currentLoadingMenuDivId = "switchMenuDIV";
						   }else{
                             // switch is not connected, but the controller is existed.
						     // "storageModuleMenuDIV" is mean no action menu
							   currentLoadingMenuDivId = "storageModuleMenuDIV";
						   }
						   break;
		case CONTROLLER_TYPE : document.getElementById("informationAreaFrame").src = CONTROLLER_PAGE + "?id=" + componentId;
						 	   currentLoadingMenuDivId = "controllerMenuDIV";
						 	   //if(dualController && !serviceMode) {
								//	document.getElementById(namespace_g + "mainForm:controllerMenuPrepareForServiceLink").style.display = "none";
						 		//	document.getElementById(namespace_g + "mainForm:controllerMenuPrepareForServiceLink_disabled").style.display = "none";
								//} else {
								//	document.getElementById(namespace_g + "mainForm:controllerMenuPrepareForServiceLink").style.display = "none";
						 		//	document.getElementById(namespace_g + "mainForm:controllerMenuPrepareForServiceLink_disabled").style.display = "none";
								//}
						       break;
		case STORAGE_MODULE_TYPE : document.getElementById("informationAreaFrame").src = STORAGE_MODULE_PAGE + "?id=" + componentId;
						           currentLoadingMenuDivId = "storageModuleMenuDIV";
						           break;
	}
	
	if (isCurrentDiskRoaming == "true" && currentLoadingMenuDivId == "diskMenuDIV") {
		document.getElementById(namespace_g + "mainForm:diskMenuAssimilateLink").style.display = "block";
		document.getElementById(namespace_g + "mainForm:diskMenuAssimilateLink_disabled").style.display = "none";
	} else {
		document.getElementById(namespace_g + "mainForm:diskMenuAssimilateLink").style.display = "none";
		document.getElementById(namespace_g + "mainForm:diskMenuAssimilateLink_disabled").style.display = "block";
	}

	// Show the current (loading) menu
	currentMenuDivId = "loadingMenuDIV";
	document.getElementById(currentMenuDivId).style.display = "block";
}

function startInformationAreaWait()
{
	// Make sure that the initial message is hidden
	document.getElementById("initialInformationAreaDiv").style.display = "none";
	
	document.getElementById("loadingInformationAreaDiv").style.display = "block";
	document.getElementById("informationAreaFrameDiv").style.visibility = "hidden";
}

function stopInformationAreaWait()
{
	if(!stillShowingInitialMessage)
	{
		informationCell = document.getElementById("informationAreaCell");
		
		// Align the frame
		document.getElementById("informationAreaFrameDiv").style.top = getAbsoulteY(informationCell) + 1;
		document.getElementById("informationAreaFrameDiv").style.left = getAbsoulteX(informationCell) + 2;
		
		document.getElementById("loadingInformationAreaDiv").style.display = "none";
		document.getElementById("informationAreaFrameDiv").style.visibility = "visible";
		
		// Hide the loading menu, and show the real menu
		document.getElementById(currentMenuDivId).style.display = "none";
		currentMenuDivId = currentLoadingMenuDivId;
		document.getElementById(currentMenuDivId).style.display = "block";
	}
}

//////////////////////////////////////// HELPER FUNCTIONS /////////////////////////////////////////////

function selectDefaultDevice(componentId)
{
	var logicalId = "logicalViewCell:" + componentId;
	
	if(document.getElementById(logicalId))
	{
		document.getElementById(logicalId).onclick();
	}
}

function getAbsoulteX(htmlElement)
{
	absoluteX = 0;
	
	while(htmlElement) 
	{
		absoluteX += htmlElement.offsetLeft;
		htmlElement = htmlElement.offsetParent;
	}
	
	return absoluteX;
}

function getAbsoulteY(htmlElement)
{
	absoluteY = 0;
	while(htmlElement) 
	{
		absoluteY += htmlElement.offsetTop;
		htmlElement = htmlElement.offsetParent;
	}
	
	return absoluteY;
}

function parseLogicalCellId(physicalCellId)
{
	// Logical cell ids will be in this format: logicalViewCell:<itemID>
	// Physical cell ids will be in this format: physicalViewCell:<itemID> 
	
	return "logicalViewCell:" + parseComponentId(physicalCellId);		
}

function parsePhysicalCellId(logicalCellId)
{
	// Logical cell ids will be in this format: logicalViewCell:<itemID>
	// Physical cell ids will be in this format: physicalViewCell:<itemID> 
	
	return "physicalViewCell:" + parseComponentId(logicalCellId);
}

function parseComponentId(htmlId)
{
	// Html ids will be in the format <html object identifier>:<component id>
	colonIndex = htmlId.indexOf(":");
	
	return htmlId.substring(colonIndex + 1);
}

function setTabIcon(tabIndex, statusImage)
{
	tabLink = document.getElementById(namespace_g + "resourceAreaTabsscm_tabbedPanel_notebookhyperlink_" + tabIndex);
	
	if(tabLink)
	{
		if(statusImage)
		{
			tabLink.innerHTML = "<IMG src='" + statusImage + "' /> " + tabLink.innerHTML;
		}
	}
}

function selectTab(componentType)
{	
	switch(componentType)
	{
		case NOT_USABLE_DISK_TYPE : ODCRegistry.getClientControl('resourceAreaTabs').restoreUIState(namespace_g + "mainForm:resourceAreaTabs:drivesTab");
						 			  break;
		case UNCONFIGURED_DISK_TYPE : ODCRegistry.getClientControl('resourceAreaTabs').restoreUIState(namespace_g + "mainForm:resourceAreaTabs:drivesTab");
						 			  break;
		case CONFIGURED_DISK_TYPE : ODCRegistry.getClientControl('resourceAreaTabs').restoreUIState(namespace_g + "mainForm:resourceAreaTabs:drivesTab");
						 			break;
		case GLOBALSPARE_DISK_TYPE : ODCRegistry.getClientControl('resourceAreaTabs').restoreUIState(namespace_g + "mainForm:resourceAreaTabs:drivesTab");
						 			 break;
		case DEDICATEDSPARE_DISK_TYPE : ODCRegistry.getClientControl('resourceAreaTabs').restoreUIState(namespace_g + "mainForm:resourceAreaTabs:drivesTab");
						 				break;
		case BBU_TYPE : ODCRegistry.getClientControl('resourceAreaTabs').restoreUIState(namespace_g + "mainForm:resourceAreaTabs:bbusTab");
						break;
		case SWITCH_TYPE : ODCRegistry.getClientControl('resourceAreaTabs').restoreUIState(namespace_g + "mainForm:resourceAreaTabs:switchesTab");
						 break;
		case CONTROLLER_TYPE : ODCRegistry.getClientControl('resourceAreaTabs').restoreUIState(namespace_g + "mainForm:resourceAreaTabs:controllersTab");
						 break;
		case STORAGE_MODULE_TYPE : ODCRegistry.getClientControl('resourceAreaTabs').restoreUIState(namespace_g + "mainForm:resourceAreaTabs:storageModulesTab");
						 break;
	}
}

function resizeFrameHeight(frameID, frameName)
{
	frameObject = document.getElementById(frameID);
	
	// Reset it to a small value so that the height is always increased
	frameObject.style.height = 10;
	
	frameDocument = window.frames[frameName].document;
	
	frameBody = frameDocument.body;

	//  Height
	oHeight = 0;
	sHeight = 0;
	
	if(frameBody.offsetHeight)
		oHeight = frameBody.offsetHeight;
	
	if(frameBody.scrollHeight)
		sHeight = frameBody.scrollHeight;
		
	// Set the height to the bigger one
	newHeight = Math.max(oHeight, sHeight);
	
	frameObject.style.height = newHeight;
}

function resizeFrameWidth(frameID, frameName)
{
	frameObject = document.getElementById(frameID);
	
	// Reset it to a small value so that the width is always increased
	frameObject.style.width = 10;
	
	frameDocument = window.frames[frameName].document;
	
	frameBody = frameDocument.body;

	//  Width
	oWidth = 0;
	sWidth = 0;
	
	if(frameBody.offsetWidth)
		oWidth = frameBody.offsetWidth;
	
	if(frameBody.scrollWidth)
		sWidth = frameBody.scrollWidth;
		
	// Set the width to the bigger one
	newWidth = Math.max(oWidth, sWidth);
	
	frameObject.style.width = newWidth;
}

function openHelpDialog(itemName)
{
	var currTabId = ODCTabPanelControlVar1.selectedTabID + "";
	
	if("Disks" == itemName)
	{
		if(0 < currTabId.indexOf("propertiesTab"))
		{
			window.open("/help/topic/com.ibm.storage.rssm.doc/scm_rss_disk_properties_help.html", 'helpwin', 'status,resizable,scrollbars,width=740,height=290');
		}
		else if(document.getElementById(namespace_g + "mainForm:alertCode"))
		{
			var codeNumber = document.getElementById(namespace_g + "mainForm:alertCode").innerHTML;
			
			var helpURL = "/help/topic/com.ibm.storage.rssm.doc/scm_alert_" + codeNumber + "_help.html";
			
			window.open(helpURL, 'helpwin', 'status,resizable,scrollbars,width=740,height=290');
		}else{
			var helpURL = "/help/topic/com.ibm.storage.rssm.doc/scm_rss_disk_alerts_help.html";
			window.open(helpURL, 'helpwin', 'status,resizable,scrollbars,width=740,height=290');		
		}
	}
	else if("BBUs" == itemName)
	{
		if(0 < currTabId.indexOf('propertiesTab'))
		{
			window.open("/help/topic/com.ibm.storage.rssm.doc/scm_rss_bbu_properties_help.html", 'helpwin', 'status,resizable,scrollbars,width=740,height=290');
		}
		else if(document.getElementById(namespace_g + "mainForm:alertCode"))
		{
			var codeNumber = document.getElementById(namespace_g + "mainForm:alertCode").innerHTML;
			
			var helpURL = "/help/topic/com.ibm.storage.rssm.doc/scm_alert_" + codeNumber + "_help.html";
			
			window.open(helpURL, 'helpwin', 'status,resizable,scrollbars,width=740,height=290');
		}else{
			var helpURL = "/help/topic/com.ibm.storage.rssm.doc/scm_rss_disk_alerts_help.html";
			window.open(helpURL, 'helpwin', 'status,resizable,scrollbars,width=740,height=290');		
		}
	}
	else if("Controllers" == itemName)
	{
		if(0 < currTabId.indexOf('propertiesTab'))
		{
			window.open("/help/topic/com.ibm.storage.rssm.doc/scm_rss_controller_properties_help.html", 'helpwin', 'status,resizable,scrollbars,width=740,height=290');
		}
		else if(document.getElementById(namespace_g + "mainForm:alertCode"))
		{
			var codeNumber = document.getElementById(namespace_g + "mainForm:alertCode").innerHTML;
			
			var helpURL = "/help/topic/com.ibm.storage.rssm.doc/scm_alert_" + codeNumber + "_help.html";
			
			window.open(helpURL, 'helpwin', 'status,resizable,scrollbars,width=740,height=290');
		}else{
			var helpURL = "/help/topic/com.ibm.storage.rssm.doc/scm_rss_disk_alerts_help.html";
			window.open(helpURL, 'helpwin', 'status,resizable,scrollbars,width=740,height=290');		
		}
	}
	else if("StorageModules" == itemName)
	{
		if(0 < currTabId.indexOf('propertiesTab'))
		{
			window.open("/help/topic/com.ibm.storage.rssm.doc/scm_rss_storage_module_properties_help.html", 'helpwin', 'status,resizable,scrollbars,width=740,height=290');
		}
		else if(document.getElementById(namespace_g + "mainForm:alertCode"))
		{
			var codeNumber = document.getElementById(namespace_g + "mainForm:alertCode").innerHTML;
			
			var helpURL = "/help/topic/com.ibm.storage.rssm.doc/scm_alert_" + codeNumber + "_help.html";
			
			window.open(helpURL, 'helpwin', 'status,resizable,scrollbars,width=740,height=290');
		}else{
			var helpURL = "/help/topic/com.ibm.storage.rssm.doc/scm_rss_disk_alerts_help.html";
			window.open(helpURL, 'helpwin', 'status,resizable,scrollbars,width=740,height=290');		
		}
	}
	else if("Switches" == itemName)
	{
		if(0 < currTabId.indexOf('propertiesTab'))
		{
			window.open("/help/topic/com.ibm.storage.rssm.doc/scm_rss_switch_properties_help.html", 'helpwin', 'status,resizable,scrollbars,width=740,height=290');
		}
		else
		{
			// Switches currently dont have an alerts tab
		}
	}
}

//////////////////////////////////////// partial case /////////////////////////////////////////////

function checkAndDisabledResourceTab(){
	var storageMissing = document.getElementById("isStorageMissing").value;
	var switchMissing = document.getElementById("isSwitchMissing").value;
	
	if(storageMissing=="true"){
		ODCRegistry.getClientControl('resourceAreaTabs').Panes[1].enabled = false;
		ODCRegistry.getClientControl('resourceAreaTabs').Panes[2].enabled = false;
		ODCRegistry.getClientControl('resourceAreaTabs').Panes[4].enabled = false;
		ODCRegistry.getClientControl('resourceAreaTabs').Panes[5].enabled = false;
		if(switchMissing!="true"){
			var tab=namespace_g + "mainForm:resourceAreaTabs:switchesTab";		
	 		ODCTabPanelControlVar1.restoreUIState(tab);
	 	}else{
			var tab=namespace_g + "mainForm:resourceAreaTabs:drivesTab";		
	 		ODCTabPanelControlVar1.restoreUIState(tab);	 	
	 	}
	}
	if(switchMissing=="true"){
		ODCRegistry.getClientControl('resourceAreaTabs').Panes[3].enabled = false;			
	}
}
/////////////////////////////////Vincent added for defect 7643/10714 /////////////////////////////////////
function onUnassignGlobalConfirmShow(){
	var leaveUnprotectedPools = selectedLogicalCellObject.getElementsByTagName("center")[0].getElementsByTagName("span")[1].innerHTML;
	document.getElementById(namespace_g + "mainForm:warning_unassignGlobal_unprotectPool_txt").innerHTML=leaveUnprotectedPools;
	if("" == leaveUnprotectedPools) {
		document.getElementById(namespace_g + "mainForm:warning_unassignGlobal_unprotectPool_txt").style.display='none';
		document.getElementById(namespace_g + "mainForm:unassignGlobalSpareConfirmMessage").innerHTML=document.getElementById(namespace_g + "mainForm:unassignGlobalConfirmation").innerHTML;
	} else {
		document.getElementById(namespace_g + "mainForm:warning_unassignGlobal_unprotectPool_txt").style.display='block';
		document.getElementById(namespace_g + "mainForm:unassignGlobalSpareConfirmMessage").innerHTML=document.getElementById(namespace_g + "mainForm:unassignGlobalConfirmationWithUnprotectedPool").innerHTML;
	}
}

/////////////////////////////////Copy back functions /////////////////////////////////////
function closeUtilDialog(){
	document.getElementById(namespace_g + "mainForm:CopyBackDialogCloseBtn").click();
}
function CopyBackDialogOnShow(theObj,theEvent){
	startWait();
	document.getElementById(namespace_g + "mainForm:gotoCopybackPageBtn").click();
}

function LoadCopyBackPage(theObj,theEvent){
    setFormTarget(theObj,650,390);
}
function setFormTarget(thisObj,width, height){
		thisObj.form.target="templ_u_iframe";
		adjustDialogSize(width, height);
}
function startWait(){
	 if (document.getElementById('templ_waitDiv_utility')) {
			document.getElementById('templ_waitDiv_utility').style.display = "";
			document.getElementById('templ_u_iframe_div').style.display = "none";
			document.getElementById('templ_u_iframe_div').style.visibility = "visible";
			//document.getElementById('templ_u_iframe').src='';
			adjustIEFrame();
	 }
}
function stopWait(dialogId){		
	 if (document.getElementById('templ_waitDiv_utility')) {
			document.getElementById('templ_waitDiv_utility').style.display = "none";
			document.getElementById('templ_u_iframe_div').style.display = "";
			document.getElementById('templ_u_iframe_div').style.visibility = "visible";
			adjustIEFrame();
	 }
}
function adjustDialogSize(varwidth , varheight) {
	document.getElementById(namespace_g + "mainForm:CopyBackDriveModal").style.width = varwidth+20;
	document.getElementById("templ_u_iframe").style.width = varwidth;

	document.getElementById(namespace_g + "mainForm:CopyBackDriveModal").style.height = varheight+20;
	document.getElementById("templ_u_iframe").style.height = varheight;
}
function adjustIEFrame() {
	if (document.getElementById(namespace_g + "mainForm:util_dialog_if")) {
		var additionIFrame = document.getElementById(namespace_g + "mainForm:util_dialog_if");
		additionIFrame.style.height = document.getElementById("templ_u_iframe").style.height;
	}
}
//////////////////////////////////////////////////////dismount/ mount /////////////////////////
PHYSICAL_TYPE_DISK = "DISK";
PHYSICAL_TYPE_BBU = "BBU";
PHYSICAL_TYPE_DSM = "DSM";
PHYSICAL_TYPE_CONTROLLER = "CONTROLLER";

var PHYSICAL_RESOURCE_MAP = new Object();

function onDismountConfirmShow(){
	return true;

}
function PrepareReplacementFor(type){
	var component = PHYSICAL_RESOURCE_MAP[currentComponentId];
	if(PHYSICAL_TYPE_DISK==type){
		document.getElementById(namespace_g + "mainForm:dismount_info_DISK").style.display="";
		document.getElementById(namespace_g + "mainForm:dismount_info_BBU").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_info_DSM").style.display="none";
		
		document.getElementById(namespace_g + "mainForm:dismount_Alert_DISK").style.display="";
		document.getElementById(namespace_g + "mainForm:dismount_Alert_BBU").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_Alert_DSM").style.display="none";
		
		document.getElementById(namespace_g + "mainForm:dismount_Message_DISK").style.display="";
		document.getElementById(namespace_g + "mainForm:dismount_Message_BBU").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_Message_DSM").style.display="none";
		document.getElementById("DSM_allowDegradedGroups").style.display="none";
		
	}else if(PHYSICAL_TYPE_BBU==type){
		document.getElementById(namespace_g + "mainForm:dismount_info_DISK").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_info_BBU").style.display="";
		document.getElementById(namespace_g + "mainForm:dismount_info_DSM").style.display="none";
		
		document.getElementById(namespace_g + "mainForm:dismount_Alert_DISK").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_Alert_BBU").style.display="";
		document.getElementById(namespace_g + "mainForm:dismount_Alert_DSM").style.display="none";
		
		document.getElementById(namespace_g + "mainForm:dismount_Message_DISK").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_Message_BBU").style.display="";
		document.getElementById(namespace_g + "mainForm:dismount_Message_DSM").style.display="none";

		document.getElementById("DSM_allowDegradedGroups").style.display="none";
				
	}if(PHYSICAL_TYPE_DSM==type){
		document.getElementById(namespace_g + "mainForm:dismount_info_DISK").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_info_BBU").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_info_DSM").style.display="";
		
		document.getElementById(namespace_g + "mainForm:dismount_Alert_DISK").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_Alert_BBU").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_Alert_DSM").style.display="";
		
		document.getElementById(namespace_g + "mainForm:dismount_Message_DISK").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_Message_BBU").style.display="none";
		document.getElementById(namespace_g + "mainForm:dismount_Message_DSM").style.display="";
		
		document.getElementById("DSM_allowDegradedGroups").style.display="";
		
	}
		document.getElementById(type+"DisplayName").innerHTML=component.displayName+" ";
		document.getElementById(namespace_g + "mainForm:physicalDismountLink").click();
	return false;
}
function BringOnlineFor(type){
	var component = PHYSICAL_RESOURCE_MAP[currentComponentId];
	if(PHYSICAL_TYPE_DISK==type){
		document.getElementById(namespace_g + "mainForm:mount_info_DISK").style.display="";
		document.getElementById(namespace_g + "mainForm:mount_info_BBU").style.display="none";
		document.getElementById(namespace_g + "mainForm:mount_info_DSM").style.display="none";

		document.getElementById("Physical_DSM_Mount_Reboot_Notice").style.display="none";
	}else if(PHYSICAL_TYPE_BBU==type){
		document.getElementById(namespace_g + "mainForm:mount_info_DISK").style.display="none";
		document.getElementById(namespace_g + "mainForm:mount_info_BBU").style.display="";
		document.getElementById(namespace_g + "mainForm:mount_info_DSM").style.display="none";
		
		document.getElementById("Physical_DSM_Mount_Reboot_Notice").style.display="none";				
	}if(PHYSICAL_TYPE_DSM==type){
		document.getElementById(namespace_g + "mainForm:mount_info_DISK").style.display="none";
		document.getElementById(namespace_g + "mainForm:mount_info_BBU").style.display="none";
		document.getElementById(namespace_g + "mainForm:mount_info_DSM").style.display="";
		
		document.getElementById("Physical_DSM_Mount_Reboot_Notice").style.display="";				
	}
		document.getElementById(type+"DisplayName_mount").innerHTML=component.displayName+" ";
		document.getElementById(namespace_g + "mainForm:physicalMountLink").click();
	return false;
}
function PhysicalObject(type,id,displayName,dismounted,mounted,missing,configured,globalSparing){
	// for all resource
	this.type = type;
	this.id = id;
	this.displayName = displayName;
	this.dismounted = dismounted;
	this.mounted = mounted;
	this.missing = missing;
	// only for BBU
	//only for controller
	//only for DSM
	//only for Disk
	this.configured = configured;
	this.globalSparing = globalSparing;
}

function onmountConfirmShow(){
	document.getElementById(namespace_g + "mainForm:mountModalSubmit").click();
	return true;
}

function ComponentClicked_Extending_Actions(id){
	var component = PHYSICAL_RESOURCE_MAP[id];
	if(component.type==PHYSICAL_TYPE_DISK){
		document.getElementById(namespace_g + "mainForm:diskMenu_Bring_On_Link").style.display = "none";
		document.getElementById(namespace_g + "mainForm:diskMenu_Bring_On_Link_disabled").style.display = "block";	  
			
		document.getElementById(namespace_g + "mainForm:diskMenu_Prepare_For_Replacement_Link").style.display = "none";
		document.getElementById(namespace_g + "mainForm:diskMenu_Prepare_For_Replacement_Link_disabled").style.display = "block";	  
			
		if(component.dismounted=="true"){
				document.getElementById(namespace_g + "mainForm:diskMenu_Bring_On_Link").style.display = "block";
				document.getElementById(namespace_g + "mainForm:diskMenu_Bring_On_Link_disabled").style.display = "none";

				document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink").style.display = "none";
				document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink_disabled").style.display = "block";
				  
				document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink").style.display = "none";
				document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink_disabled").style.display = "block";

				document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink").style.display = "none";
				document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink_disabled").style.display = "block";				
		}else if(component.mounted=="true" && component.configured!="true"){
			document.getElementById(namespace_g + "mainForm:diskMenu_Prepare_For_Replacement_Link").style.display = "block";
			document.getElementById(namespace_g + "mainForm:diskMenu_Prepare_For_Replacement_Link_disabled").style.display = "none";	  
		}
		if(component.missing=="true"){
				document.getElementById(namespace_g + "mainForm:diskMenu_Bring_On_Link").style.display = "none";
				document.getElementById(namespace_g + "mainForm:diskMenu_Bring_On_Link_disabled").style.display = "block";

				document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink").style.display = "none";
				document.getElementById(namespace_g + "mainForm:diskMenuGlobalHotSpareLink_disabled").style.display = "block";
				  
				document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink").style.display = "none";
				document.getElementById(namespace_g + "mainForm:diskMenuUnassignGlobalHotSpareLink_disabled").style.display = "block";

				document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink").style.display = "none";
				document.getElementById(namespace_g + "mainForm:diskMenuCopyBackLink_disabled").style.display = "block";				
		}
		
	}else if(component.type==PHYSICAL_TYPE_BBU){
		document.getElementById(namespace_g + "mainForm:bbuMenu_Bring_On_Link").style.display = "none";
		document.getElementById(namespace_g + "mainForm:bbuMenu_Bring_On_Link_disabled").style.display = "block";	  
			
		document.getElementById(namespace_g + "mainForm:bbuMenu_Prepare_For_Replacement_Link").style.display = "none";
		document.getElementById(namespace_g + "mainForm:bbuMenu_Prepare_For_Replacement_Link_disabled").style.display = "block";	  
		if(component.dismounted=="true"){
				document.getElementById(namespace_g + "mainForm:bbuMenu_Bring_On_Link").style.display = "block";
				document.getElementById(namespace_g + "mainForm:bbuMenu_Bring_On_Link_disabled").style.display = "none";			
		}else if(component.mounted=="true"){
			document.getElementById(namespace_g + "mainForm:bbuMenu_Prepare_For_Replacement_Link").style.display = "block";
			document.getElementById(namespace_g + "mainForm:bbuMenu_Prepare_For_Replacement_Link_disabled").style.display = "none";	  
		}	
	}else if(component.type==PHYSICAL_TYPE_DSM){
		document.getElementById(namespace_g + "mainForm:dsmMenu_Bring_On_Link").style.display = "none";
		document.getElementById(namespace_g + "mainForm:dsmMenu_Bring_On_Link_disabled").style.display = "block";	  
			
		document.getElementById(namespace_g + "mainForm:dsmMenu_Prepare_For_Replacement_Link").style.display = "none";
		document.getElementById(namespace_g + "mainForm:dsmMenu_Prepare_For_Replacement_Link_disabled").style.display = "block";	  
			
		if(component.dismounted=="true"){
				document.getElementById(namespace_g + "mainForm:dsmMenu_Bring_On_Link").style.display = "block";
				document.getElementById(namespace_g + "mainForm:dsmMenu_Bring_On_Link_disabled").style.display = "none";			
		}else if(component.mounted=="true"){
			document.getElementById(namespace_g + "mainForm:dsmMenu_Prepare_For_Replacement_Link").style.display = "block";
			document.getElementById(namespace_g + "mainForm:dsmMenu_Prepare_For_Replacement_Link_disabled").style.display = "none";	  
		}	
	}
}

function onShowAssignGlobalDialog() {
	
}

/* dialog for assimilate disks */
function onAssimilateDriveShow() {
	document.getElementById("assimilate_msg_row").style.display = "";
	document.getElementById("assimilate_progressing_row").style.display = "none";
}
function confirmAssimilate() {
	document.getElementById("assimilate_msg_row").style.display = "none";
	document.getElementById("assimilate_progressing_row").style.display = "";
	document.getElementById(namespace_g + "mainForm:hidden_assimilate_drive_submit_button").click();
	document.getElementById(namespace_g + "mainForm:confirm_assimilate").disabled = true;
	document.getElementById(namespace_g + "mainForm:cancel_assimilate").disabled = true;
}

function cancelAssimilate() {
	document.getElementById(namespace_g + "mainForm:hidden_assimilate_drive_cancel_button").click();
}
