/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// ports.js

// GLOBAL
// An array of tab indexes that have been requested
var requestedTabs = new Array(false, false, false);
// An array of loaded tabs
var loadedTabs = new Array(false, false, false);
// Current tab index
var currentSelectedTab = -1;
// Property pages
var portListingPages = new Array( path + "/faces/page/rbce/ports/SASSwitchPorts.jsp", "", "");

function clickedTab(tabIndex)
{
	// The same tab was clicked
	if(tabIndex == currentSelectedTab)
	{
		return;
	}
	
	// Unselect the old
	if(document.getElementById("tab" + currentSelectedTab))
	{
		document.getElementById("tab" + currentSelectedTab).className = "unSelectedTab dmc_outputText";
		
		// Make sure to hide the old frame
		document.getElementById("frame" + currentSelectedTab).style.display = "none";
	}
	
	// Selecting new
	document.getElementById("tab" + tabIndex).className = "selectedTab dmc_outputText";
	currentSelectedTab = tabIndex;
	
	loadTab(tabIndex);
}

function loadTab(tabIndex)
{
	// Check if the tab has already been loaded
	// Load if needed

	if(! loadedTabs[tabIndex])
	{		
		requestedTabs[tabIndex] = true;
		
		document.getElementById("frame" + tabIndex).src = portListingPages[tabIndex];
		
		// Show the wait div
		startPortsWait(tabIndex);
	}
	else
	{
		// Here the tab is loaded, so just display it
		document.getElementById("waitDiv").style.display = "none";
	
		document.getElementById("frame" + tabIndex).style.display = "block";
	}
}

function reloadCurrentTab()
{
	// Here the currently selected tab needs to be reloaded
	
	if(! document.getElementById("tab" + currentSelectedTab))
	{
		return;
	}
	
	// Set the loaded to be false
	loadedTabs[currentSelectedTab] = false;
	
	loadTab(currentSelectedTab);
}

function startPortsWait(tabIndex)
{
	document.getElementById("waitDiv").style.display = "block";
	
	document.getElementById("frame" + tabIndex).style.display = "none";
}

function stopPortsWait(tabIndex)
{
	// Make sure that this frame has been requested before
	// Frames will fire an onLoad->stopPortsWait event when they load with src = ""
	// We need to detect and skip that case
	if(!requestedTabs[tabIndex])
	{
		return;
	}
	
	// Here a frame has finished loading, note it in the array
	loadedTabs[tabIndex] = true;
	
	// Display this tab only if its the current one
	if(tabIndex == currentSelectedTab)
	{		
		document.getElementById("waitDiv").style.display = "none";
			
		document.getElementById("frame" + currentSelectedTab).style.display = "block";
	}
}

function onLoad_BladePortProperties(){
	parent.stopWaitFromPort("util_dialog");
}

function onLoad_ExternalPortProperties(){
	parent.stopWaitFromPort("util_dialog");
	alignHeaderTableAndContentTable('headerTableDivId','phyTable_tableHeader');
}

function onLoad_ControllerPortProperties(){
	parent.stopWaitFromPort("util_dialog");
	alignHeaderTableAndContentTable('headerTableDivId','phyTable');
}

