/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// SASSwitchPorts.js

var expandedImage = document.global_context_path + "/images/common/tree/collapse_obj.gif";
var collapsedImage = document.global_context_path + "/images/common/tree/expand_obj.gif";
var collapsedImgName = "expand_obj.gif";

var selectedPorts = new Array();
var selectedExpanders = new Array();
var selectedObjStatus = new Array();

function disableButtons()
{
	document.getElementById(namespace_g + "form1:enableButton").disabled = true;
	document.getElementById(namespace_g + "form1:disableButton").disabled = true;
	document.getElementById(namespace_g + "form1:propertiesButton").disabled = true;	
}

function clickExpandImgBtn(id, image){
	var rowId = "TR_"+id+"-";
	var allTrNodes = document.getElementsByTagName("tr");
	var imagePath = image.src;
	var imageName = imagePath.substring(imagePath.lastIndexOf('\/')+1);
	//value is not a standard attribute for <img>, so access its value in the way below
	var imageValue = image.attributes.value.value;
	if(allTrNodes != null && allTrNodes.length > 0){
		if(imageName == collapsedImgName){
		
			image.src = expandedImage;
			image.alt = document.getElementById(namespace_g + "form1:collapse_alt").innerHTML + " " + imageValue;
			image.title = document.getElementById(namespace_g + "form1:collapse_alt").innerHTML + " " + imageValue;
			
			for(var i=0; i<allTrNodes.length; i++){
				var trId = allTrNodes[i].id;
				if(trId !=null && trId.indexOf(rowId)>=0){
					allTrNodes[i].style.display = "";
				}
			}
		}
		else {
			image.src = collapsedImage;
			image.alt = document.getElementById(namespace_g + "form1:expand_alt").innerHTML + " " + imageValue;
			image.title = document.getElementById(namespace_g + "form1:expand_alt").innerHTML + " " + imageValue;
			
			for(var i=0; i<allTrNodes.length; i++){
				var trId = allTrNodes[i].id;
				if(trId !=null && trId.indexOf(rowId)>=0){
					allTrNodes[i].style.display = "none";
				}
			}
		}
	}
}

function toggle(id, image, event)
{	
	if(document.getElementById(id).style.display == "none")
	{
		document.getElementById(id).style.display = "block"
		
		image.src = expandedImage;
		image.alt = document.getElementById(namespace_g + "form1:collapse_alt").innerHTML;
		image.title = document.getElementById(namespace_g + "form1:collapse_alt").innerHTML;
	}
	else
	{
		document.getElementById(id).style.display = "none";
		
		image.src = collapsedImage;
		image.alt = document.getElementById(namespace_g + "form1:expand_alt").innerHTML;
		image.title = document.getElementById(namespace_g + "form1:expand_alt").innerHTML;
	}
}

function portCheckBoxClicked(checkbox)
{
	var EnableFlag = "";
	for(x = 0; x < properties.length; x++){
		if(properties[x]){
			if(properties[x][0] == checkbox.value){
				if(properties[x][1] == 'BladeSlotConnection'){
					EnableFlag = properties[x][5];
			    }else if((properties[x][1] == 'ExternalPort')){
			    	EnableFlag = properties[x][6];
			    } 
			}
		}		       		       	
    }
	if(checkbox.checked)
	{
		// This select box was just checked
		// Add it to the list of slected items
		selectedPorts.push(checkbox.value);
		selectedObjStatus.push(EnableFlag);
	}
	else
	{
		// This checkbox was just unchecked
		// Remove it from the list of selected items
		selectedPorts.splice(indexOf(checkbox.value, selectedPorts), 1);
		selectedObjStatus.splice(indexOf(EnableFlag, selectedObjStatus), 1);
	}
	
	fixButtonDisable();
}

function expanderCheckBoxClicked(checkbox)
{
	if(checkbox.checked)
	{
		// This select box was just checked
		// Add it to the list of slected items
		selectedExpanders.push(checkbox.value);
	}
	else
	{
		// This checkbox was just unchecked
		// Remove it from the list of selected items
		selectedExpanders.splice(indexOf(checkbox.value, selectedExpanders), 1);
	}
	
	fixButtonDisable();
}

function fixButtonDisable()
{
    var selObjAllEnabledFlg = true;
    var selObjAllDisabledFlg = true;
    for(i = 0; i < selectedObjStatus.length; i++){
    	if(selectedObjStatus[i] == "false"){
    		selObjAllEnabledFlg = false;
    	}
    	if(selectedObjStatus[i] == "true"){
    		selObjAllDisabledFlg = false;
    	}
    }
	// Checking if controls have to be enabled or disabled
	
	// The properties button should only be enabled if one item is selected
	if((selectedPorts.length + selectedExpanders.length) == 1)
	{
		document.getElementById(namespace_g + "form1:propertiesButton").disabled = false;
	}
	else
	{
		document.getElementById(namespace_g +"form1:propertiesButton").disabled = true;
	}
	
	// The enable and disable buttons should be enabled if at least one port is checked
	if(selectedPorts.length > 0)
	{	
		document.getElementById(namespace_g +"form1:enableButton").disabled = true;
		document.getElementById(namespace_g +"form1:disableButton").disabled = true;
		if(selObjAllEnabledFlg){
			document.getElementById(namespace_g +"form1:disableButton").disabled = false;
			document.getElementById(namespace_g +"form1:enableButton").disabled = true;
		}					
		if(selObjAllDisabledFlg){
			document.getElementById(namespace_g +"form1:enableButton").disabled = false;
			document.getElementById(namespace_g +"form1:disableButton").disabled = true;
		}			
	}
	else
	{
		document.getElementById(namespace_g +"form1:enableButton").disabled = true;
		document.getElementById(namespace_g +"form1:disableButton").disabled = true;
	}
	if(selectedExpanders.length > 0) {
		document.getElementById(namespace_g +"form1:enableButton").disabled = true;
		document.getElementById(namespace_g +"form1:disableButton").disabled = true;		
	}
}

function indexOf(element, array)
{
	for(x = 0; x < array.length; x++)
		if(array[x] == element)
			return x;
			
	return -1;
}

function viewProperties()
{	
	for(x = 0; x < properties.length; x++)
	{
		if(properties[x][0] == selectedPorts[0] || properties[x][0] == selectedExpanders[0])
		{
			break;
		}
	}
	// Make sure x is valid
	if(x == properties.length)
	{
		return;
	}
	
	
	// Check the type of the item selected
	if(properties[x][1] == 'BladeSlotConnection')
	{
		//showBladeSlotConnectionProperties(properties[x]);
		document.getElementById(namespace_g +"form1:selectedBladePortID").value = properties[x][0];
		document.getElementById(namespace_g +"form1:showBladePortProperties").click();
	}
	else if(properties[x][1] == 'ExternalPort')
	{
		//showExternalPortProperties(properties[x]);
		document.getElementById(namespace_g +"form1:selectedExternalPortID").value = properties[x][0];
		document.getElementById(namespace_g +"form1:showExternalPortProperties").click();
	}
	else if(properties[x][1] == 'RAIDController')
	{
		//showRaidControllerProperties(properties[x]);
		document.getElementById(namespace_g +"form1:selectedControllerPortID").value = properties[x][0];
		document.getElementById(namespace_g +"form1:showControllerPortProperties").click();
	}
}

function clickedEnable()
{
	var portNames = getSelectedPortNames();
	
	list = document.getElementById("enablePortList");
	
	// Clear old list
	list.innerHTML = "";
	
	// Adding new names
	for(x = 0; x < portNames.length; x++)
	{
		newRow = document.createElement("LI");

		newRow.innerHTML = portNames[x];
			
		list.appendChild(newRow);
	}
	
	// If any expanders are selected we need to dispaly a disclaimer
	if(selectedExpanders.length > 0)
	{
		document.getElementById("enableDisclaimer").style.display = "block";
	}
	else
	{
		document.getElementById("enableDisclaimer").style.display = "none";
	}
	
	// Launch the modal
	document.getElementById(namespace_g +"form1:enableLauncher").click();
}

function clickedDisable()
{
	var portNames = getSelectedPortNames();
	
	list = document.getElementById("disablePortList");
	
	// Clear old list
	list.innerHTML = "";
	
	// Adding new names
	for(x = 0; x < portNames.length; x++)
	{
		newRow = document.createElement("LI");

		newRow.innerHTML = portNames[x];
			
		list.appendChild(newRow);
	}
	
	// If any expanders are selected we need to dispaly a disclaimer
	if(selectedExpanders.length > 0)
	{
		document.getElementById("disableDisclaimer").style.display = "block";
	}
	else
	{
		document.getElementById("disableDisclaimer").style.display = "none";
	}
	
	// Launch the modal
	document.getElementById(namespace_g +"form1:disableLauncher").click();
	
}

function getSelectedPortNames()
{
	var portNames = new Array();
	
	// Setting up the modal list
	for(x = 0; x < selectedPorts.length; x++)
	{
		// Find the name in the properties array using the ID
		var y = 0;
		while(properties[y][0] != selectedPorts[x])
			y++;
			
		portNames.push(properties[y][2]);
	}
	
	// Sorting
	portNames.sort();
	
	return portNames;
}

function showBladeSlotConnectionProperties(data)
{
	// Set the data in the modal
	document.getElementById("bladeSlotConnectionPropertiesPortID").innerHTML = data[2];
	document.getElementById("bladeSlotConnectionPropertiesAddress").innerHTML = data[3];
	document.getElementById("bladeSlotConnectionPropertiesType").innerHTML = data[4];
	document.getElementById("bladeSlotConnectionPropertiesEnabled").innerHTML = data[5];
	document.getElementById("bladeSlotConnectionPropertiesStatus").innerHTML = data[6];
	
	var phy = data[7][0];
		
	// Setting up the PHYs table
	document.getElementById("bladeSlotConnectionPHYPropertiesLinkRate").innerHTML = phy[0];
	document.getElementById("bladeSlotConnectionPHYPropertiesMaxLinkRate").innerHTML = phy[1];
	document.getElementById("bladeSlotConnectionPHYPropertiesIsConnected").innerHTML = phy[2];
	document.getElementById("bladeSlotConnectionPHYPropertiesPHYID").innerHTML = phy[3];
	
	
	// Show the modal
	document.getElementById("bladeSlotConnectionPropertiesLauncher").click();
}

function showExternalPortProperties(data)
{
	// Set the data in the modal
	document.getElementById("externalPortPropertiesPortID").innerHTML = data[2];
	document.getElementById("externalPortPropertiesAddress").innerHTML = data[3];
	document.getElementById("externalPortPropertiesType").innerHTML = data[4];
	document.getElementById("externalPortPropertiesRoutingSetting").innerHTML = data[5];
	document.getElementById("externalPortPropertiesEnabled").innerHTML = data[6];
	document.getElementById("externalPortPropertiesStatus").innerHTML = data[7];
	
	// Setting up the PHYs table
	var table = document.getElementById("externalPortPropertiesPHYsTable");
	var phys = data[8];
	
	// Removing all entries in the table
	while(table.rows.length > 1)
	{
		table.deleteRow(1);
	}

	// Adding the model in the correct ordering
	for(x = 0; x < phys.length; x++)
	{
		newRow = table.insertRow(x + 1);
		
		for(y = 0; y < phys[x].length; y++)
		{
			newCell = document.createElement('td');
			
			newCell.className = "nbceTableRow";
			newCell.innerHTML = phys[x][y];
			
			newRow.appendChild(newCell);
		}
	}
	
	// Show the modal
	document.getElementById("externalPortPropertiesLauncher").click();
}

function showRaidControllerProperties(data)
{
	// Set the data in the modal
	document.getElementById("raidControllerPropertiesPortID").innerHTML = data[2];
	document.getElementById("raidControllerPropertiesAttachedSASAddress").innerHTML = data[3];
	document.getElementById("raidControllerPropertiesStatus").innerHTML = data[4];
		
	// Setting up the PHYs table
	var table = document.getElementById("raidControllerPropertiesPHYsTable");
	var phys = data[5];
	
	// Removing all entries in the table
	while(table.rows.length > 1)
	{
		table.deleteRow(1);
	}

	// Adding the model in the correct ordering
	for(x = 0; x < phys.length; x++)
	{
		newRow = table.insertRow(x + 1);
		
		for(y = 0; y < phys[x].length; y++)
		{
			newCell = document.createElement('td');
			
			newCell.className = "nbceTableRow";
			newCell.innerHTML = phys[x][y];
			
			newRow.appendChild(newCell);
		}
	}
		
	// Show the modal
	document.getElementById("raidControllerPropertiesLauncher").click();
}

function setFormTargetFromPort(varwidth, varheight){

	document.getElementById(namespace_g +"form1").target = "templ_u_iframe";
	adjustDialogSizeFromPort(varwidth , varheight);
}
function adjustDialogSizeFromPort(varwidth , varheight) {
	var clientWidth = 0;
	var clientHeight = 0;
	
	var marginWidth = document.getElementById("templ_u_iframe").marginWidth;
	var marginHeight = document.getElementById("templ_u_iframe").marginHeight;
	
	var titleHeight = 18;
	var borderWidth = 2;
	
	if(typeof varwidth == "undefined" || varwidth == null || varwidth == ""){	
		clientWidth  = document.body.offsetWidth*0.80; //set a better pop-up width 
		document.getElementById(namespace_g +"form1:util_subview:util_dialog").style.width = clientWidth;
	} else {
		clientWidth = varwidth;
		document.getElementById(namespace_g +"form1:util_subview:util_dialog").style.width = (clientWidth + 2 * marginWidth + 2 * borderWidth);
		document.getElementById("templ_u_iframe").style.width = (clientWidth + 2 * marginWidth);
	}
	
	if(typeof varheight == "undefined" || varheight == null || varheight == ""){
		clientHeight  = window.outerHeight*0.75; //set a better pop-up width 
		document.getElementById(namespace_g +"form1:util_subview:util_dialog").style.height = clientHeight;
	} else {
		clientHeight = varheight;
		document.getElementById(namespace_g +"form1:util_subview:util_dialog").style.height = (clientHeight + 2 * marginHeight + titleHeight + 2 * borderWidth);
		document.getElementById("templ_u_iframe").style.height = (clientHeight + 2 * marginHeight);
	}
}

function stopWaitFromPort(){
	document.getElementById('templ_waitDiv_utility').style.display = "none";
	document.getElementById('templ_u_iframe_div').style.visibility = "visible";
	if (document.getElementById(namespace_g +"form1:util_subview:util_dialog_if")) {
		var additionIFrame = document.getElementById(namespace_g +"form1:util_subview:util_dialog_if");
		additionIFrame.style.height = document.getElementById("templ_u_iframe").style.height;
	}			
}

function setPortUtilDialogTitle(titleString){
	document.getElementById(namespace_g +"form1:util_subview:util_dialog_tb").lastChild.nodeValue = titleString;
	//defect 11351, better support accessiblity
	document.getElementById("templ_u_iframe").title = titleString;
}
