/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
var mixDiskConfirmed = false;
var lastClickedButtonID;

function move(fromTable , toTable, buttonID) {
	if (checkSize(fromTable)) {
		moveRow(fromTable , toTable , true);
		refreshInformation();
		refreshButton();
	} else {
		lastClickedButtonID = buttonID;
		document.getElementById(namespace_g + "myForm:showMixSizeMessage").click();
	}
}

function confirmMixDisk() {
	mixDiskConfirmed = true;
	document.getElementById(lastClickedButtonID).click();
}

function checkSize(fromTable) {
	if(mixDiskConfirmed){
		mixDiskConfirmed = false;
		return true;
	}
	
	var fromTableobj = document.getElementById(fromTable);
	var fromTableTbodyobj = fromTableobj.getElementsByTagName("tbody")[0];
	var fromRowlen = fromTableTbodyobj.rows.length;
	
	var toTableobj;
	var toTableTbodyobj;
	var toRowlen;
	
	var selectedDiskSize = "";
	
	if(fromTable==namespace_g + "myForm:availableDiskTable") {
		//check from table first
		for (var i = 0;i < fromRowlen;i ++) {
			var trobj = fromTableTbodyobj.rows[i];
			var inputobj = trobj.getElementsByTagName("input")[0];
			if (inputobj.type == "checkbox" && inputobj.checked) {
				//size value
				var outputobj = trobj.getElementsByTagName("span")[0];
				//alert(selectedDiskSize+" "+outputobj.innerHTML);
				if(selectedDiskSize == "") {
					//the first row added
					selectedDiskSize = outputobj.innerHTML;
					//alert("selectedDiskSize "+outputobj.innerHTML);
				} else if (selectedDiskSize != outputobj.innerHTML) {
					//new disk size
					return false;
				}
			}
		}
		
		//then check the to table
		var switches = retreiveType();
		if (switches == "1") {
			toTableobj = document.getElementById(namespace_g + "myForm:oneAddedDiskTable");
			toTableTbodyobj = toTableobj.getElementsByTagName("tbody")[0];
			toRowlen = toTableTbodyobj.rows.length;
			
			for (var i = 0;i < toRowlen;i ++) {
				var trobj = toTableTbodyobj.rows[i];
				//size value
				var outputobj = trobj.getElementsByTagName("span")[0];
				//alert(selectedDiskSize+" "+outputobj.innerHTML);
				if(selectedDiskSize != outputobj.innerHTML) {
					return false;
				}
			}
		} else if (switches == "2") {
			toTableobj = document.getElementById(namespace_g + "myForm:twoAddedDiskATable");
			toTableTbodyobj = toTableobj.getElementsByTagName("tbody")[0];
			toRowlen = toTableTbodyobj.rows.length;
			
			for (var i = 0;i < toRowlen;i ++) {
				var trobj = toTableTbodyobj.rows[i];
				//size value
				var outputobj = trobj.getElementsByTagName("span")[0];
				//alert(selectedDiskSize+" "+outputobj.innerHTML);
				if(selectedDiskSize != outputobj.innerHTML) {
					return false;
				}
			}
			
			toTableobj = document.getElementById(namespace_g + "myForm:twoAddedDiskBTable");
			toTableTbodyobj = toTableobj.getElementsByTagName("tbody")[0];
			toRowlen = toTableTbodyobj.rows.length;
			
			for (var i = 0;i < toRowlen;i ++) {
				var trobj = toTableTbodyobj.rows[i];
				//size value
				var outputobj = trobj.getElementsByTagName("span")[0];
				//alert(selectedDiskSize+" "+outputobj.innerHTML);
				if(selectedDiskSize != outputobj.innerHTML) {
					return false;
				}
			}
		}
	}
	return true;
}

function moveRow(fromTable , toTable , ifcheck) {
	var widthArray = new Array()
	widthArray[0] = "10%"
	widthArray[1] = "40%"
	widthArray[2] = "25%"
	widthArray[3] = "25%";
	var fromTableobj = document.getElementById(fromTable);
	var fromTableTbodyobj = fromTableobj.getElementsByTagName("tbody")[0];
	var toTableobj = document.getElementById(toTable);
	var toTableTbodyobj = toTableobj.getElementsByTagName("tbody")[0];
	var rowlen = fromTableTbodyobj.rows.length;
	var trarray = new Array();
	for (var i = 0;i < rowlen;i ++) {
		var trobj = fromTableTbodyobj.rows[i];
		var inputobj = trobj.getElementsByTagName("input")[0];
		if (inputobj.type == "checkbox" && (inputobj.checked == ifcheck)) {
			trarray.push(trobj);
			if(fromTable==namespace_g + "myForm:availableDiskTable"){
				poolUsedDiskSizeArray.push(parseDecimalEscapeHTMLTag(trobj.cells[1].lastChild.lastChild.innerHTML));
			}else{
				removeDiskCapacity(parseDecimalEscapeHTMLTag(trobj.cells[1].lastChild.lastChild.innerHTML));
			}
			var classstyle = toTableTbodyobj.rows.length % 2 == 0 ? "dmc_rowClass1" : "dmc_rowClass2";
			var newrow = toTableTbodyobj.insertRow(toTableTbodyobj.rows.length);
			newrow.className = classstyle;
			newrow.valign = "top";
			//newrow.align = "left";
			inputobj.checked = false;
			
			for (var k = 0;k < trobj.cells.length;k ++) {
				var cell = document.createElement("td");
				newrow.appendChild(cell);
				cell.width = widthArray[k];
				cell.align = "left";
				cell.innerHTML = trobj.cells[k].innerHTML;
			}
		}
	}
	
	for (var j = 0;j < trarray.length;j ++) {
		fromTableTbodyobj.removeChild(trarray[j]);
	}
	refreshTableStyle(fromTableTbodyobj);
	saveData();
	//document.getElementById(toTable + "Div").focus();
	//document.getElementById(toTable + "Div").blur();
}

function removeDiskCapacity(cap){
	for(var i=0;i<poolUsedDiskSizeArray.length;i++){
		if((Number(poolUsedDiskSizeArray[i])-cap)==0){
			poolUsedDiskSizeArray.splice(i,1);
			return;
		}		
	}
}

function refreshTableStyle(tbodyobj) {
	var rowlen = tbodyobj.rows.length;
	for (var i = 0;i < rowlen;i ++) {
		if (i % 2 == 0) {
			tbodyobj.rows[i].className = "dmc_rowClass1";
		} else {
			tbodyobj.rows[i].className = "dmc_rowClass2";
		}
	}
}

function saveData() {
	var oneTablehidden = document.getElementById(namespace_g + "myForm:oneAddedDiskTableData");
	var twoATablehidden = document.getElementById(namespace_g + "myForm:twoAddedDiskATableData");
	var twoBTablehidden = document.getElementById(namespace_g + "myForm:twoAddedDiskBTableData");
	oneTablehidden.value = "";
	twoATablehidden.value = "";
	twoBTablehidden.value = "";
	
	var switches = retreiveType();
	if (switches == "1") {
		var oneTableobj = document.getElementById(namespace_g + "myForm:oneAddedDiskTable");
		var oneTableTbodyobj = oneTableobj.getElementsByTagName("tbody")[0];
		var rowlen = oneTableTbodyobj.rows.length;
		for (var i = 0;i < rowlen;i ++) {
			var onetrobj = oneTableTbodyobj.rows[i];
			var oneinputobj = onetrobj.getElementsByTagName("input");
			for (var kk = 0;kk < oneinputobj.length;kk ++) {
				if (oneinputobj[kk].type == "hidden") {
					oneTablehidden.value += oneinputobj[kk].value + "|";
				}
			}
		}
		oneTablehidden.value = oneTablehidden.value.substring(0 , oneTablehidden.value.length - 1);
		return;
	}
	
	if (switches == "2") {
		var twoATableobj = document.getElementById(namespace_g + "myForm:twoAddedDiskATable");
		var twoATableTbodyobj = twoATableobj.getElementsByTagName("tbody")[0];
		var rowAlen = twoATableTbodyobj.rows.length;
		for (var k = 0;k < rowAlen;k ++) {
			var twoAtrobj = twoATableTbodyobj.rows[k];
			var twoAinputobj = twoAtrobj.getElementsByTagName("input");
			for (var ii = 0;ii < twoAinputobj.length;ii ++) {
				if (twoAinputobj[ii].type == "hidden") {
					twoATablehidden.value += twoAinputobj[ii].value + "|";
				}
			}
		}
		
		twoATablehidden.value = twoATablehidden.value.substring(0 , twoATablehidden.value.length - 1);
		
		var twoBTableobj = document.getElementById(namespace_g + "myForm:twoAddedDiskBTable");
		var twoBTableTbodyobj = twoBTableobj.getElementsByTagName("tbody")[0];
		var rowBlen = twoBTableTbodyobj.rows.length;
		for (var j = 0;j < rowBlen;j ++) {
			var twoBtrobj = twoBTableTbodyobj.rows[j];
			var twoBinputobj = twoBtrobj.getElementsByTagName("input")[1];
			if (twoBinputobj.type == "hidden") {
				twoBTablehidden.value += twoBinputobj.value + "|";
			}
		}
		
		twoBTablehidden.value = twoBTablehidden.value.substring(0 , twoBTablehidden.value.length - 1);
		return;
	}
}

function retreiveType() {
	return retreiveElement("type");
}

function retreiveRaidLevel() {
	return retreiveElement("raid");
}

function retreiveElement(types) {
	var tag = document.getElementById(namespace_g + "myForm:tag").value;
	var selectValue = null;
	if( tag == "CreateAdvancedPool"){
		var selectValueobj = document.getElementById(namespace_g + "myForm:raidLevel");
		selectValue = selectValueobj.options[selectValueobj.selectedIndex].value;		
	}else if( tag == "ExpandPool"){
	    selectValue = document.getElementById(namespace_g + "myForm:raidLevel").value;	    	
	}
	
	if (types == "raid") {
		return selectValue;
	}

	var availableValue = document.getElementById(namespace_g + "myForm:tableTypeIndicator").value;
	var availableArray = availableValue.split("|");

	for (var i = 0;i < availableArray.length;i ++) {
		var mayvalue = availableArray[i].split("_")[0];
		var mayindicate = availableArray[i].split("_")[1];
		if (selectValue == mayvalue) {
			if (types == "type") {
				return mayindicate;
			}
		}
	}
}

function refreshInformation() {
	var raidLevel = retreiveRaidLevel();
	var switches = retreiveType();
	var requiredDisks = getRequiredDisks();

	//var requiredDisks = document.getElementById(namespace_g + "myForm:txtMinimumNumberOfDisks").innerHTML;
	var availablecount = countCheckBox("availableDiskTable" , false);
	var onecount = countCheckBox("oneAddedDiskTable" , false);
	var twoAcount = countCheckBox("twoAddedDiskATable" , false);
	var twoBcount = countCheckBox("twoAddedDiskBTable" , false);
	
	var singleCap = 0;
	
	var tag = document.getElementById(namespace_g + "myForm:tag").value;
	if( tag == "CreateAdvancedPool"){		
		singleCap = document.getElementById(namespace_g + "myForm:driveType");	
		singleCap = singleCap.options[singleCap.selectedIndex].value;	
		var driveTypeArray = singleCap.split(" ");
		singleCap = driveTypeArray[0];
	}else if( tag == "ExpandPool"){
	    var singleCapObject = document.getElementById(namespace_g + "myForm:diskNumber").nextSibling.nextSibling;
		if(singleCapObject!=null){
			singleCap = singleCapObject.innerHTML;
			singleCap = singleCap.substring(1 , singleCap.indexOf(" GB"));
			singleCap = Number(singleCap);
		}else{
			singleCap = 0;
		}
	}
	
	if( tag == "CreateAdvancedPool"){		    
		var addedNumber = document.getElementById(namespace_g + "myForm:txtAddedNumberOfDisks");	
		var txtAddedNumber = document.getElementById(namespace_g + "myForm:addedNumberOfDisks");
		var txtMinimumNumberOfDisks = document.getElementById(namespace_g + "myForm:txtMinimumNumberOfDisks");
		var minimumNumberOfDisks = document.getElementById(namespace_g + "myForm:minimumNumberOfDisks");
		var minimumPoolConfiguration = document.getElementById(namespace_g + "myForm:minimumPoolConfiguration");
		var txtMinimumPoolConfiguration = document.getElementById(namespace_g + "myForm:txtMinimumPoolConfiguration");
		var newPoolConfiguration = document.getElementById(namespace_g + "myForm:newPoolConfiguration");
		var txtNewPoolConfiguration = document.getElementById(namespace_g + "myForm:txtNewPoolConfiguration");
		var allSystemCapacity = document.getElementById(namespace_g + "myForm:allSystemCapacity");
		
		var totalCap = document.getElementById(namespace_g + "myForm:txtTotalNewPoolCapacity");
		var remainCap = document.getElementById(namespace_g + "myForm:txtRemainingSystemCapacity");
		
		totalCap.innerHTML = "0 GB";
		
		document.getElementById(namespace_g + "myForm:help_addedDisk_one").style.display = "none";
		document.getElementById(namespace_g + "myForm:help_addedDisk_two").style.display = "none";
		document.getElementById("space_one").style.display = "none";
		document.getElementById("space_two").style.display = "none";
		document.getElementById("space_one_2").style.display = "none";
		document.getElementById("space_two_2").style.display = "none";
		
		if (switches == "1") {
		//added by jiaoyong
			document.getElementById("oneRowA").style.display = "";
			document.getElementById("oneRowB").style.display = "";
			document.getElementById("twoRowA").style.display = "none";
			document.getElementById("twoRowB").style.display = "none";
			
			addedNumber.innerHTML = onecount;
			if (onecount >= requiredDisks) {
				if (raidLevel == RSSM_RAID_TYPE_RAID5) {
					// calculate the capacity for RAID 5
					totalCap.innerHTML = formatDecimal(getCapacityFromSelection(RSSM_RAID_TYPE_RAID5)) + " GB";
				} else {
					totalCap.innerHTML = formatDecimal(getCapacityFromSelection(RSSM_RAID_TYPE_RAID0)) + " GB";
				}
				document.getElementById("space_one").style.display = "";
				document.getElementById("space_one_2").style.display = "";
			} else {
				document.getElementById("space_one").style.display = "";
				document.getElementById(namespace_g + "myForm:help_addedDisk_one").style.display = "";
			}
		} else if (switches == "2") {
			//added by jiaoyong
			// modified by Jia Ming
			document.getElementById("oneRowA").style.display = "none";
			document.getElementById("oneRowB").style.display = "none";
			document.getElementById("twoRowA").style.display = "";
			document.getElementById("twoRowB").style.display = "";
			

			txtNewPoolConfiguration.innerHTML = twoAcount + "+" + twoBcount;

			if (twoAcount >= requiredDisks / 2 && twoBcount >= requiredDisks / 2 && twoAcount == twoBcount){
				totalCap.innerHTML = formatDecimal(getCapacityFromSelection(MIROR_RAID_TPYES)) + " GB";
				document.getElementById("space_two").style.display = "";
				document.getElementById("space_two_2").style.display = "";
			} else {
				document.getElementById("space_two").style.display = "";
				document.getElementById(namespace_g + "myForm:help_addedDisk_two").style.display = "";
			}
		}
		var usedCapacity = getTotalUsedCapacity();
		var remainCapacityInGB = Number(allSystemCapacity.innerHTML) - usedCapacity;
		if(remainCapacityInGB>1){
			remainCap.innerHTML = formatDecimal(remainCapacityInGB) + " GB";	
		}else{
			remainCap.innerHTML = "0 GB";	
		}
		
	}else if( tag == "ExpandPool"){	
		var totalCapacity = document.getElementById(namespace_g + "myForm:totalCapacity").innerHTML;
		
		var availableCapacity = document.getElementById(namespace_g + "myForm:hidden_availableCapacity").innerHTML;

		var diskNumber = document.getElementById(namespace_g + "myForm:diskNumber").innerHTML;
		var comeFrom = document.getElementById(namespace_g + "myForm:comeFrom").value;
		var neededCapacity = document.getElementById(namespace_g + "myForm:neededCapacity").value;
		var usedCapacity = totalCapacity - availableCapacity;
		
		var addedCapacity = 0;
		var newAvailable = 0;
		var addedDisk = 0;
		//if (comeFrom == comeFrom_ExpandVolume) {
			if (switches == "1") {
				document.getElementById(namespace_g + "myForm:value_right_1").innerHTML = onecount;
				document.getElementById(namespace_g + "myForm:value_right_2").innerHTML = formatDecimal(Number(totalCapacity) + Number(singleCap * onecount));
				document.getElementById(namespace_g + "myForm:value_right_2_gb").style.display = "";
				document.getElementById(namespace_g + "myForm:value_right_4").innerHTML = formatDecimal(singleCap * availablecount);
				
				var tempAvailableCapacity = Number(singleCap * onecount) + Number(availableCapacity);
				if (tempAvailableCapacity > neededCapacity) {
					document.getElementById(namespace_g + "myForm:value_right_3").innerHTML = formatDecimal(tempAvailableCapacity - neededCapacity);
					newAvailable = tempAvailableCapacity - neededCapacity;
				} else {
					document.getElementById(namespace_g + "myForm:value_right_3").innerHTML = availableCapacity;
				}
				changeNeededCapacity(tempAvailableCapacity , neededCapacity);
				addedCapacity = singleCap * onecount;
				addedDisk = onecount;
			} else if (switches == "2" && twoAcount == twoBcount) {
				document.getElementById(namespace_g + "myForm:value_right_1").innerHTML = Number(diskNumber/2) + " + " + Number(diskNumber/2);
				document.getElementById(namespace_g + "myForm:value_right_2").innerHTML = Number(diskNumber/2 + twoAcount) + " + " + Number(diskNumber/2 + twoAcount);
				document.getElementById(namespace_g + "myForm:value_right_2_gb").style.display = "none";
				document.getElementById(namespace_g + "myForm:value_right_3").innerHTML = formatDecimal(Number(totalCapacity) + Number(singleCap * twoAcount));
				document.getElementById(namespace_g + "myForm:value_right_5").innerHTML = formatDecimal(singleCap * availablecount);
				
				var tempAvailableCapacity = Number(singleCap * twoAcount) + Number(availableCapacity);
				if (tempAvailableCapacity > neededCapacity) {
					document.getElementById(namespace_g + "myForm:value_right_4").innerHTML = formatDecimal(tempAvailableCapacity - neededCapacity);
					newAvailable = tempAvailableCapacity - neededCapacity;
					changeNeededCapacity(tempAvailableCapacity - neededCapacity , neededCapacity);
				} else {
					document.getElementById(namespace_g + "myForm:value_right_4").innerHTML = formatDecimal(availableCapacity);
					changeNeededCapacity(tempAvailableCapacity , neededCapacity);
				}
				addedCapacity = singleCap * twoAcount;
				addedDisk = twoAcount * 2;
			}

		document.getElementById(namespace_g + "myForm:originalCapacity_confirmMessage").value = totalCapacity;
		document.getElementById(namespace_g + "myForm:additionalCapacity_confirmMessage").value = formatDecimal(addedCapacity);
		document.getElementById(namespace_g + "myForm:newTotalCapacity_confirmMessage").value = formatDecimal(Number(totalCapacity) + Number(addedCapacity));
		document.getElementById(namespace_g + "myForm:newAvailableCapacity_confirmMessage").value = formatDecimal(newAvailable);
		document.getElementById(namespace_g + "myForm:additionalDisks_confirmMessage").value = addedDisk;
	}
}

function getRequiredDisks() {
	var raidsRequired = document.getElementById(namespace_g + "myForm:requiredDisks").value;
	var raidstype = retreiveRaidLevel();
	var showArray = raidsRequired.split("|");
	for (var i = 0;i < showArray.length;i ++) {
		var typeArray = showArray[i].split("_");
		if (raidstype == typeArray[0]) {
			return typeArray[1];
		}
	}
}

function countCheckBox(tableid , needcheck) {
	var tblobj = document.getElementById(namespace_g + "myForm:" + tableid);
	var tbodyobj = tblobj.getElementsByTagName("tbody")[0];
	
	var rowlen = tbodyobj.rows.length;
	var count = 0;
	var inputobjs = tbodyobj.getElementsByTagName("input");
	for (var i = 0;i < inputobjs.length;i ++) {
		if (inputobjs[i].type == "checkbox" && (needcheck ? inputobjs[i].checked : true)) {
			count ++;
		}
	}
	
	return count;
}

function getAvailableSystemCapacity(fromTable){
	var fromTableobj = document.getElementById(fromTable);
	var fromTableTbodyobj = fromTableobj.getElementsByTagName("tbody")[0]; // !
	var rowlen = fromTableTbodyobj.rows.length;
	var availableCapacity = 0;
	for (var i = 0;i < rowlen;i ++) {
		var trobj = fromTableTbodyobj.rows[i];
		availableCapacity+=parseDecimalEscapeHTMLTag(trobj.cells[1].lastChild.lastChild.innerHTML);
	}
	return availableCapacity;
}

function getTotalUsedCapacity(){
	var capacity = 0;
	var diskcount = poolUsedDiskSizeArray.length;
	for(var i=0;i<diskcount;i++){
		var cap = Number(poolUsedDiskSizeArray[i]);
		capacity = Number(capacity+cap);
	}
	return capacity;
}

function getAvailableDiskArray(tableId,index){
    var diskAry = new Array();
	var tableObj = document.getElementById(tableId);
	var tbodyObj = tableObj.getElementsByTagName("tbody")[0];
	var rowlen = tbodyObj.rows.length;
	for (var i = 0;i < rowlen;i ++) {
		var trobj = tbodyObj.rows[i];
		//diskAry.push(parseDecimal(trobj.cells[index].lastChild.lastChild.innerHTML));
	}
	return diskAry;
}

function changeNeededCapacity(availableCapacity, neededCapacity) {
	availableCapacity = Number(availableCapacity);
	neededCapacity = Number(neededCapacity);
	if( neededCapacity > availableCapacity ){
	    document.getElementById("AvailablePoolCapacityTR").style.display = "none";
	    document.getElementById("AdditionalCapacityNeededTR").style.display = "";
	    
	    var showNeededCapacity = neededCapacity - availableCapacity;
	    document.getElementById(namespace_g + "myForm:additionCapacityNeeded").innerHTML = formatDecimal(showNeededCapacity);
	}else{
   		document.getElementById("AvailablePoolCapacityTR").style.display = "";
	    document.getElementById("AdditionalCapacityNeededTR").style.display = "none";
	    var showAvailableCapacity = availableCapacity - neededCapacity;
	    document.getElementById(namespace_g + "myForm:availableCapacity").innerHTML = formatDecimal(showAvailableCapacity);
	}	
}

function refreshButton() {
    var flag = true;//return result that store the previous isNext
	var raidstype = retreiveRaidLevel();
	var requiredDisk = getRequiredDisks();
	var nameEmpty = true;
	
	var availablecount = countCheckBox("availableDiskTable" , true);
	var onecount = countCheckBox("oneAddedDiskTable" , true);
	var oneallcount = countCheckBox("oneAddedDiskTable" , false);
	var twoAcount = countCheckBox("twoAddedDiskATable" , true);
	var twoBcount = countCheckBox("twoAddedDiskBTable" , true);
	var twoAallcount = countCheckBox("twoAddedDiskATable" , false);
	var twoBallcount = countCheckBox("twoAddedDiskBTable" , false);
	
	var addoneButton = document.getElementById(namespace_g + "myForm:oneAddedDiskAddButton");
	var removeoneButton = document.getElementById(namespace_g + "myForm:oneAddedDiskRemoveButton");
	var addtwoupButton = document.getElementById(namespace_g + "myForm:twoAddedDiskUpAddButton");
	var addtwodownButton = document.getElementById(namespace_g + "myForm:twoAddedDiskDownAddButton");
	var removetwoupButton = document.getElementById(namespace_g + "myForm:twoAddedDiskUpRemoveButton");
	var removetwodownButton = document.getElementById(namespace_g + "myForm:twoAddedDiskDownRemoveButton");
		
	var raid1Error = document.getElementById("selectionErrorTR");
	
	var okButton = document.getElementById(namespace_g + "myForm:okbutton");
	var nextInd = document.getElementById(namespace_g + "myForm:isNext");
	var tag = document.getElementById(namespace_g + "myForm:tag").value;
	
	document.getElementById(namespace_g + "myForm:selectedNumber").innerHTML = countCheckBox("availableDiskTable" , true);

	if (raidstype == RSSM_RAID_TYPE_RAID5 || raidstype == RSSM_RAID_TYPE_RAID0) {
		
		/* --- refresh add and remove button --- */
		if (availablecount > 0) {
			addoneButton.disabled = "";
		} else {
			addoneButton.disabled = "disabled";
		}

		if (onecount > 0) {
			removeoneButton.disabled = "";
		} else {
			removeoneButton.disabled = "disabled";
		}
		/* --- end of refresh add and remove button --- */
		
		/* --- refresh ok button --- */
		if (tag == "CreateAdvancedPool") {
			if (oneallcount >= requiredDisk) {
				if (okButton) {
					okButton.disabled = "";
				}
				if(!nameEmpty)
					flag = true;
			} else {
				if (okButton) {
					okButton.disabled = "disabled";
				}
				flag = false;
			}
		} else if (tag == "ExpandPool") {
			if (document.getElementById("AdditionalCapacityNeededTR").style.display == "none" && oneallcount > 0) {
				flag = true;
			} else {
				flag = false;
			}
		}		
		/* --- end of refresh ok button --- */
		if (parent) {
			parent.refreshNext();
		}

			raid1Error.style.display='none';
		
		return flag;
	}
	
	if (raidstype == RSSM_RAID_TYPE_RAID10) {
	
		/* --- refresh add and remove button --- */
		if (availablecount > 0) {
			addtwoupButton.disabled = "";
			addtwodownButton.disabled = "";
		} else {
			addtwoupButton.disabled = "disabled";
			addtwodownButton.disabled = "disabled";
		}
		if (twoAcount > 0) {
			removetwoupButton.disabled = "";
		} else {
			removetwoupButton.disabled = "disabled";
		}
		if (twoBcount > 0) {
			removetwodownButton.disabled = "";
		} else {
			removetwodownButton.disabled = "disabled";
		}
		/* --- end of refresh add and remove button --- */
		
		/* --- refresh ok button --- */
		if (tag == "CreateAdvancedPool") {
			if (twoAallcount >= requiredDisk / 2 && twoBallcount >= requiredDisk / 2 && twoAallcount == twoBallcount) {
				if (okButton) {
					okButton.disabled = "";
				}
				flag = true;
			} else {
				if (okButton) {
					okButton.disabled = "disabled";
				}
				flag = false;
			}
		} else if (tag == "ExpandPool") {
			if (twoAallcount == twoBallcount && twoAallcount > 0 && document.getElementById("AdditionalCapacityNeededTR").style.display == "none") {
				flag = true;
			} else {
				flag = false;
			}
		}
		/* --- end of refresh ok button --- */
		
		if (parent) {
			parent.refreshNext();
		}
		
		raid1Error.style.display='none';
		return flag;
	}
	
	if (raidstype == RSSM_RAID_TYPE_RAID1) {
	
		/* --- refresh add and remove button --- */
		if (availablecount > 0 && availablecount < 2) {
			var error = true;
			if (twoAallcount == 0) {
				addtwoupButton.disabled = "";
				error = false;
			} else {
				addtwoupButton.disabled = "disabled";
			}
			
			if (twoBallcount == 0) {
				addtwodownButton.disabled = "";
				error = false;
			} else {
				addtwodownButton.disabled = "disabled";
			}
			
			if(error){
				raid1Error.style.display='';
			} else {
				raid1Error.style.display='none';
			}
		} else {
			addtwoupButton.disabled = "disabled";
			addtwodownButton.disabled = "disabled";
			if(availablecount >= 2){
				raid1Error.style.display='';
			} else {
				raid1Error.style.display='none';
			}
		}
		
		if (twoAcount == 1) {
			removetwoupButton.disabled = "";
		} else {
			removetwoupButton.disabled = "disabled";
		}
		
		if (twoBcount == 1) {
			removetwodownButton.disabled = "";
		} else {
			removetwodownButton.disabled = "disabled";
		}
		/* --- end of refresh add and remove button --- */
		
		/* --- refresh ok button --- */
		if (tag == "CreateAdvancedPool") {
			if (twoAallcount == requiredDisk / 2 && twoBallcount == requiredDisk /2 ) {
				if (okButton) {
					okButton.disabled = "";
				}
				flag = true;
			} else {
				if (okButton) {
					okButton.disabled = "disabled";
				}
				flag = false;
			}
		} else if (tag == "ExpandPool") {
			flag = false;
		}
		/* --- end of refresh ok button --- */
		
		if (parent) {
			parent.refreshNext();
		}
		
		return flag;
	}
}

function diskSelectionOnAjaxComplete(){
	enablePoolNameInput();
	init_PostLoad();
	beepWhenRefresh();
	innerMessagesInstance.display();
	setTimeout(lazyAdjustCreatePoolAdvancePathColumntWidth,200);
	SCMJsManager.getAttrManager().executeBinding();
}
function lazyAdjustCreatePoolAdvancePathColumntWidth(){
	alignHeaderTableAndContentTable('headerTableDivId','availableDiskTable');
	alignHeaderTableAndContentTable('headerTableDivId1','oneAddedDiskTable');
	alignHeaderTableAndContentTable('headerTableDivId2','twoAddedDiskATable');
	alignHeaderTableAndContentTable('headerTableDivId3','twoAddedDiskBTable');
}
