/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

var definedVolumes_page = "DefinedVolumes";
var definedVolumes_confirm = "DefinedVolumes_Confirm";

var name_null_ErrMsg = null;
var capacity_null_ErrMsg = null;
var quantity_null_ErrMsg = null;
var nameSuffix_null_ErrMsg = null;

var PoolNameErrMsg = null;
var quantity_size_ErrMsg = null;
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 1999, 2010 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

var capacity_size_ErrMsg = null;
var findDefinedName_ErrMsg = null;
var volumesNum_ErrMsg = null;
var non_numeric_ErrMsg = null;
var nameLength_ErrMsg = null;
var nameCharacters_ErrMsg = null;
var capacity_exceedAvailableCapacity_ErrMsg = null;
var no_availableCapacity_ErrMsg = null;

var capacity_min_ErrMsg = null;
var capacity_minimum_size_ErrMsg = null;
var quantity_min_ErrMsg = null;
var quantity_non_numeric_ErrMsg = null;
var nameSuffix_non_numeric_ErrMsg = null;
var nameSuffix_min_ErrMsg = null;
var nameSuffix_max_ErrMsg = null;

var maxCapacity = 32768;
var maxQuantity = 128;

var errorMsg_tr = new Array();
errorMsg_tr[0] = "nameMsg_tr";
errorMsg_tr[1] = "capacityMsg_tr";
errorMsg_tr[2] = "quantityMsg_tr";
errorMsg_tr[3] = "nameSuffixMsg_tr";

var errorMsg_span = new Array();
errorMsg_span[0] = "nameMsg_span";
errorMsg_span[1] = "capacityMsg_span";
errorMsg_span[2] = "quantityMsg_span";
errorMsg_span[3] = "nameSuffixMsg_span";

// DefineVolumes onLoad method
function onLoad_DefineVolumes(){
	setVolumeInputsStatus(true);
	LoadCommonPage();
   	initDefineVolumesMessage(); 
   	// initial error message	
	initErrorMessage();
}

function LoadCommonPage() {
	refreshBodyMargin();
	lazyLoad();
	if (parent) {
		parent.refreshNext();
	}
}

// delay the loading time
function lazyLoad() {
	setTimeout(lazyDo ,5);	
}

// trigger Ajax call				
function lazyDo() {
	var obj = document.getElementById(namespace_g + "myForm:clickbtn");
	obj.click();
}

function refreshBodyMargin() {
	document.getElementsByTagName("body")[0].className = "wizardFrameBody";
}

function setVolumeInputsStatus(isDisabled) {
	document.getElementById(namespace_g + "myForm:name").disabled = isDisabled;
	document.getElementById(namespace_g + "myForm:capacity").disabled = isDisabled;
	document.getElementById(namespace_g + "myForm:quantity").disabled = isDisabled;
	document.getElementById(namespace_g + "myForm:nameSuffix").disabled = isDisabled;
}

// [DefineVolumes.jsp]init error message
function initDefineVolumesMessage(){
	name_null_ErrMsg = document.getElementById(namespace_g + "myForm:name_null_ErrMsg").innerHTML;
	capacity_null_ErrMsg = document.getElementById(namespace_g + "myForm:capacity_null_ErrMsg").innerHTML;
	quantity_null_ErrMsg = document.getElementById(namespace_g + "myForm:quantity_null_ErrMsg").innerHTML;
	nameSuffix_null_ErrMsg = document.getElementById(namespace_g + "myForm:nameSuffix_null_ErrMsg").innerHTML; 
	quantity_size_ErrMsg = document.getElementById(namespace_g + "myForm:quantity_size_ErrMsg").innerHTML;
	capacity_size_ErrMsg = document.getElementById(namespace_g + "myForm:capacity_size_ErrMsg").innerHTML;

	capacity_exceedAvailableCapacity_ErrMsg = document.getElementById(namespace_g + "myForm:capacity_exceedAvailableCapacity_ErrMsg").innerHTML;
	findDefinedName_ErrMsg = document.getElementById(namespace_g + "myForm:findDefinedName_ErrMsg").innerHTML;					
	volumesNum_ErrMsg = document.getElementById(namespace_g + "myForm:volumesNum_ErrMsg").innerHTML;
	non_numeric_ErrMsg = document.getElementById(namespace_g + "myForm:non_numeric_ErrMsg").innerHTML;
	three_decima_ErrMsg = document.getElementById(namespace_g + "myForm:threeDecima_ErrMsg").innerHTML;	
	nameLength_ErrMsg = document.getElementById(namespace_g + "myForm:nameLength_ErrMsg").innerHTML;
	nameCharacters_ErrMsg = document.getElementById(namespace_g + "myForm:nameCharacters_ErrMsg").innerHTML;
	no_availableCapacity_ErrMsg = document.getElementById(namespace_g + "myForm:no_availableCapacity_ErrMsg").innerHTML;
	
	capacity_min_ErrMsg = document.getElementById(namespace_g + "myForm:capacity_min_ErrMsg").innerHTML;
	capacity_minimum_size_ErrMsg = document.getElementById(namespace_g + "myForm:capacity_minimum_size_ErrMsg").innerHTML;
	quantity_non_numeric_ErrMsg = document.getElementById(namespace_g + "myForm:quantity_non_numeric_ErrMsg").innerHTML;
	quantity_min_ErrMsg = document.getElementById(namespace_g + "myForm:quantity_min_ErrMsg").innerHTML;
	nameSuffix_non_numeric_ErrMsg = document.getElementById(namespace_g + "myForm:nameSuffix_non_numeric_ErrMsg").innerHTML;
	nameSuffix_min_ErrMsg = document.getElementById(namespace_g + "myForm:nameSuffix_min_ErrMsg").innerHTML;
	nameSuffix_max_ErrMsg = document.getElementById(namespace_g + "myForm:nameSuffix_max_ErrMsg").innerHTML;
}

function defineVolume_ajaxB() {
	setTimeout(defineVolume_ajaxB_click , 5);
}

function defineVolume_ajaxB_click() {
    document.getElementById(namespace_g + "myForm:load").value = "loadFinished";    
	document.getElementById(namespace_g + "myForm:ajaxBbutton").click();
}

/* ------- validate pool name suffix ------ */
function validateNameSuffix(id){
    var nameSuffixValue = document.getElementById(id).value;
	if (nameSuffixValue == null || !(nameSuffixValue.match("[0-9]+") == nameSuffixValue)) {
		showErrorMsg('nameSuffixMsg_tr','nameSuffixMsg_span', nameSuffix_non_numeric_ErrMsg);
		return false;
	}
	
	if (nameSuffixValue == "0"){
		showErrorMsg('nameSuffixMsg_tr','nameSuffixMsg_span', nameSuffix_min_ErrMsg);
		return false;
	}
	
	if( !validateNumber(nameSuffixValue)){
		showErrorMsg('nameSuffixMsg_tr','nameSuffixMsg_span', nameSuffix_non_numeric_ErrMsg);
		return false;
	}
	
	clearItemErrorMsg(3);
	return true;
}

function validateNameSuffixWithoutErrorMsg(id){
    var nameSuffixValue = document.getElementById(id).value;
	if( !validateNumber(nameSuffixValue)){
		return false;
	}
	
	if( Number(nameSuffixValue) < 1){
		return false;
	}
	
	return true;
}

//validate number
var NUMBER_PATTERN = "[1-9]+[0-9]*";
function validateNumber(value){
  if( value != null){
	  if( value.match(NUMBER_PATTERN) == value){
	  	  return true;
	  } else{
	  	  return false;
	  }
  }
}

function validateMaxIntegerWithoutErrorMsg(_value){
	var Integer_MAX_VALUE = 2147483647;
	
 	if( Number(_value) > Integer_MAX_VALUE){
		return false;
	}else{
	    return true;
	}
}

function validateMaxInteger(_value){
	var Integer_MAX_VALUE = 2147483647;
	
 	if( Number(_value) > Integer_MAX_VALUE){
		showErrorMsg('nameSuffixMsg_tr','nameSuffixMsg_span', nameSuffix_max_ErrMsg);
		return false;
	}else{
	    return true;
	}
}

/* ------- validate pool quantity ------ */
function validateQuantity(id){
   var quantityValue = document.getElementById(id).value;
   var createdVolumeNumber = document.getElementById(namespace_g + "myForm:createdVolumeNumber").innerHTML - 0;
   var prepareVolumesNumber = document.getElementById(namespace_g + "myForm:prepareVolumesNumber").innerHTML - 0;
    
	if( quantityValue == ""){
	    showErrorMsg('quantityMsg_tr','quantityMsg_span', quantity_null_ErrMsg);
	    return false;
	}else if( parseDecimal(quantityValue)==null){
		showErrorMsg('quantityMsg_tr','quantityMsg_span', quantity_non_numeric_ErrMsg);
		return false;
	}
    var quantity = parseDecimal(quantityValue);
	
    if( quantity < 1 ){
       showErrorMsg('quantityMsg_tr','quantityMsg_span', quantity_min_ErrMsg);
       return false;
    }
   
 	if( quantity > maxQuantity){
       showErrorMsg('quantityMsg_tr','quantityMsg_span', volumesNum_ErrMsg);
       return false;
    }

   if( quantity == 1 || quantity == 0){
       document.getElementById(namespace_g + "myForm:nameSuffix").value = "";
       document.getElementById(namespace_g + "myForm:nameSuffix").disabled = true;
   }else if(quantity > 1){
   		if (document.getElementById(namespace_g + "myForm:nameSuffix").value == "") {
   	   		document.getElementById(namespace_g + "myForm:nameSuffix").value = "1";
   	   	}
       document.getElementById(namespace_g + "myForm:nameSuffix").disabled = false;
   }
   
   var sum = Number(quantityValue) + Number(createdVolumeNumber) + Number(prepareVolumesNumber);;
   if( sum > maxQuantity){
       showErrorMsg('quantityMsg_tr','quantityMsg_span', volumesNum_ErrMsg);
       return false;
   }
   
   clearItemErrorMsg(2);     
   return true;   
}

function validateQuantityWithoutErrorMsg(id,fromEvent){
   var quantityValue = document.getElementById(id).value;
   var createdVolumeNumber = document.getElementById(namespace_g + "myForm:createdVolumeNumber").innerHTML - 0;
   var prepareVolumesNumber = document.getElementById(namespace_g + "myForm:prepareVolumesNumber").innerHTML - 0;
    
	if( quantityValue == ""){
	    return false;
	}else if( !validateNumber(quantityValue) ){
		return false;
	}

    if( quantityValue < 1 ){
       return false;
    }
   
 	if( quantityValue > maxQuantity){
       return false;
    }

   if( quantityValue == 1 || quantityValue == 0){
       document.getElementById(namespace_g + "myForm:nameSuffix").value = "";
       document.getElementById(namespace_g + "myForm:nameSuffix").disabled = true;
   }else if(quantityValue > 1){
   		if (document.getElementById(namespace_g + "myForm:nameSuffix").value == ""&&
   		    fromEvent=="onblur") {
   	   		document.getElementById(namespace_g + "myForm:nameSuffix").value = "1";
   	   	}
       document.getElementById(namespace_g + "myForm:nameSuffix").disabled = false;
   }
   
   var sum = Number(quantityValue) + Number(createdVolumeNumber) + Number(prepareVolumesNumber);;
   if( sum > maxQuantity){
       return false;
   }
   return true;   
}

//defect 7170,add by qiuhongyan.
function validateNameWithoutErrorMsg(id){
	var name = document.getElementById(id).value;
	var nameSuffix = document.getElementById(namespace_g + "myForm:nameSuffix").value;
	var quantity = Number(document.getElementById(namespace_g + "myForm:quantity").value);	
	var sumLength = 0;
	if( name == ""){
	    return false;
	}
	
	
	//Since quantity and suffix is validated before validating name, here consider quantity and suffix are valid.
	//Change the algorithm of getting the longest name length for defect CQ11249
	if(quantity == 1){
		sumLength = name.length + nameSuffix.length;
	}else{// other valid quantity values are greater than 1
		sumLength = name.length + ((Number(nameSuffix)+quantity-1)+"").length;
	}
	if( sumLength > 12 || sumLength < 1 || name.length == 0 ){	    
	    return false;
	}
	
	if( !isDeviceNameValid(name)){
	    return false;
	}
	
	return true;   
}

/* ------- validate pool name ------ */
function validateName(id){
	var name = document.getElementById(id).value;
	var nameSuffix = document.getElementById(namespace_g + "myForm:nameSuffix").value;
	var quantity = Number(document.getElementById(namespace_g + "myForm:quantity").value);	
	var sumLength = 0;
	if( name == ""){
	    showErrorMsg('nameMsg_tr','nameMsg_span', name_null_ErrMsg);  
	    return false;
	}
	
	//Since quantity and suffix is validated before validating name, here consider quantity and suffix are valid.
	//Change the algorithm of getting the longest name length for defect CQ11249
	if(quantity == 1){
		sumLength = name.length + nameSuffix.length;
	}else{// other valid quantity values are greater than 1
		sumLength = name.length + ((Number(nameSuffix)+quantity-1)+"").length;
	}
	
	if( sumLength > 12 || sumLength < 1 || name.length == 0 ){	    
	    showErrorMsg('nameMsg_tr','nameMsg_span', nameLength_ErrMsg); 
	    return false;
	}
	
	if( !isDeviceNameValid(name)){
	    showErrorMsg('nameMsg_tr','nameMsg_span', nameCharacters_ErrMsg); 
	    return false;
	}
	
	clearItemErrorMsg(0);
	return true;    
}

/* ------- validate pool capacity ------ */
function validateCapacity(id){	
    var capacityValue = document.getElementById(id).value;

	if(capacityValue.length == 0){
	    showErrorMsg('capacityMsg_tr','capacityMsg_span', capacity_null_ErrMsg);
	    return false;
	}
	 
	var capNum = parseDecimal(capacityValue);
	if(capNum==null) {
		showErrorMsg('capacityMsg_tr','capacityMsg_span', non_numeric_ErrMsg);	
		return false;
	}
	
	if( capNum <= 0){
  		showErrorMsg('capacityMsg_tr','capacityMsg_span', capacity_minimum_size_ErrMsg);
  		return false;
  	}

  	if(capNum > maxCapacity){	
        showErrorMsg('capacityMsg_tr','capacityMsg_span', capacity_size_ErrMsg);
  		return false;
  	} 
	/* now the define volume support float value
	 * commented by jmzhang
	 **/
	/*
	if (capacityValue.indexOf(".") > 0 && capacityValue.substring(capacityValue.lastIndexOf(".")+1).length > 3) {
		showErrorMsg('capacityMsg_tr','capacityMsg_span', three_decima_ErrMsg);
		return false;		
	}*/
	var addDecimalValue = String(getDecimal(capNum));
	if (addDecimalValue.length > 5) {	
		showErrorMsg('capacityMsg_tr','capacityMsg_span', three_decima_ErrMsg);
			return false;
	}

  	clearItemErrorMsg(1);
  	return true;
}

/* ------- validate availablecapacity ------ */
function validateexceedCapacity(){
	var newAvailableCapacity = Number(document.getElementById(namespace_g + "myForm:newAvailableCapacityLongValue").innerHTML);
	var capacityValue = parseDecimal(document.getElementById(namespace_g + "myForm:capacity").value);
	var quantityValue = parseDecimal(document.getElementById(namespace_g + "myForm:quantity").value); 
	var nameSuffixValue = document.getElementById(namespace_g + "myForm:nameSuffix").value; 
	if((newAvailableCapacity/1024/1024/1024) < quantityValue * capacityValue){
		showErrorMsg('capacityMsg_tr','capacityMsg_span', capacity_exceedAvailableCapacity_ErrMsg);
	    return false;
	}
	
	return true;
}

// common function : show error message 
function showErrorMsg(id_tr, id_span, errorMsg) {
   var objTr = document.getElementById(id_tr);
   var objSpan = document.getElementById(id_span);
	
   objTr.style.display="";
   objSpan.style.display = "";
   objSpan.innerHTML = errorMsg;  
   //defect 10385, add a popup dialog to indicate error happen, support accessbility  
   document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
}

function clearItemErrorMsg(errIndex){
    document.getElementById(errorMsg_tr[errIndex]).display="none";
    document.getElementById(errorMsg_span[errIndex]).innerHTML="";
}

function generateVolumeName(fromEvent){
	var allCreatedVolumeNameStr = "," + document.getElementById(namespace_g + "myForm:allCreatedVolumeNameStr").innerHTML;
	var nameObj = document.getElementById(namespace_g + "myForm:name");
	var quantityObj = document.getElementById(namespace_g + "myForm:quantity");	
	var nameSuffixObj = document.getElementById(namespace_g + "myForm:nameSuffix");
	var result = true;
	var newName = "";
	if( nameObj.value != ""){
		
		if( nameSuffixObj.value != ""){
			if( ! validateNameSuffixWithoutErrorMsg(nameSuffixObj.id)){
			 	result = false;
			}
			
			if( ! validateMaxIntegerWithoutErrorMsg(nameSuffixObj.value)){
			    result = false;
			}
		}
		if( quantityObj.value != ""){
			if( ! validateQuantityWithoutErrorMsg(quantityObj.id,fromEvent)){
	     		result = false;
			}				
		}
		if (result) {
			if (!validateNameWithoutErrorMsg(nameObj.id)) {
				result = false;
			}
		}
		if( result){
			if( nameSuffixObj.value == ""){
				newName = nameObj.value;
			}else if(quantityObj.value != ""){
				var beginName = nameObj.value + parseInt(nameSuffixObj.value);					
				var index = parseInt(nameSuffixObj.value) + parseInt(quantityObj.value - 1);
				if( ! validateMaxInteger(index)){
				    newName = nameObj.value;
				}else{
					var endName = nameObj.value + index;
					newName = beginName + "-" + endName; 		
				}					
			}			
		}
	}

	document.getElementById(namespace_g + "myForm:exampleName").innerHTML = newName;
	return result;
}


function disableSuffixField(){
	var quantityValue = document.getElementById(namespace_g + "myForm:quantity").value;
	var nameSuffixObj = document.getElementById(namespace_g + "myForm:nameSuffix");
	if(""!=quantityValue && validateNumber(quantityValue) && quantityValue > 1){
		if(""==nameSuffixObj.value){
			nameSuffixObj.value = "1";
		}
		nameSuffixObj.disabled = false;
	}else{
		nameSuffixObj.value = "";
		nameSuffixObj.disabled = true;
	}
	
}

function setVolumeInputsStatus(isDisabled) {
	document.getElementById(namespace_g + "myForm:name").disabled = isDisabled;
	document.getElementById(namespace_g + "myForm:capacity").disabled = isDisabled;
	document.getElementById(namespace_g + "myForm:quantity").disabled = isDisabled;
	document.getElementById(namespace_g + "myForm:nameSuffix").disabled = isDisabled;
}

/*
 * count the selected checkbox in DefineVolumes page
 */
function countSelectedCheckBox(tableID){
	var count = 0;
	var tableObj = document.getElementById(tableID);	
	var inputobjs = tableObj.getElementsByTagName("input");
	for (var i = 0;i < inputobjs.length;i ++) {
		if (inputobjs[i].type == "checkbox" && inputobjs[i].checked ) {
			count ++;
		}
	}
	return count;
}

function refreshRemoveButton(){
	var count = countSelectedCheckBox(namespace_g + "myForm:newVolumesTable");
	if( count > 0){
	    document.getElementById(namespace_g + 'myForm:removeButton').disabled = false;
	}else{
		document.getElementById(namespace_g + 'myForm:removeButton').disabled = true;
	}
}

// Define Volumes JS begin
// init button disabled
function initPageButton(){
	var prepareVolumesNumber = document.getElementById(namespace_g + "myForm:prepareVolumesNumber").innerHTML - 0;
	document.getElementById(namespace_g + "myForm:addButton").disabled = false;
			
	var quantity = document.getElementById(namespace_g + "myForm:quantity").value;
	if( quantity == ""){
		document.getElementById(namespace_g + "myForm:quantity").value = "1";
	}

	if( prepareVolumesNumber > 0){		    
	    for(var i=0; i < prepareVolumesNumber; i++){
			var checkbox  = document.getElementById(namespace_g + "myForm:newVolumesTable:"+i+":rowSelect1");
			if( checkbox){
				checkbox.checked = false;
			}
		}	
	}
	
	refreshRemoveButton();	
	
	//indicate that the cursor should be placed in the first field(name) on the page by default.
	if (parent) {
		if( parent.getFrame("step_iframe").document.getElementById(parent.getFrame("step_iframe").namespace_g + "myForm:name") != null){	
			parent.getFrame("step_iframe").focus();   
			parent.getFrame("step_iframe").document.getElementById(parent.getFrame("step_iframe").namespace_g + "myForm:name").focus();
		}
	}else{
		document.getElementById(namespace_g + "myForm:name").focus();
	}
}

/* ------- show allcated bar ------ */
function overlapTables()
{
	var allocated = Number(document.getElementById(namespace_g + "myForm:allocated").innerHTML);
	
	if(allocated != 0){
		if(document.getElementById("td1").style.display != ""){
			document.getElementById("td1").style.display = "";
		}
		document.getElementById("td1").style.width = allocated;
		document.getElementById("td2").style.width = 100-allocated;
	}else{
		document.getElementById("td1").style.display = "none";
	}
	 
}

function refreshVolumeNext() {
	if(document.getElementById(namespace_g + 'myForm:isMandatory').value == 'true'){
		if(document.getElementById(namespace_g + 'myForm:newVolumesTable').rows.length > 0) {
			document.getElementById(namespace_g + 'myForm:isNext').value='true';
			
		} else {
			document.getElementById(namespace_g + 'myForm:isNext').value='false';
			
		}
		parent.refreshNext();
	}
	
	document.getElementById(namespace_g + 'myForm:name').value='';
	document.getElementById(namespace_g + 'myForm:capacity').value='';
	document.getElementById(namespace_g + 'myForm:quantity').value='1';
	document.getElementById(namespace_g + 'myForm:nameSuffix').value='';
	
	disableSuffixField();
}

// validate defineVolume precondition
function defineVolumePrecondition(){
	var volumeNum = document.getElementById(namespace_g + "myForm:volumeNum").innerHTML;
	if( volumeNum >= maxQuantity){
	    var message = document.getElementById(namespace_g + "myForm:ReachMaxVolumeNumber_InfoMsg").innerHTML;
		// clear old info message
	    innerMessagesInstance.clearSpecialMessage();
	    // show new info message
	    innerMessagesInstance.showSpecialMessage(message);
	    //disabled all fields 
	    
	    document.getElementById(namespace_g + "myForm:name").disabled = true;
	    document.getElementById(namespace_g + "myForm:capacity").disabled = true;
	    document.getElementById(namespace_g + "myForm:quantity").disabled = true;
	    document.getElementById(namespace_g + "myForm:nameSuffix").disabled = true;
	    document.getElementById(namespace_g + "myForm:addButton").disabled = true;
	    document.getElementById(namespace_g + "myForm:removeButton").disabled = true;	   
	}
}

function enableAddButton(){
    document.getElementById(namespace_g + "myForm:addButton").disabled=false;
}

/*
 * select checkbox action in DefineVolumes page
 */
function selectCheckBox_defineVolumes(){	
	refreshRemoveButton();
	//selectOnlyOneCheckBox(_object.id);
	//selectedCheckBoxID = _object.id; 
}

function validateRemove(){
	document.getElementById(namespace_g + "myForm:actionStr").value = "removeVolume";
	document.getElementById(namespace_g + "myForm:removeButton").disabled = true;	
	
	//submit the remove action
	document.getElementById(namespace_g + "myForm:load").value = "loadFinished";
	document.getElementById(namespace_g + "myForm:clickbtn").click();	
	
	// disabled radioBox in newVolumesTable when remove volume
	var tableObj = document.getElementById(namespace_g + "myForm:newVolumesTable");
	if( tableObj){
		var checkboxesobj = tableObj.getElementsByTagName("input");
		for (var i = 0;i < checkboxesobj.length;i ++) {
			 if (checkboxesobj[i].type == "checkbox" || checkboxesobj[i].checked == false) {
				 checkboxesobj[i].disabled = true;
			 }
		}
	}	
}

function validateSubmit(pageTitle, _event, target, width, height){
	var result = true;
	var isPopup_confirmDialog = false;
	var isNext = document.getElementById(namespace_g + "myForm:isNext");
	popup_dialog(width, height);
	return result;
}

//clear the iframe src when closing the pannelDialog
function clearFrame(){
	var iframeObj;
	var iframeDIVObj;
	
	if( document.getElementById('templ_u_iframe')){
		iframeObj = document.getElementById("templ_u_iframe");
	   	iframeDIVObj = document.getElementById("templ_u_iframe_div");
	}else if( parent.document.getElementById('templ_u_iframe')){
	   	iframeObj = parent.document.getElementById("templ_u_iframe");
	   	iframeDIVObj = parent.document.getElementById("templ_u_iframe_div");
	}

	if( iframeObj.src != ''){
		iframeObj.src = '';	
		iframeDIVObj.style.visibility= "hidden";	
	}					
}

/* ------- validate the new volumes  ------ */
function validateAdd(){
	//document.getElementById(namespace_g + "myForm:addButton").disabled=true;
	
	var allCreatedVolumeNameStr = "," + document.getElementById(namespace_g + "myForm:allCreatedVolumeNameStr").innerHTML;
	var nameObj = document.getElementById(namespace_g + "myForm:name");
	var quantityObj = document.getElementById(namespace_g + "myForm:quantity");	
	var capacityObj = document.getElementById(namespace_g + "myForm:capacity");
	var nameSuffixObj = document.getElementById(namespace_g + "myForm:nameSuffix");
	var result = true;
	//Since validate name need correct quantity, validate quantity first.
	var quantityIntValue = parseDecimal(quantityObj.value);
	if( ! validateQuantity(quantityObj.id)){
	     result = false;
	}
	else if( quantityIntValue > 1 && nameSuffixObj.value == ""){
		showErrorMsg('nameSuffixMsg_tr','nameSuffixMsg_span', nameSuffix_null_ErrMsg);		
		result = false;
	}
	else if( nameSuffixObj.value != ""){
		if( ! validateNameSuffix(nameSuffixObj.id)){
			 result = false;
		}
	}
	
	if (result) {
		// validate name
		if (!validateName(nameObj.id)) {
			result = false;
		}else if (!validateCapacity(capacityObj.id)) {
				result = false;
		}else if (!validateexceedCapacity()) {
					result = false;
		}
	}
	if(result){
		for( var i=0; i < quantityIntValue; i++){
			 if( nameSuffixObj.value == ""){
			     newName = "," + nameObj.value + ",";
			 }else{
			 	 index = parseInt(nameSuffixObj.value)+i;
		     	 newName = "," + nameObj.value + index + ",";
			 }
	
		     if( allCreatedVolumeNameStr.indexOf(newName) != -1){
		         showErrorMsg('nameMsg_tr','nameMsg_span', findDefinedName_ErrMsg);	   
		    	 result = false;
		     }
		}
	}
	if(result){
	   document.getElementById(namespace_g + "myForm:addButton").disabled=true;
	   document.getElementById(namespace_g + "myForm:createType").value = definedVolumes_page;
	   document.getElementById(namespace_g + "myForm:createStep").value = definedVolumes_confirm;
	   document.getElementById(namespace_g + "myForm:nameSuffix_value").value = document.getElementById(namespace_g + "myForm:nameSuffix").value;
	   document.getElementById(namespace_g + "myForm:actionStr").value = "prepareVolume";
	   document.getElementById(namespace_g + "myForm:load").value = "loadFinished";
	   var addedCapacity = parseDecimal(capacityObj.value);
	   var capacityBindingObj = document.getElementById(namespace_g + "myForm:capacityBindingField");
	   capacityBindingObj.value= addedCapacity*1024*1024*1024;
	   var quantityBindingObj = document.getElementById(namespace_g + "myForm:quantityBindingField");
	   quantityBindingObj.value= quantityIntValue;
	   document.getElementById(namespace_g + "myForm:clickbtn").click();
	}else{
	/*
	//comment by qiuhongyan, cannot see bellow code make sense here.
	if (document.getElementById(namespace_g + "myForm:nameSuffix").value== ""){
	   document.getElementById(namespace_g + "myForm:nameSuffix").value = "";
	   document.getElementById(namespace_g + "myForm:nameSuffix").disabled = true;	   
	   document.getElementById(namespace_g + "myForm:exampleName").innerHTML = document.getElementById(namespace_g + "myForm:name").value;}
	*/   
	}
	refreshRemoveButton();
	
	return result;	
}
function addZeroIfNeeded (){}
function alternateSelectionOfAddedVolumes() {
	var imgobj = document.getElementById(namespace_g + "myForm:newVolumesTable:selectionimg");
	var selalttxt = document.getElementById(namespace_g + "myForm:SelectallimgAltText").innerHTML;
	var unselalltxt = document.getElementById(namespace_g + "myForm:UnselectallimgAltText").innerHTML;
	
	var tableobj = document.getElementById(namespace_g + "myForm:newVolumesTable");
	var tbodyobj = tableobj.getElementsByTagName("tbody")[0];
	var allcheckbox = tbodyobj.getElementsByTagName("input");
	var selallflag = false;
	
	
	if (imgobj && allcheckbox.length > 0) {
		if (imgobj.src.indexOf("unselectall") != -1) {
			imgobj.src = current_context + "/images/common/tree/selectall.gif";
			imgobj.alt = selalttxt;
			imgobj.title = selalttxt;
		} else {
			imgobj.src = current_context + "/images/common/tree/unselectall.gif";
			imgobj.alt = unselalltxt;
			imgobj.title = unselalltxt;
			selallflag = true;
		}
		for (var i = 0;i < allcheckbox.length;i ++) {
			if (allcheckbox[i].type == "checkbox") {
				allcheckbox[i].checked = selallflag;
			}
		}
		refreshRemoveButton();
	}
}
