/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

var SelectedPoolsObjMap = new JSSimpleMap();
function PoolObject(poolName,raidType,dismounted,mounted,sparingNumberString,missing){
	this.poolName = poolName;
	this.raidType = raidType;
	this.dismounted = dismounted;
	this.mounted = mounted;
	this.sparingNumberString = sparingNumberString;
	this.missing = missing;
	
	this.getKey = function(){
		return (this.poolName);
	}
	this.toString = function(){
		return (this.poolName);
	}
}

function setPoolMenuValues(){
var selectOneOptions = new Array();
	var menu1 = document.getElementById(namespace_g + "myForm:menu_1").innerHTML;
	var menu2 = document.getElementById(namespace_g + "myForm:menu_2").innerHTML;
	var menu3 = document.getElementById(namespace_g + "myForm:menu_3").innerHTML;
	var menu4 = document.getElementById(namespace_g + "myForm:menu_4").innerHTML;
	var menu5 = document.getElementById(namespace_g + "myForm:menu_5").innerHTML;
	var menu6 = document.getElementById(namespace_g + "myForm:menu_6").innerHTML;
	var menu7 = document.getElementById(namespace_g + "myForm:menu_7").innerHTML;
	var menu9 = document.getElementById(namespace_g + "myForm:menu_9").innerHTML;
	var menu10 = document.getElementById(namespace_g + "myForm:menu_10").innerHTML;

	selectOneOptions[0] = new Option(menu2,'Properties');
	selectOneOptions[1] = new Option(menu3,'ExpandPool');
	selectOneOptions[2] = new Option(menu5,'DeletePool');
	selectOneOptions[3] = new Option(menu6,'AGHS');
	selectOneOptions[4] = new Option(menu9,'DismountPool');
	selectOneOptions[5] = new Option(menu10,'MountPool');
	 var menu = document.getElementById("poolAction");
	 menu.options[0] = new Option(menu1,'MoreAction');;
     for(var i=0;i<selectOneOptions.length;i++){
        menu.options[i+1]=selectOneOptions[i];
        menu.options[i+1].key = true;
     }
     emulate("poolAction");
}
function initMenu(){
	setPoolMenuValues();
	SelectedPoolsObjMap = new JSSimpleMap();
	poolOnClicked();
}
function enablePoolButtons(flag){
	if(flag){
		document.getElementById(namespace_g + "myForm:createStoragePool").disabled = false;
		document.getElementById("poolAction").disabled = false;
	}else{
		document.getElementById(namespace_g + "myForm:createStoragePool").disabled = true;
		document.getElementById(namespace_g + "myForm:createStorageVolume").disabled = true;
		document.getElementById("poolAction").disabled = true;
	}
}
function poolSubmitAction(thisObj){
	syncCheckbox(false, "rowLinkHidden");
    if(isSelectOptionDisabled(thisObj)){
	   return;
	 }
	var action = thisObj.options[thisObj.options.selectedIndex].value;
	thisObj.value="";
	if(action=="Properties"){
		document.getElementById(namespace_g + 'myForm:viewProperties').click();
		parent.setStorageUtilTitle('poolPropertiesTitle');
	}
	else if(action=="DeletePool"){
		document.getElementById(namespace_g + 'myForm:deleteDialogPopuper').click();
		parent.setStorageInformationTitle('confirmMessage');
	} else if(action=="AGHS") {
		document.getElementById(namespace_g + 'myForm:viewAssignGlobal').click();
		parent.setStorageUtilTitle('poolAssignGlobalSparingTitle');
	} else if(action=="AssignSparing") {
		document.getElementById(namespace_g + 'myForm:viewAssignDedicated').click();
		parent.setStorageUtilTitle('poolAssignDedicateSparingTitle');
	} else if(action=="UnassignSparing") {
		document.getElementById(namespace_g + 'myForm:viewUnassignDedicated').click();
		parent.setStorageUtilTitle('poolUnassignDedicateSparingTitle');
	} else if(action=="ExpandPool") {
		document.getElementById(namespace_g + 'myForm:ExpandPoolButton').click();
	} else if(action=="DismountPool") {
		document.getElementById(namespace_g + "myForm:dismountLink").click();
	} else if(action=="MountPool") {
		document.getElementById(namespace_g + "myForm:mountLink").click();
	}
	thisObj.selectedIndex = 0;
}
function poolOnClicked(thisObj,poolName,raidType,dismounted,mounted,sparingNumberString,missing){
	document.getElementById(namespace_g + "myForm:createStorageVolume").disabled = true;
	var menu = document.getElementById("poolAction");
	for(var i=1;i<menu.options.length;i++){
	   	menu.options[i].key = true;
	}
	if(thisObj){
		var poolObj = new PoolObject(poolName,raidType,dismounted,mounted,sparingNumberString,missing);
		if(thisObj && thisObj.checked){
			SelectedPoolsObjMap.put(poolObj.getKey(),poolObj);
		}else{
			SelectedPoolsObjMap.remove(poolObj.getKey());
		}
		var selectedPoolNumber = SelectedPoolsObjMap.length();	
		var allSelectedObjecs = SelectedPoolsObjMap.valueArray();
		
		if(selectedPoolNumber==1){
			document.getElementById(namespace_g + "myForm:createStorageVolume").disabled = false;
			menu.options[1].key = false;
			menu.options[2].key = false;
			menu.options[3].key = false;
			if(allSelectedObjecs[0].dismounted=="true"){
				menu.options[6].key = false;
			}else if(allSelectedObjecs[0].mounted=="true"){
				menu.options[5].key = false;
			}
		}
		if(selectedPoolNumber>0){
		// if one of dimounted pool is selected, all other functions should be disabled.
			var haveOneDismountedSelected = false;
			for(var i=0;i<allSelectedObjecs.length;i++){
				haveOneDismountedSelected = (haveOneDismountedSelected || (allSelectedObjecs[i].dismounted=="true" || allSelectedObjecs[i].missing=="true"));
			}
			if(haveOneDismountedSelected){
				menu.options[2].key = true;			
				menu.options[3].key = true;			
				document.getElementById(namespace_g + "myForm:createStorageVolume").disabled = true;
			}		
		}		
	}
	menu.options[4].key = false;	
	emulate("poolAction");
	highlightStartRow(namespace_g + "myForm:storagePoolTable");
	syncCheckbox(false, "rowLinkHidden");
}

/////////////////////////////////// mount/dismount support//////////////////////////////////

//dismounting
function onDismountConfirmShow(){
	var allSelectedObjecs = SelectedPoolsObjMap.valueArray();
	document.getElementById("PoolDisplayName").innerHTML=allSelectedObjecs[0].poolName;
	document.getElementById(namespace_g + 'myForm:dismountOK').disabled = false;
	document.getElementById(namespace_g + 'myForm:dismountCancel').disabled = false;
	hideProgressIndicator("spinningDiv_dismountModal");
	return true;
}
function onDismountingStart(){
	enableSelectedStorageTabs(2);
	return true;
}
function ondismounting(){
	document.getElementById(namespace_g + 'myForm:dismountOK').disabled = true;
	document.getElementById(namespace_g + 'myForm:dismountCancel').disabled = true;
	showProgressIndicator('spinningDiv_dismountModal');
	document.getElementById(namespace_g + 'myForm').target='_self';
	return true;
}
function onDismountingEnd(){
	document.getElementById(namespace_g + "myForm:dismountHiddenBtn").click();
	refreshTabs();
	return true;	
}
function refreshTabs(){
	enableAllStorageTabs();
	setTimeout(lazyRefreshTabs,200);
	function lazyRefreshTabs(){	
		parent.refreshAllTabs(parent.REFRESH_MASK_VOLUME+parent.REFRESH_MASK_POOL+parent.REFRESH_MASK_DISK+parent.REFRESH_MASK_HOST);	
	}
}

//mounting
function onmountConfirmShow(){
	var r2 = true;
	if(r2)
	{
		//mount pool not allowed in controller r2.
		return true;
	}else{
		var allSelectedObjecs = SelectedPoolsObjMap.valueArray();
		document.getElementById("PoolDisplayName_mount").innerHTML=allSelectedObjecs[0].poolName;
		document.getElementById(namespace_g + "myForm:mountModalSubmit").click();
		return true;
	}
}
function onMountingStart(){
	enableSelectedStorageTabs(2);
	return true;
}
function onMountingEnd(){
	document.getElementById(namespace_g + "myForm:mountCancel").click();
	refreshTabs();
	return true;
}
function onmounting(){
	document.getElementById(namespace_g + 'myForm').target='_self';
	return true;	
}
function gotoShutdownAndRecoverPage(){
	document.getElementById(namespace_g + 'myForm:gotoShutdownAndRecoverPage').click();
}
/////////////////////////////////// mount/dismount support end ///////////////////////////////
