/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// storageDisk.js

function assignHotSpare(assignType) {	
	var leftTable = document.getElementById(namespace_g + "myForm:leftStoragePoolDiskTable");
	var rightTable = document.getElementById(namespace_g + "myForm:rightStoragePoolDiskTable");
	
	var checkBoxs = getElementsByTagNameAndType("input", "checkbox");
	
	for(var i=0; i<checkBoxs.length; i++) {
		var thisObj = checkBoxs[i];		
		if(thisObj.checked) {
			var trObj = thisObj.parentNode.parentNode.parentNode;
			var tableObj = trObj.parentNode.parentNode;
			
			if (assignType == "assign" && tableObj.id == namespace_g + "myForm:leftStoragePoolDiskTable") {
				rightTable.tBodies[0].appendChild(trObj);
			} else if (assignType == "unassign" && tableObj.id == namespace_g + "myForm:rightStoragePoolDiskTable") {
				leftTable.tBodies[0].appendChild(trObj);
			} 
		}	
	}
	unselectedCheckbox();
	setTableClass(namespace_g + "myForm:leftStoragePoolDiskTable");
	setTableClass(namespace_g + "myForm:rightStoragePoolDiskTable");
}

/**
 * Submit the assigne/unassign selected pools
 *
 */
function assignSelectedPool() {
	document.getElementById("assignUnAssignDedicatedSpareDiskDrive").style.visibility= "visible";
	
	var checkBoxs = getElementsByTagNameAndType("input", "checkbox");
	
	for(var i=0; i<checkBoxs.length; i++) {
		var thisObj = checkBoxs[i];
		var trObj = thisObj.parentNode.parentNode.parentNode;
		var tableObj = trObj.parentNode.parentNode;
		if (tableObj.id == namespace_g + "myForm:rightStoragePoolDiskTable" && thisObj.style.display == "none") {
		    thisObj.checked = true;
		}
		if(thisObj.style.display != "none") {
			thisObj.disabled = true;
		}
	}
	document.getElementById(namespace_g + "myForm:do_ok_btn").disabled = true;
	document.getElementById(namespace_g + "myForm:do_cancel_btn").disabled = true;
	document.getElementById(namespace_g + "myForm:clickLeftBtn").disabled = true;
	document.getElementById(namespace_g + "myForm:clickRightBtn").disabled = true;	
}

/**
 * Unselected all checkboxs after the operation
 *
 */
function unselectedCheckbox(){
	var checkBoxs = getElementsByTagNameAndType("input","checkbox");

	for(var i=0; i<checkBoxs.length; i++){
		checkBoxs[i].checked = false;
	}
}
	
	
/**
 * Get elements by the tag name and the type
 *
 */
function getElementsByTagNameAndType(tagName, type){
	var checkBoxs = new Array();
	var tags = document.getElementsByTagName(tagName);
	var index = 0;
	for(var i=0; i<tags.length; i++){
		var tmpType = tags[i].getAttribute("type");
		if(tmpType == type){
			checkBoxs[index] = tags[i];
			index++;
		}
	}
	return checkBoxs;
}

/**
 * Set the seperated class style for the table rows
 *
 */
function setTableClass(tableID) {
	var rows = document.getElementById(tableID).tBodies[0].rows;	
	for(var i=0; i<rows.length; i++) {
		if(i%2 == 0) {
			rows[i].className = "dmc_rowClass1";
		} else {
			rows[i].className = "dmc_rowClass2";
		}		
	}
}

/**
 * Enable the button when the ajax call is completed.
 * 
 */
function enableButton(){
	document.getElementById(namespace_g + "myForm:do_ok_btn").disabled = false;
	document.getElementById(namespace_g + "myForm:do_cancel_btn").disabled = false;
}
