/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// storagePool.js
var name_null_ErrMsg = null;
var capacity_null_ErrMsg = null;
var quantity_null_ErrMsg = null;
var nameSuffix_null_ErrMsg = null;

var PoolNameErrMsg = null;
var quantity_size_ErrMsg = null;
var capacity_size_ErrMsg = null;
var findDefinedName_ErrMsg = null;
var volumesNum_ErrMsg = null;
var non_numeric_ErrMsg = null;
var nameLength_ErrMsg = null;
var nameCharacters_ErrMsg = null;
var capacity_exceedAvailableCapacity_ErrMsg = null;
var no_availableCapacity_ErrMsg = null;

var capacity_min_ErrMsg = null;
var capacity_minimum_size_ErrMsg = null;
var quantity_min_ErrMsg = null;
var quantity_non_numeric_ErrMsg = null;
var nameSuffix_non_numeric_ErrMsg = null;
var nameSuffix_min_ErrMsg = null;
var nameSuffix_max_ErrMsg = null;


var maxCapacity = 32768;
var maxQuantity = 128;

//table category
var poolCapacityTable = "poolCapacityTable";
var existingPoolTable = "existingPoolTable";
var expandPoolCapacityTable = "expandPoolCapacityTable";

var errorMsg_tr = new Array();
errorMsg_tr[0] = "nameMsg_tr";
errorMsg_tr[1] = "capacityMsg_tr";
errorMsg_tr[2] = "quantityMsg_tr";
errorMsg_tr[3] = "nameSuffixMsg_tr";

var errorMsg_span = new Array();
errorMsg_span[0] = "nameMsg_span";
errorMsg_span[1] = "capacityMsg_span";
errorMsg_span[2] = "quantityMsg_span";
errorMsg_span[3] = "nameSuffixMsg_span";

var selectStoragePool_page = "SelectStoragePool";
var definedVolumes_page = "DefinedVolumes";
var createBasicPool_page = "CreateBasicPool";
var createAdvancedPool_page = "CreateAdvancedPool";
var createBasicPool_confirm = "CreateBasicPool_Confirm";
var definedVolumes_confirm = "DefinedVolumes_Confirm";
var expandStoragePool_page = "ExpandStoragePool";
var selectDrives_confirm = "SelectDrives_Confirm";

var selectedCheckBoxID = null;

var poolName = null;
var raidLevel = null;
var isExpandPool = false;
var comeFrom_ExpandVolume = "Volume"; 
var additionCapacityNeeded_ExpandPool = 0;
var GB = "GB";

var browser_IE = "IE";
var browser_FireFox = "FireFox";

// construct onLoad method for each page
function customOnLoad(){
	var pageOnLoad = "onLoad_" + document.title + "()";		
	try{
		eval(pageOnLoad);
	}
	catch(error){
		
	}
}

function refreshBodyMargin() {
	document.getElementsByTagName("body")[0].className = "wizardFrameBody";
}

// SelectStoragePool onLoad method	
function onLoad_SelectStoragePool() {
	LoadCommonPage();
	//added by hemingg
	//disable the next button when the page load
	forwardNextPage('false', true);
	
	// initial error message	
	initErrorMessage();	
}
// CreateBasicPool onLoad method	
function onLoad_CreateBasicPool(){
	LoadCommonPage();
	//added by hemingg
	//disable the next button when the page loads
	forwardNextPage('false', true);
	
	// initial error message	
	initErrorMessage();	
}

function onLoad_CreateAdvancedPool() {
	LoadCommonPage();
	//added by jiaoyong
	//disable the next button when the page loads
	init_CreateAdvancedPool();
	forwardNextPage('false', true);

	//disable the pool name input
	var poolnametext = document.getElementById(namespace_g + "myForm:poolName");
	poolnametext.disabled = true;
	
	// initial error message	
	initErrorMessage();	
}
// CreatePoolConfirm onLoad method	 
function onLoad_CreatePoolConfirmMessage(){
   parent.stopWait('util_dialog');
   initConfirmMessage();  
   alignHeaderTableAndContentTable('headerTableDivId','selectedPoolCapacityTable');
   
   // initial error message	
   initErrorMessage();	 
}

function onLoad_CreateAdvancedPoolConfirmMessage() {
	parent.stopWait('util_dialog');
	initAdvancedConfirmMessage();
   alignHeaderTableAndContentTable('headerTableDivId','selectedPoolCapacityTable');
	
	// initial error message	
	initErrorMessage();	
}

function onLoad_CreateBasicPoolWaiting(){
	LoadCommonPage();
	
	// initial error message	
	initErrorMessage();	
}

function onLoad_CreateAdvancedPoolWaiting(){
	LoadCommonPage();
	// initial error message	
	initErrorMessage();	
}

// CreateBasicPoolCompletion onLoad method
function onLoad_CreateBasicPoolCompletion(){
	LoadCommonPage();
	initCreateBasicPoolCompletion();
	
	// initial error message	
	initErrorMessage();	
}
function onLoad_CreateAdvancedPoolCompletion() {
	LoadCommonPage();
	initCreateBasicPoolCompletion();
	// initial error message	
	initErrorMessage();	
}
// DefineVolumes onLoad method
function onLoad_DefineVolumes(){
	setVolumeInputsStatus(true)
	LoadCommonPage();
   	initDefineVolumesMessage(); 
   	
   	// initial error message	
	initErrorMessage();
}

// validate defineVolume precondition
function defineVolumePrecondition(){
	var volumeNum = document.getElementById(namespace_g + "myForm:volumeNum").innerHTML;
	if( volumeNum >= maxQuantity){
	    var message = document.getElementById(namespace_g + "myForm:ReachMaxVolumeNumber_InfoMsg").innerHTML;
		// clear old info message
	    innerMessagesInstance.clearSpecialMessage();
	    // show new info message
	    innerMessagesInstance.showSpecialMessage(message);
	    //disabled all fields 
	    
	    document.getElementById(namespace_g + "myForm:name").disabled = true;
	    document.getElementById(namespace_g + "myForm:capacity").disabled = true;
	    document.getElementById(namespace_g + "myForm:quantity").disabled = true;
	    document.getElementById(namespace_g + "myForm:nameSuffix").disabled = true;
	    document.getElementById(namespace_g + "myForm:addButton").disabled = true;
	    document.getElementById(namespace_g + "myForm:removeButton").disabled = true;	   
	}
}

function onLoad_DefineVolumesConfirmMessage(){
	// Call the common function to send the ajax request
	commonPageLoad();
   	stopWait('util_dialog');
}


function onLoad_ExpandStoragePool(){
   LoadCommonPage();
   document.getElementById("parent_expand_advanced").disabled = true;
   document.getElementById("parent_expand_easy").disabled = true;
   document.getElementById("AvailablePoolCapacityTR").style.display = "none";
   document.getElementById("AdditionalCapacityNeededTR").style.display = "none";
   
   // initial error message	
   initErrorMessage();
   
   // control warn message display
 	if("true" != document.getElementById(namespace_g + "myForm:showShutIOWarnMsg").innerHTML 
 		    && "true" != document.getElementById(namespace_g + "myForm:showExpandRAID1WarnMsg").innerHTML )
 	{
 		document.getElementById("expandPoolWarnDiv").style.display = "none";
 	}
 	else
 	{
	 	if("true" == document.getElementById(namespace_g + "myForm:showShutIOWarnMsg").innerHTML)
	 	{
	 		document.getElementById(namespace_g +"myForm:ShutIO_WARNING_Text_ID").style.display = "";
	 		document.getElementById(namespace_g +"myForm:ShutIO_warningMsg_Text_ID").style.display = "";
	 	}
	 	else 
	 	{
	 		document.getElementById(namespace_g +"myForm:ShutIO_WARNING_Text_ID").style.display = "none";
	 		document.getElementById(namespace_g +"myForm:ShutIO_warningMsg_Text_ID").style.display = "none";
	 	}
	 	if("true" == document.getElementById(namespace_g + "myForm:showExpandRAID1WarnMsg").innerHTML)
	 	{
	 		document.getElementById(namespace_g +"myForm:ExpandRAID1_WARNING_Text_ID").style.display = "";
	 		document.getElementById(namespace_g +"myForm:ExpandRAID1_warningMsg_Text_ID").style.display = "";
	 	}
	 	else
	 	{
	 		document.getElementById(namespace_g +"myForm:ExpandRAID1_WARNING_Text_ID").style.display = "none";
	 		document.getElementById(namespace_g +"myForm:ExpandRAID1_warningMsg_Text_ID").style.display = "none";
	 	}
	 	document.getElementById("expandPoolWarnDiv").style.display = "";
 	}
}

function onLoad_ExpandPoolConfirmMessage(){
  parent.stopWait('util_dialog');
  initExpandPoolConfirmMessage();
  LoadCommonPage(); 
  
  // initial error message	
  initErrorMessage();	
}

function onLoad_ExpandPoolWaiting(){
   LoadCommonPage(); 
   if(parent.document.getElementById(namespace_g + "myForm:btnCancel")){
   	  parent.document.getElementById(namespace_g + "myForm:btnCancel").value = document.getElementById(namespace_g + "myForm:closeBtnLabel").innerHTML;
   }
   // initial error message	
   initErrorMessage();	
   //showProgressIndicator('spinningDiv');
}

function onLoad_ExpandPoolCompletion(){
   LoadCommonPage();
   initExpandPoolCompletion();
   // initial error message	
   initErrorMessage();	
}

function onLoad_SelectDrives(){
   LoadCommonPage();
   initSelectDrives();  
   
   // initial error message	
   initErrorMessage();	
}

function onLoad_SelectPoolConfirmMessage(){
  stopWait('util_dialog'); 
  initSelectPoolConfirmMessage();
}
function LoadCommonPage() {
	refreshBodyMargin();
	lazyLoad();
	if (parent) {
		parent.refreshNext();
	}
}

// delay the loading time
function lazyLoad() {
	setTimeout(lazyDo ,5);	
}

// trigger Ajax call				
function lazyDo() {
	var obj = document.getElementById(namespace_g + "myForm:clickbtn");
	obj.click();
}

//Stop displaying "waiting" image while iFrame content is finished 
function CreatePool_stopWait(dialogId){
	if(dialogId == 'completion_dialog'){
	   if(document.getElementById('completion_waitDiv_utility')){
			document.getElementById('completion_waitDiv_utility').style.display = "none";
			document.getElementById('completion_u_iframe_div').style.visibility= "visible";
			
	   }else if(parent.document.getElementById('completion_waitDiv_utility')){
			parent.document.getElementById('completion_waitDiv_utility').style.display = "none";		
			parent.document.getElementById('completion_u_iframe_div').style.visibility= "visible";			
	   }
	}	
}

//clear the iframe src when closing the pannelDialog
function clearFrame(){
	var iframeObj;
	var iframeDIVObj;
	
	if( document.getElementById('templ_u_iframe')){
		iframeObj = document.getElementById("templ_u_iframe");
	   	iframeDIVObj = document.getElementById("templ_u_iframe_div");
	}else if( parent.document.getElementById('templ_u_iframe')){
	   	iframeObj = parent.document.getElementById("templ_u_iframe");
	   	iframeDIVObj = parent.document.getElementById("templ_u_iframe_div");
	}

	if( iframeObj.src != ''){
		iframeObj.src = '';	
		iframeDIVObj.style.visibility= "hidden";	
	}					
}

// div unexpanded or expanded
function clickExpend(divID , imgobj){
	var thisDIV = document.getElementById(divID);
	
	if( thisDIV.style.display=='block' ||thisDIV.style.display == ""){
		thisDIV.style.display='none';
		imgobj.src = document.global_context_path + "/images/right.gif";
		imgobj.title = bundle.Image_Expend;
		imgobj.alt = bundle.Image_Expend;
	}else{
		thisDIV.style.display='block';		
		imgobj.src = document.global_context_path + "/images/down.gif";
		imgobj.title = bundle.Image_Collapse;
		imgobj.alt = bundle.Image_Collapse;
	}		
}

// set tag for wizard 
function forwardNextPage(isForward, isRefreshNextButton){
	var isNext = document.getElementById(namespace_g + "myForm:isNext");
	var	nextButton = document.getElementById(namespace_g + "myForm:NextButton");
	isNext.value = isForward;
	
	if (parent) {
		parent.refreshNext();
	}
	
	if(nextButton && isRefreshNextButton){
	   if(isNext.value == "true"){
	   	  nextButton.disabled = false;
	   }else{
	   	  nextButton.disabled = true;
	   }
	}
}

/* ----- begin of initialization ------ */

// [CreateBasicPool.jsp]menu disabled
function enableSelectMenu(){
	forwardNextPage("true", true);
	selectedCheckBoxID = null;
	document.getElementById(namespace_g + "myForm:driveType").disabled = false;
	document.getElementById(namespace_g + "myForm:raidLevel").disabled = false;
	//document.getElementById(namespace_g + "myForm:globalSpare").disabled = false;	
	
	//document.getElementById(namespace_g + "myForm:poolName").value = "";
	var totalBytes = Number(document.getElementById(namespace_g + "myForm:totalCapacity").innerHTML);
	document.getElementById("remainingCapacity").innerHTML = formatDecimal(totalBytes/1024/1024/1024);
	
	document.getElementById("poolCapacityTable").style.display = "";
    document.getElementById("waitImg").style.display = "none"; 
	document.getElementById(namespace_g + "myForm:currentGlobalSpare").value = document.getElementById(namespace_g + "myForm:basicPoolGlobalHotSpares").innerHTML; 
	
	if(document.getElementById(namespace_g + "myForm:displayPoolCapacityBeanTable").innerHTML == "true") {
		document.getElementById(namespace_g + "myForm:isNext").value = true; 
	} else {
		document.getElementById(namespace_g + "myForm:isNext").value = false; 
	}
	parent.refreshNext();
}

function setDefaultSelectedOption(){
	var radios = document.getElementsByName("selected");
	if( radios.length > 0){
	    radios[0].focus();
	    radios[0].click();
	}	
}


/** disable select menu. **/
//add by hemg
function disableSelectMenu()
{
	document.getElementById(namespace_g + "myForm:driveType").disabled = true;
	document.getElementById(namespace_g + "myForm:raidLevel").disabled = true;
	//document.getElementById(namespace_g + "myForm:globalSpare").disabled = true;	
}

/** before ajax submit, do something. **/
function onStartAjaxLoad()
{
	disableSelectMenu();
	forwardNextPage("false", true);
}



// [CreatePoolConfirmMessage.jsp]init confirm message
function  initConfirmMessage(){
    document.getElementById(namespace_g + "myForm:poolName_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:poolName").value;
    
	var obj = parent.document.getElementById(parent.namespace_g + "myForm:raidLevel");
	var strsel = obj.options[obj.selectedIndex].text;
    document.getElementById(namespace_g + "myForm:raidLevel_confirm").innerHTML = strsel;	
    
    document.getElementById(namespace_g + "myForm:capacity_confirm").innerHTML  = parent.document.getElementById(parent.namespace_g + "myForm:capacity_confirmMessage").value;	     	
	document.getElementById(namespace_g + "myForm:driveNumber_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:driveNumber_confirmMessage").value;   
}

// [CreateAdvancedPoolConfirmMessage.jsp]init confirm message
function initAdvancedConfirmMessage() {
	document.getElementById(namespace_g + "myForm:poolName_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:poolName").value;
	var obj = parent.document.getElementById(parent.namespace_g + "myForm:raidLevel");
	var strsel = obj.options[obj.selectedIndex].text;	
    document.getElementById(namespace_g + "myForm:raidLevel_confirm").innerHTML = strsel;
    document.getElementById(namespace_g + "myForm:capacity_confirm").innerHTML  = parent.document.getElementById(parent.namespace_g + "myForm:txtTotalNewPoolCapacity").innerHTML;
    var onetable = parent.document.getElementById("oneAddedDiskDiv");
    var twotable = parent.document.getElementById("twoAddedDiskDiv");
    var oneTableNumber = parent.document.getElementById(parent.namespace_g + "myForm:txtAddedNumberOfDisks");
    var twoTableNumber = parent.document.getElementById(parent.namespace_g + "myForm:txtNewPoolConfiguration");
    if (onetable.style.display != "none"){
		document.getElementById(namespace_g + "myForm:driveNumber_confirm").innerHTML = oneTableNumber.innerHTML;
	} else if(twotable.style.display != "none"){
		document.getElementById(namespace_g + "myForm:driveNumber_confirm").innerHTML = twoTableNumber.innerHTML;
	}
}

function initCreateBasicPoolCompletion(){
    //defect 8359,qiuhongyan
    var createResult = document.getElementById(namespace_g + "myForm:createResult").value;
    if( createResult == "false"){
        //fail to create pool,back button enable, next button disable
        parent.document.getElementById(parent.namespace_g + "myForm:hidden_showPrev").value = true;
        var stepFrame = parent.getFrame("step_iframe");
	    stepFrame.document.getElementById(stepFrame.namespace_g + "myForm:isNext").value = false;
        document.getElementById(namespace_g + "myForm:description").innerHTML = document.getElementById(namespace_g + "myForm:failureDescription").innerHTML;
    }else if( createResult == "true"){
        //success to create pool,back button disable
        parent.document.getElementById(parent.namespace_g + "myForm:hidden_showPrev").value = false;
        var stepFrame = parent.getFrame("step_iframe");
        stepFrame.document.getElementById(stepFrame.namespace_g + "myForm:isNext").value = true;
        document.getElementById(namespace_g + "myForm:description").innerHTML =  document.getElementById(namespace_g + "myForm:successDescription").innerHTML;
    }
    parent.refreshNext();    
    /*
    if( createResult == "Failure"){
        forwardNextPage("false", true);
    }else if( createResult == "Created"){
    	forwardNextPage("true", true);
    }*/
    
}
// [DefineVolumes.jsp]init error message
function initDefineVolumesMessage(){
	name_null_ErrMsg = document.getElementById(namespace_g + "myForm:name_null_ErrMsg").innerHTML;
	capacity_null_ErrMsg = document.getElementById(namespace_g + "myForm:capacity_null_ErrMsg").innerHTML;
	quantity_null_ErrMsg = document.getElementById(namespace_g + "myForm:quantity_null_ErrMsg").innerHTML;
	nameSuffix_null_ErrMsg = document.getElementById(namespace_g + "myForm:nameSuffix_null_ErrMsg").innerHTML; 
	quantity_size_ErrMsg = document.getElementById(namespace_g + "myForm:quantity_size_ErrMsg").innerHTML;
	capacity_size_ErrMsg = document.getElementById(namespace_g + "myForm:capacity_size_ErrMsg").innerHTML;

	capacity_exceedAvailableCapacity_ErrMsg = document.getElementById(namespace_g + "myForm:capacity_exceedAvailableCapacity_ErrMsg").innerHTML;
	findDefinedName_ErrMsg = document.getElementById(namespace_g + "myForm:findDefinedName_ErrMsg").innerHTML;					
	volumesNum_ErrMsg = document.getElementById(namespace_g + "myForm:volumesNum_ErrMsg").innerHTML;
	non_numeric_ErrMsg = document.getElementById(namespace_g + "myForm:non_numeric_ErrMsg").innerHTML;
	three_decima_ErrMsg = document.getElementById(namespace_g + "myForm:threeDecima_ErrMsg").innerHTML;	
	nameLength_ErrMsg = document.getElementById(namespace_g + "myForm:nameLength_ErrMsg").innerHTML;
	nameCharacters_ErrMsg = document.getElementById(namespace_g + "myForm:nameCharacters_ErrMsg").innerHTML;
	no_availableCapacity_ErrMsg = document.getElementById(namespace_g + "myForm:no_availableCapacity_ErrMsg").innerHTML;
	
	capacity_min_ErrMsg = document.getElementById(namespace_g + "myForm:capacity_min_ErrMsg").innerHTML;
	capacity_minimum_size_ErrMsg = document.getElementById(namespace_g + "myForm:capacity_minimum_size_ErrMsg").innerHTML;
	quantity_non_numeric_ErrMsg = document.getElementById(namespace_g + "myForm:quantity_non_numeric_ErrMsg").innerHTML;
	quantity_min_ErrMsg = document.getElementById(namespace_g + "myForm:quantity_min_ErrMsg").innerHTML;
	nameSuffix_non_numeric_ErrMsg = document.getElementById(namespace_g + "myForm:nameSuffix_non_numeric_ErrMsg").innerHTML;
	nameSuffix_min_ErrMsg = document.getElementById(namespace_g + "myForm:nameSuffix_min_ErrMsg").innerHTML;
	nameSuffix_max_ErrMsg = document.getElementById(namespace_g + "myForm:nameSuffix_max_ErrMsg").innerHTML;
}

function defineVolume_ajaxB() {
	setTimeout(defineVolume_ajaxB_click , 5);
}

function defineVolume_ajaxB_click() {
    document.getElementById(namespace_g + "myForm:load").value = "loadFinished";    
	document.getElementById(namespace_g + "myForm:ajaxBbutton").click();
}

function initSelectDrives(){
    var switches = retreiveType();

    if( switches == "1"){
    	document.getElementById(namespace_g + "myForm:text_right_1").innerHTML = document.getElementById(namespace_g + "myForm:AddedNumberOfDrives").innerHTML;
    	document.getElementById(namespace_g + "myForm:text_right_2").innerHTML = document.getElementById(namespace_g + "myForm:NewTotalPoolCapacity").innerHTML;
    	document.getElementById(namespace_g + "myForm:text_right_3").innerHTML = document.getElementById(namespace_g + "myForm:NewAvailablePoolCapacity").innerHTML;
    	document.getElementById(namespace_g + "myForm:text_right_4").innerHTML = document.getElementById(namespace_g + "myForm:RemainingSystemCapacity").innerHTML;
    	document.getElementById("oneAddedDiskButtonDiv").style.display = "";
    	document.getElementById("oneAddedDiskDiv").style.display = "";
    }else if( switches == "2"){
		document.getElementById(namespace_g + "myForm:text_right_1").innerHTML = document.getElementById(namespace_g + "myForm:CurrentPoolConfiguration").innerHTML;
    	document.getElementById(namespace_g + "myForm:text_right_2").innerHTML = document.getElementById(namespace_g + "myForm:NewPoolConfiguration").innerHTML;
    	document.getElementById(namespace_g + "myForm:text_right_3").innerHTML = document.getElementById(namespace_g + "myForm:NewTotalPoolCapacity").innerHTML;
    	document.getElementById(namespace_g + "myForm:text_right_4").innerHTML = document.getElementById(namespace_g + "myForm:NewAvailablePoolCapacity").innerHTML;
    	document.getElementById("row_5").style.display = "";
    	document.getElementById("twoAddedDiskButtonDiv").style.display = "";
    	document.getElementById("twoAddedDiskDiv").style.display = "";
    }
    
    
}


function initExpandPoolConfirmMessage(){
	document.getElementById(namespace_g + "myForm:poolName_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:poolName").innerHTML;
	document.getElementById(namespace_g + "myForm:originalCapacity_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:originalCapacity_confirmMessage").value;		
	document.getElementById(namespace_g + "myForm:additionalCapacity_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:additionalCapacity_confirmMessage").value;		
	document.getElementById(namespace_g + "myForm:additionalDisks_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:additionalDisks_confirmMessage").value;	
	document.getElementById(namespace_g + "myForm:newTotalCapacity_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:newTotalCapacity_confirmMessage").value;	
	document.getElementById(namespace_g + "myForm:newAvailableCapacity_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:newAvailableCapacity_confirmMessage").value;
	
	var ifobj = parent.document.getElementById(parent.namespace_g + "myForm:util_subview:util_dialog_if");
	if (ifobj) {
		ifobj.style.height = parent.document.getElementById("templ_u_iframe_div").style.height;
	}
}

function initSelectPoolConfirmMessage(){
	document.getElementById(namespace_g + "myForm:poolName_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:poolName").innerHTML;
	document.getElementById(namespace_g + "myForm:originalCapacity_confirm").innerHTML = formatDecimal(parent.document.getElementById(parent.namespace_g + "myForm:totalCapacity").innerHTML);				
	document.getElementById(namespace_g + "myForm:additionalCapacity_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:additionalCapacity_confirmMessage").value;	
	document.getElementById(namespace_g + "myForm:additionalDisks_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:additionalDisks_confirmMessage").value;	
	document.getElementById(namespace_g + "myForm:newTotalCapacity_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:newTotalCapacity_confirmMessage").value;	
	document.getElementById(namespace_g + "myForm:newAvailableCapacity_confirm").innerHTML = parent.document.getElementById(parent.namespace_g + "myForm:newAvailableCapacity_confirmMessage").value;	
}

function initSelectPoolSelection() {
	var selectIndex = document.getElementById(namespace_g + "myForm:oldSelectedIndex").value;
	var selectedPoolName = document.getElementById(namespace_g + "myForm:oldSelectedPoolName").value;
	var parentRadios = document.getElementsByName("parent_creatPool");
    var childrenRadios = document.getElementsByName("children_creatPool_new");
    var poolNumberObj   = document.getElementById(namespace_g + "myForm:poolNumber");
	if (parentRadios.length == 2) {
		parentRadios[0].disabled = false;
		if (poolNumberObj) {
			var poolNumber = poolNumberObj.innerHTML;
			if (poolNumber != 0) {
				parentRadios[1].disabled = false;
			}
		}
		
	}
	if (selectIndex == "2") {	
		if (parentRadios.length != 0) {
			parentRadios[0].checked = true;
		}
	    /*
				noted by hemingg
				the obj.click() method will not work under the firefox when the value of the obj's disabled attribute was changed to false from true,
				So I update the clickRadio() method, add a parameter into this method to handle the radio obj.
		    */
		childrenRadios[0].click();
		clickRadio(childrenRadios[0]);
	} else if (selectIndex == "3") {
		if (parentRadios.length != 0) {
			parentRadios[0].checked = true;
		}
	    /*
				noted by hemingg
				the obj.click() method will not work under the firefox when the value of the obj's disabled attribute was changed to false from true,
				So I update the clickRadio() method, add a parameter into this method to handle the radio obj.
		 */
		childrenRadios[1].click();
		clickRadio(childrenRadios[1]);
	} else if (selectIndex == "4") {
	
		clickRadio(parentRadios[1]);
		if (selectedPoolName != "") {
			var selectedSpan = null;
			var spanobj = document.getElementsByTagName("span");
			for (var j = 0;j < spanobj.length;j ++) {
				if (spanobj[j].innerHTML == selectedPoolName) {
					selectedSpan = spanobj[j];
					break;
				}
			}
			while (selectedSpan.tagName != "TR") {
				selectedSpan = selectedSpan.parentNode;
			}
			
			if (selectedSpan) {
				var inputObj = selectedSpan.getElementsByTagName("input");
				for (var k = 0;k < inputObj.length;k ++) {
					if (inputObj[k].type == "radio") {
						inputObj[k].checked = true;
					    /*
		 					noted by hemingg
		 					the obj.click() method will not work under the firefox when the value of the obj's disabled attribute was changed to false from true,
		 					So I update the clickRadio() method, add a parameter into this method to handle the radio obj.
		 			    */
						inputObj[k].nextSibling.click();
						selectCheckBox_selectStoragePool(inputObj[k].nextSibling);
						break;
					}
				}
			}
		}
	}
}
/* ----- end of initialization ------ */

// [CreateBasicPool.jsp]menu changing
function menuValueChange(menuType){
	document.getElementById(namespace_g + "myForm:currentDriveType").value = document.getElementById(namespace_g + "myForm:driveType").value;	
	document.getElementById(namespace_g + "myForm:currentRAIDLevel").value = document.getElementById(namespace_g + "myForm:raidLevel").value;
	document.getElementById(namespace_g + "myForm:clickbtn").click();
			
	document.getElementById("poolCapacityTable").style.display = "none";
    document.getElementById("waitImg").style.display = "";
}

function selectOnlyOneCheckBox(_objectID){
	if( selectedCheckBoxID != null){
	    if( _objectID == selectedCheckBoxID){ 
	    	var curr_checkbox = document.getElementById(_objectID);	
	    	curr_checkbox.checked = true;    	      	
	    }else{
	    	var previous_checkbox = document.getElementById(selectedCheckBoxID);	
	    	var curr_checkbox = document.getElementById(_objectID);	
	    	
	    	if( previous_checkbox){
	    		previous_checkbox.checked = false;	 
	    	}	    	   	
	    	curr_checkbox.checked = true;
	    }
	}
}


function selectCheckBox_selectStoragePool(_object) {
	_objectID = _object.id;
	
	var expandPool = document.getElementById(namespace_g + "myForm:expandPool");
	var expand = enableExpandPool(_object);
    if (! expand) {
        expandPool.checked = false;
        document.getElementById(namespace_g + 'myForm:hid_isExpand').value = false;
    	expandPool.disabled = true;
    }else{
    	expandPool.disabled = false;
    	document.getElementById(namespace_g + 'myForm:hid_isExpand').value = expandPool.checked;
    }

	selectOnlyOneCheckBox(_objectID);	
	selectedCheckBoxID = _objectID; 
    forwardNextPage("true", true);
}


function obtainTrObjectFromInputObject(_object){	
	if (_object.tagName.toUpperCase() == "INPUT") {
		while(_object.tagName != "TR"){
		 	  _object = _object.parentNode;
		}		
	}	
	return _object;
}

function selectCheckBox_createBasicPool(_object){
	var objectID = _object.id;
	var trObject = obtainTrObjectFromInputObject(_object);
			
	var spansObj = trObject.getElementsByTagName("span");
	var capacity= null;
	var driveNumber = null;
	var usedCapacity = null;

	for (var j = 0;j < spansObj.length;j ++) {
		if (spansObj[j].id.indexOf("capacity") != -1) {
			capacity = spansObj[j].innerHTML;
		}

		if (spansObj[j].id.indexOf("poolDriveNumber") != -1) {		
			driveNumber = spansObj[j].innerHTML;
		}	
		
		if (spansObj[j].id.indexOf("usedCapacity") != -1) {
		    usedCapacity = spansObj[j].innerHTML;
		}		
	}

	if(capacity){
	    var capacityLong = Number(capacity);	
	    var totalCapacity = document.getElementById(namespace_g + "myForm:totalCapacity").innerHTML;	  
		var remainCapacity = Number(totalCapacity) - Number(usedCapacity);		
		document.getElementById(namespace_g + "myForm:capacity_confirmMessage").value = capacity;			
		document.getElementById("remainingCapacity").innerHTML = formatDecimal(remainCapacity/1024/1024/1024);
	}

	if( driveNumber){
		document.getElementById(namespace_g + "myForm:driveNumber_confirmMessage").value = driveNumber;	 
	}

	document.getElementById(namespace_g + "myForm:createType").value = createBasicPool_page;
	selectOnlyOneCheckBox(objectID);
	selectedCheckBoxID = objectID; 
	forwardNextPage("true", true);	
}

function removeGB(str){
	if( str != null && str.length > 0){
	    if( str.indexOf(" "+GB) > -1){
	        str = str.substring(0, str.indexOf(" "+GB));
	    } else if (str.indexOf(GB) > -1) {
	    	str = str.substring(0, str.indexOf(GB));
	    }	
	}
	return str;
}
function removeSpace(str) {
	if( str != null && str.length > 0){
		while(str.indexOf("&nbsp;") > -1) {
			str = str.replace("&nbsp;","");
		} 
		str = str.replace(/^\s*/, "").replace(/\s*$/, "");
	}
	return str;
}

// click checkBox Event
function selectCheckBox_expandStoragePool(_object){
	var objectID = _object.id;
	var trObject = obtainTrObjectFromInputObject(_object);

    var parentRadios = document.getElementsByName("parent_expandPool");
	var poolName = document.getElementById(namespace_g + "myForm:poolName").innerHTML;
	var totalCapacity = document.getElementById(namespace_g + "myForm:totalCapacity").innerHTML;
	var availableCapacity = document.getElementById(namespace_g + "myForm:availableCapacity").innerHTML;
    
    for(var k =0; k < parentRadios.length; k++){
		if( parentRadios[k].checked){
		    document.getElementById(namespace_g + "myForm:expandType").value = parentRadios[k].value;			    		     	
		    break;
		}
	}
			
	var capacity = 0;
	var driveNumber = 0;
	var newTotalCapacity = 0;
	var newAvailableCapacity = 0;
	
	var spansObj = trObject.getElementsByTagName("span");
	for (var j = 0;j < spansObj.length;j ++) {
		if (spansObj[j].id.indexOf("capacity") != -1) {
			capacity = spansObj[j].innerHTML;
			//capacity = removeGB(capacity);
			capacity = removeSpace(capacity);
		}			
		if (spansObj[j].id.indexOf("driveNumber") != -1) {
			driveNumber = spansObj[j].innerHTML;
			driveNumber = removeSpace(driveNumber);
		}				
		if (spansObj[j].id.indexOf("newTotalCapacity") != -1) {
			newTotalCapacity = spansObj[j].innerHTML;
			//newTotalCapacity = removeGB(newTotalCapacity);
			newTotalCapacity = removeSpace(newTotalCapacity);
		}
		if (spansObj[j].id.indexOf("newAvailableCapacity") != -1) {
			newAvailableCapacity = spansObj[j].innerHTML;
			//newAvailableCapacity = removeGB(newAvailableCapacity);
			newAvailableCapacity = removeSpace(newAvailableCapacity);
		}
	}
	
	document.getElementById(namespace_g + "myForm:poolName_confirmMessage").value = poolName;
	document.getElementById(namespace_g + "myForm:originalCapacity_confirmMessage").value = totalCapacity;
	document.getElementById(namespace_g + "myForm:additionalCapacity_confirmMessage").value = capacity;
	document.getElementById(namespace_g + "myForm:newTotalCapacity_confirmMessage").value = newTotalCapacity;
	document.getElementById(namespace_g + "myForm:additionalDisks_confirmMessage").value = driveNumber;
	
	selectOnlyOneCheckBox(objectID);
	selectedCheckBoxID = objectID;
	
	var comeFrom = document.getElementById(namespace_g + "myForm:comeFrom").value;
	if( comeFrom == comeFrom_ExpandVolume){
		var neededCapacity = Number(document.getElementById(namespace_g + "myForm:neededCapacity").value);
		newAvailableCapacity = Number(newAvailableCapacity);
		changeNeededCapacity(newAvailableCapacity, neededCapacity);	
		if( neededCapacity > newAvailableCapacity){
			forwardNextPage("false", true);
		} else {
			forwardNextPage("true", true);
			document.getElementById(namespace_g + "myForm:newAvailableCapacity_confirmMessage").value = formatDecimal(Number(newAvailableCapacity) - Number(neededCapacity));
		}
	}else{
		document.getElementById("AvailablePoolCapacityTR").style.display = "";
	    document.getElementById("AdditionalCapacityNeededTR").style.display = "none";
	    document.getElementById(namespace_g + "myForm:newAvailableCapacity_confirmMessage").value = formatDecimal(newAvailableCapacity);
	    forwardNextPage("true", true);
	}
}

function changeNeededCapacity(availableCapacity, neededCapacity) {
	availableCapacity = Number(availableCapacity);
	neededCapacity = Number(neededCapacity);
	if( neededCapacity > availableCapacity ){
	    document.getElementById("AvailablePoolCapacityTR").style.display = "none";
	    document.getElementById("AdditionalCapacityNeededTR").style.display = "";
	    
	    var showNeededCapacity = neededCapacity - availableCapacity;
	    document.getElementById(namespace_g + "myForm:additionCapacityNeeded").innerHTML = formatDecimal(showNeededCapacity);
	}else{
   		document.getElementById("AvailablePoolCapacityTR").style.display = "";
	    document.getElementById("AdditionalCapacityNeededTR").style.display = "none";
	    var showAvailableCapacity = availableCapacity - neededCapacity;
	    document.getElementById(namespace_g + "myForm:availableCapacity").innerHTML = formatDecimal(showAvailableCapacity);
	}	
}

function enableExpandPool(_object){ 
	var trObject = obtainTrObjectFromInputObject(_object);
	
	var raidLevelObj = trObject.getElementsByTagName("span");
	var disableExpandRaidLevel = document.getElementById(namespace_g + "myForm:disabledExpandRaidLevel").value;
	var textObj = null;
	for (var j = 0;j < raidLevelObj.length;j ++) {
		if (raidLevelObj[j].id.indexOf("raid_Level") != -1) {
			textObj = raidLevelObj[j];
			break;
		}
	}
	if(textObj){
		if(textObj.innerHTML == disableExpandRaidLevel){
			return false;
		}else{
			return true;
		}
	}
	return false;
}

//added  by hemingg
//Do some initial when the CreateAvancedPool finish loading.
function init_CreateAdvancedPool()
{
	//set the poolName is empty.
	document.getElementById(namespace_g + "myForm:poolName").value="";
}


// initialize radio in SelectStoragePool.jsp page
function initDisableRadio_SelectStoragePool() { 
	 var pageActionType = document.getElementById(namespace_g + "myForm:pageActionType").value;
     var parentRadios = document.getElementsByName("parent_creatPool");
     var childrenRadios = document.getElementsByName("children_creatPool_new");
     
     var showExistingPoolObj = document.getElementById(namespace_g + "myForm:showExistingPool");
     var showExistingPool;
	 var poolNumberObj   = document.getElementById(namespace_g + "myForm:poolNumber");
	 var poolNumber = 0;

	if(poolNumberObj){
	    poolNumber = poolNumberObj.innerHTML;
	}
    
	if( showExistingPoolObj){
		showExistingPool = showExistingPoolObj.value;
	} 	     
	 if(pageActionType == "createPool"){
	 	 //parentRadios[0].disabled=false;
		 childrenRadios[0].disabled = false;
		 childrenRadios[1].disabled = false;
		 childrenRadios[0].checked = true;
		 /*
		 	noted by hemingg
		 	the obj.click() method will not work under the firefox when the value of the obj's disabled attribute was changed to false from true,
		 	So I update the clickRadio() method, add a parameter into this method to handle the radio obj.
		 */
		 childrenRadios[0].click();
		 clickRadio(parentRadios[0]);
		 clickRadio(childrenRadios[0]);
			 			 			 
	 }else if(pageActionType == "createVolume"){
         if(poolNumber == 0 ) {				   			    
             parentRadios[0].disabled = false;
		     parentRadios[0].checked = true;
		     childrenRadios[0].disabled = false;
		     childrenRadios[0].checked = true;
		     childrenRadios[0].click();
		     clickRadio(childrenRadios[0]);  
	         childrenRadios[1].disabled = false;
	         // disable when no pool exists
	         parentRadios[1].disabled = true;
	         parentRadios[1].checked = false;
	         		            	    	    				    		
		  }else {       	
		      parentRadios[1].disabled = false;
		      parentRadios[1].checked = true;
		      parentRadios[0].disabled = false;
		      childrenRadios[0].disabled = false;
		      childrenRadios[1].disabled = false;
		      clickRadio(parentRadios[1]);			    	        	        	  	    
	      } 
	      //The radio button in the table should be selected by default.
	      setDefaultSelectedOption();
		  beepWhenRefresh();				 
	  }
	  
	  if( parentRadios && parentRadios.length > 0){
	  	  document.getElementById("td_black").width = "4%";
	  }else{
	  	  document.getElementById("td_black").width = "1%";
	  }	 
}

function initDisableRadio_ExpandStoragePool() {
	/*var parentRadios = document.getElementsByName("parent_expandPool");
	var poolCapacityNumber = document.getElementById(namespace_g + "myForm:poolCapacityNumber").value;

	if( parentRadios.length != 0){										 
		if( poolCapacityNumber > 0){
		    parentRadios[0].disabled = false;
			parentRadios[1].disabled = false;
			parentRadios[0].checked = false;
			parentRadios[1].checked = true;
		}else{
			parentRadios[0].disabled = true;
			parentRadios[1].disabled = true;
			parentRadios[0].checked = false;
			parentRadios[1].checked = false;
		}		   	   				    		
	}	

	clickRadio_ExpandPool();

	var comeFrom = document.getElementById(namespace_g + "myForm:comeFrom").value;
	var availableCapacity = Number(document.getElementById(namespace_g + "myForm:availableCapacity").innerHTML);
	var neededCapacity = Number(document.getElementById(namespace_g + "myForm:neededCapacity").value);

	if( comeFrom == comeFrom_ExpandVolume){
	    changeNeededCapacity(availableCapacity, neededCapacity);
	}else{
		document.getElementById("AvailablePoolCapacityTR").style.display = "";
	    document.getElementById("AdditionalCapacityNeededTR").style.display = "none";
	}*/
	var poolCapacityNumber = Number(document.getElementById(namespace_g + "myForm:poolCapacityNumber").value);
	if (poolCapacityNumber > 0) {
		document.getElementById("parent_expand_advanced").disabled = false;
		document.getElementById("parent_expand_easy").disabled = false;
		document.getElementById("parent_expand_easy").checked = true;
		
		clickRadio_ExpandPool();
	}
}


function initCreateBasicPoolRadio(parentRadios, childrenRadios, browser){
    var showExistingPoolObj = document.getElementById(namespace_g + "myForm:showExistingPool");
    var showExistingPool;
	var poolNumberObj   = document.getElementById(namespace_g + "myForm:poolNumber");
	var poolNumber = 0;

	if( poolNumberObj){
	    poolNumber = poolNumberObj.innerHTML;
	}
    
	if( showExistingPoolObj){
		showExistingPool = showExistingPoolObj.value;
	}

	if( showExistingPool == "false"){	    
	    parentRadios[0].disabled = false;
		childrenRadios[0].click();
	}else{
		parentRadios[0].disabled = false;	
		parentRadios[0].checked = true;	
		childrenRadios[0].click();
		parentRadios[1].checked = false;
	 
		if( poolNumber == 0 ) {				   	
		    parentRadios[1].disabled = true;
		    	    				    		
		}else {       	
		    parentRadios[1].disabled = false;		   	    	        	        	  	    
		}
	}	
}

// [SelectStoragePool.jsp]click radio event
//updated by hemingg
function clickRadio(radioObj){
	if(radioObj!=null)
	{
		if(!radioObj.checked)
		{
			radioObj.checked=true;
		}
	}
	forwardNextPage("false", true);	
	var parentRadios = document.getElementsByName("parent_creatPool");
	var childrenRadios  = document.getElementsByName("children_creatPool_new");
	var createType;
	
	if (parentRadios.length != 0) {
		if (parentRadios[0].checked){
			setCheckBoxChecked(selectStoragePool_page, false);
			setCheckBoxDisabled(selectStoragePool_page, true);
			childrenRadios[0].disabled = false;
			//childrenRadios[0].checked = true;
			childrenRadios[1].disabled = false;
			
			if (childrenRadios[0].checked) {
				createType = createBasicPool_page;
			} else if (childrenRadios[1].checked) {
				createType = createAdvancedPool_page;
			}
		}else if( parentRadios[1].checked){
			childrenRadios[0].checked = false;
			childrenRadios[1].checked = false;
			childrenRadios[0].disabled = true;
			childrenRadios[1].disabled = true;
			
			setCheckBoxDisabled(selectStoragePool_page, false);			
			//The radio button in the table should be selected by default.
	        setDefaultSelectedOption();	
			
			createType = definedVolumes_page;
		}
	} else {
		if (childrenRadios[0].checked) {
			createType = createBasicPool_page;
		} else if (childrenRadios[1].checked) {
			createType = createAdvancedPool_page;
		}
	}
	document.getElementById(namespace_g + "myForm:createType").value = createType;
	if(createType == createBasicPool_page || createType == createAdvancedPool_page){
	   forwardNextPage("true", true);
	}	
}

//[ExpandStoragePool.jsp] click radio event
function clickRadio_ExpandPool(){
	forwardNextPage("false", true);
	var expandEasy = document.getElementById("parent_expand_easy");
	var expandAdvanced = document.getElementById("parent_expand_advanced");
	var neededCapacity = parseDecimal(document.getElementById(namespace_g + "myForm:neededCapacity").value);
	var availableCapacity = parseDecimalEscapeHTMLTag(document.getElementById(namespace_g + "myForm:oldAvailableCapacity").innerHTML);
	var expandType = "";
	
	if (expandEasy.checked == true) {
		expandType = expandEasy.value;
	} else if (expandAdvanced.checked == true) {
		expandType = expandAdvanced.value;
	}

	if( expandType == "advanced"){    //  user select the expand pool advanced radio
		setCheckBoxChecked(expandStoragePool_page, false);
		setCheckBoxDisabled(expandStoragePool_page, true);
		document.getElementById("NextButtonID").value="myForm:SelectDrivesButton";
		
		//add judgement for system total capacity match needed capacity,by qiuhongyan
		//if not match,next button disable
		var totalAvailableCapacity = parseDecimal(document.getElementById(namespace_g + "myForm:totalAvailableCapacity").value);
		if( neededCapacity <= totalAvailableCapacity){
			forwardNextPage("true", true);
		}
	} else if (expandType == "easy"){     //  expandPool_easy		
		setCheckBoxDisabled(expandStoragePool_page, false);
		setDefaultSelectedOption();
		document.getElementById("NextButtonID").value="myForm:ExpandPoolConfirmButton";
	}
	
	if(neededCapacity && neededCapacity > availableCapacity){
		document.getElementById("AvailablePoolCapacityTR").style.display = "none";
    	document.getElementById("AdditionalCapacityNeededTR").style.display = "";
    	document.getElementById(namespace_g + "myForm:additionCapacityNeeded").innerHTML = formatDecimal(neededCapacity - availableCapacity);
	} else {
		document.getElementById("AvailablePoolCapacityTR").style.display = "";
		document.getElementById("AdditionalCapacityNeededTR").style.display = "none";
	}
}

//[SelectStoragePool.jsp] reset checkBox disabled properties
function setCheckBoxDisabled(page, flag) {
	var tableObj = null;
	if(page == selectStoragePool_page) {
		tableObj = document.getElementById(namespace_g + "myForm:existingPoolTable");
		document.getElementById(namespace_g + "myForm:expandPool").disabled = flag;	
	} else if (page == expandStoragePool_page) {
		tableObj = document.getElementById(namespace_g + "myForm:expandPoolCapacityOptionTable");			
	}
	
	if( tableObj){
		var chkboxesobj = tableObj.getElementsByTagName("input");
		for (var i = 0;i < chkboxesobj.length;i ++) {
			 if (chkboxesobj[i].type == "radio" || chkboxesobj[i].type == "checkbox") {
				chkboxesobj[i].disabled = flag;
			 }
		}
	}		
}

//[SelectStoragePool.jsp] reset checkBox checked properties
function setCheckBoxChecked(page, flag){
	var tableObj = null;
	if(page == selectStoragePool_page) {
		tableobj = document.getElementById(namespace_g + "myForm:existingPoolTable");		
		document.getElementById(namespace_g + "myForm:expandPool").checked = flag;
    } else if(page == expandStoragePool_page) {   	
		tableobj = document.getElementById(namespace_g + "myForm:expandPoolCapacityOptionTable");
    }
    
    if( tableobj){
	    var chkboxesobj = tableobj.getElementsByTagName("input");
	    if( chkboxesobj){
		    for (var i = 0;i < chkboxesobj.length;i ++) {
				if (chkboxesobj[i].type == "radio" || chkboxesobj[i].type == "checkbox") {
					chkboxesobj[i].checked = flag;
				}
			}
	    }    
    }
}

// common function : show error message 
function showErrorMsg(id_tr, id_span, errorMsg) {
   var objTr = document.getElementById(id_tr);
   var objSpan = document.getElementById(id_span);
	
   objTr.style.display="";
   objSpan.style.display = "";
   objSpan.innerHTML = errorMsg;  
   //defect 10385, add a popup dialog to indicate error happen, support accessbility  
   document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
   
}

// common function : clear error message 
function clearErrorMsg(pageTitle){
    if( pageTitle == definedVolumes_page){
        for( var i=0; i < errorMsg_tr.length; i++){
             id_tr = errorMsg_tr[i];
             objTr = document.getElementById(id_tr);
             objTr.style.display="none";
        }
        
        for( var k=0; k < errorMsg_span.length; k++){
        	 id_span = errorMsg_span[i];        	 
             objSpan = document.getElementById(id_span);
			 if(objSpan){
			 	objSpan.innerHTML ="";
			 }             
        }
    }else if( pageTitle == createBasicPool_page){
    	poolNameTr = document.getElementById("poolNameMsg_tr");
    	poolNameSpan = document.getElementById(namespace_g + "myForm:poolName_errMsg");
    	errorMsgTr = document.getElementById("errMsg_tr");
    	errorMsgSpan = document.getElementById("errMsg_span");
    	
        poolNameTr.style.display="none";
        errorMsgTr.style.display="none";
        poolNameSpan.innerHTML ="";
        errorMsgSpan.innerHTML ="";
    }
}

// Define Volumes JS begin
// init button disabled
function initPageButton(pageTitle){
    //forwardNextPage("false", true);	   
	if( pageTitle == definedVolumes_page){
		var prepareVolumesNumber = document.getElementById(namespace_g + "myForm:prepareVolumesNumber").innerHTML - 0;
		document.getElementById(namespace_g + "myForm:addButton").disabled = false;
				
		var quantity = document.getElementById(namespace_g + "myForm:quantity").value;
		if( quantity == ""){
			document.getElementById(namespace_g + "myForm:quantity").value = "1";
		}

		if( prepareVolumesNumber > 0){		    
		    for(var i=0; i < prepareVolumesNumber; i++){
				var checkbox  = document.getElementById(namespace_g + "myForm:newVolumesTable:"+i+":rowSelect1");
				if( checkbox){
					checkbox.checked = false;
				}
			}	
		}	
		
		refreshRemoveButton();	
		
		//indicate that the cursor should be placed in the first field(name) on the page by default.
		if (parent) {
			if( parent.getFrame("step_iframe").document.getElementById(parent.getFrame("step_iframe").namespace_g + "myForm:name") != null){	
				parent.getFrame("step_iframe").focus();   
				parent.getFrame("step_iframe").document.getElementById(parent.getFrame("step_iframe").namespace_g + "myForm:name").focus();
			}
		}else{
			document.getElementById(namespace_g + "myForm:name").focus();
		}
	}   
}

function setVolumeInputsStatus(isDisabled) {
	document.getElementById(namespace_g + "myForm:name").disabled = isDisabled;
	document.getElementById(namespace_g + "myForm:capacity").disabled = isDisabled;
	document.getElementById(namespace_g + "myForm:quantity").disabled = isDisabled;
	document.getElementById(namespace_g + "myForm:nameSuffix").disabled = isDisabled;
}

//validate number
var NUMBER_PATTERN = "[1-9]+[0-9]*";
function validateNumber(value){
  if( value != null){
	  if( value.match(NUMBER_PATTERN) == value){
	  	  return true;
	  } else{
	  	  return false;
	  }
  }
}

//---------handler the creating result(success of failed)----------------------------------------------------//
function handleCreateResult(){
	var result = document.getElementById(namespace_g + "myForm:createResult").value;
	//defect 8359,qiuhongyan,always go to create pool summary 
	document.getElementById(namespace_g + 'myForm:NextButton').click();
}
function clearItemErrorMsg(errIndex){
    document.getElementById(errorMsg_tr[errIndex]).display="none";
    document.getElementById(errorMsg_span[errIndex]).innerHTML="";
}
function validateSubmit(pageTitle, _event, target, width, height){
	var result = true;
	var isPopup_confirmDialog = false;
	var isNext = document.getElementById(namespace_g + "myForm:isNext");
// ------- begin: CreateBasicPool.jsp submit validate------- //
	if( pageTitle == createBasicPool_page){
		clearErrorMsg(createBasicPool_page);
	 	var poolName = document.getElementById(namespace_g + "myForm:poolName").value;
	 	var allPoolName = "," + document.getElementById(namespace_g + "myForm:allExistingPoolNameStr").innerHTML;
	 	var errMsg = null;
	    if( poolName == ""){ 
	        errMsg = document.getElementById(namespace_g + "myForm:poolNameErrorMessage").innerHTML;
			result = false;
	    }else{
	         if( poolName.length > 12){	    
	   		     errMsg = document.getElementById(namespace_g + "myForm:nameLength_ErrMsg").innerHTML;	    
	    		 result = false;
			 }
	         
	         if( allPoolName != null && allPoolName.indexOf(","+poolName+",") != -1){
	         	 errMsg = document.getElementById(namespace_g + "myForm:findDefinedPoolName_ErrMsg").innerHTML;
	    	 	 result = false;
	    	 }
	    }
	    if(!result){
	    	showErrorMsg('poolNameMsg_tr',namespace_g + 'myForm:poolName_errMsg', errMsg);
	        return result;	    
	    }
	    
	    var poolCapacityNumber = document.getElementById(namespace_g + "myForm:poolCapacityNumber").innerHTML;
	    if( poolCapacityNumber == 0){
	    	errMsg = document.getElementById(namespace_g + "myForm:no_availablePoolCapacity_ErrMsg").innerHTML;
	    	showErrorMsg('errMsg_tr','errMsg_span', errMsg); 
	    	return false;
	    }
	    if( isNext.value == "false"){	  
	        errMsg = document.getElementById(namespace_g + "myForm:no_selected_ErrMsg").innerHTML;	       
	        showErrorMsg('errMsg_tr','errMsg_span', errMsg); 
	        return false;
	    }
	    
	    // set pool name to inputHidden field for submit.
	    var poolName_submit = document.getElementById(namespace_g + "myForm:poolName_submit");
	    if( poolName){
			poolName_submit.value = poolName;
		}
		
	    isPopup_confirmDialog = true;
	}
// ------- end: CreateBasicPool.jsp submit validate------- //


// ------- begin: CreateAdvancedPool.jsp submit validate------- //
	if (pageTitle == createAdvancedPool_page) {
		var poolName = document.getElementById(namespace_g + "myForm:poolName").value;
		var existedName = ","+document.getElementById(namespace_g + "myForm:existedPoolName").innerHTML;
		if (poolName == "") {
			var errMsg = document.getElementById(namespace_g + "myForm:CreatePoolAdvanced_ErrMsg_PoolNameNull").innerHTML;
		    document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display="";
		    document.getElementById(namespace_g + "myForm:poolName_errMsg").innerHTML = errMsg;
		    return false;
		}

		if (existedName.indexOf(","+poolName+",") != -1) {
//			var errMsg = document.getElementById(namespace_g + "myForm:CreatePoolAdvanced_ErrMsg_PoolNameExisted").innerHTML;
			document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display="";
//			document.getElementById(namespace_g + "myForm:poolName_errMsg").innerHTML = errMsg;
			return false;
		}
		
		if( isNext.value == "false"){
//		    var errMsg = document.getElementById(namespace_g + "myForm:CreatePoolAdvanced_ErrMsg_DiskCountUncorrect").innerHTML;
		    document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display="";
//		    document.getElementById("DiskCount_Err").innerHTML = errMsg;
		    return false;
		}
		isPopup_confirmDialog = true;
	}
// ------- end: CreateAdvancedPool.jsp submit validate------- //


// ------- begin: DefineVolumes.jsp submit validate------- //	
	if( pageTitle == definedVolumes_confirm){
		isPopup_confirmDialog = true;	
	}	
// ------- end: DefineVolumes.jsp submit validate------- //

// ------- begin: Popup a confirm pannelDialog ------- //
	if( isPopup_confirmDialog){			
		popup_dialog(width, height);
	}
// ------- end: Popup a pannelDialog ------- //
	
	return result;
}

/* ------- Popup a confirm pannelDialog  ------ */ 
function popup_dialog(width, height){

    if( document.getElementById('templ_u_iframe').src != ''){
	    document.getElementById('templ_u_iframe').src = '';
	}  

	document.getElementById(namespace_g + "myForm").target="templ_u_iframe";
	adjustDialogSize(width,height);
/*
	if( width == null || width == ''){	
	    width = 500;
	}
	if( height == null || height == ''){
	    height = 400;
	}

	document.getElementById("templ_u_iframe").style.width = width * 0.95;
	document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.width = width;
    	
	document.getElementById(namespace_g + "myForm:util_subview:util_dialog").style.height = height;
	// when clicking more than twice,style.height has problem.		
	document.getElementById(namespace_g + "myForm:util_subview:util_dialog_tb").lastChild.nodeValue = document.getElementById(namespace_g + "myForm:confirmationMessage").innerHTML;
*/	
}

/* ------- validate pool name ------ */
function validateName(id){
	var name = document.getElementById(id).value;
	var nameSuffix = document.getElementById(namespace_g + "myForm:nameSuffix").value;
	var quantity = Number(document.getElementById(namespace_g + "myForm:quantity").value);	
	var sumLength = 0;
	if( name == ""){
	    showErrorMsg('nameMsg_tr','nameMsg_span', name_null_ErrMsg);  
	    return false;
	}
	
	//Since quantity and suffix is validated before validating name, here consider quantity and suffix are valid.
	//Change the algorithm of getting the longest name length for defect CQ11249
	if(quantity == 1){
		sumLength = name.length + nameSuffix.length;
	}else{// other valid quantity values are greater than 1
		sumLength = name.length + ((Number(nameSuffix)+quantity-1)+"").length;
	}
	
	if( sumLength > 12 || sumLength < 1 || name.length == 0 ){	    
	    showErrorMsg('nameMsg_tr','nameMsg_span', nameLength_ErrMsg); 
	    return false;
	}
	
	if( !isDeviceNameValid(name)){
	    showErrorMsg('nameMsg_tr','nameMsg_span', nameCharacters_ErrMsg); 
	    return false;
	}
	
	clearItemErrorMsg(0);
	return true;    
}
//defect 7170,add by qiuhongyan.
function validateNameWithoutErrorMsg(id){
	var name = document.getElementById(id).value;
	var nameSuffix = document.getElementById(namespace_g + "myForm:nameSuffix").value;
	var quantity = Number(document.getElementById(namespace_g + "myForm:quantity").value);	
	var sumLength = 0;
	if( name == ""){
	    return false;
	}
	
	
	//Since quantity and suffix is validated before validating name, here consider quantity and suffix are valid.
	//Change the algorithm of getting the longest name length for defect CQ11249
	if(quantity == 1){
		sumLength = name.length + nameSuffix.length;
	}else{// other valid quantity values are greater than 1
		sumLength = name.length + ((Number(nameSuffix)+quantity-1)+"").length;
	}
	if( sumLength > 12 || sumLength < 1 || name.length == 0 ){	    
	    return false;
	}
	
	if( !isDeviceNameValid(name)){
	    return false;
	}
	
	return true;   
}
/* ------- validate the new volumes  ------ */
function validateAdd(){
	//document.getElementById(namespace_g + "myForm:addButton").disabled=true;
	
	var allCreatedVolumeNameStr = "," + document.getElementById(namespace_g + "myForm:allCreatedVolumeNameStr").innerHTML;
	var nameObj = document.getElementById(namespace_g + "myForm:name");
	var quantityObj = document.getElementById(namespace_g + "myForm:quantity");	
	var capacityObj = document.getElementById(namespace_g + "myForm:capacity");
	var nameSuffixObj = document.getElementById(namespace_g + "myForm:nameSuffix");
	var result = true;
	//Since validate name need correct quantity, validate quantity first.
	if( ! validateQuantity(quantityObj.id)){
	     result = false;
	}
	else if( quantityObj.value > 1 && nameSuffixObj.value == ""){
		showErrorMsg('nameSuffixMsg_tr','nameSuffixMsg_span', nameSuffix_null_ErrMsg);		
		result = false;
	}
	else if( nameSuffixObj.value != ""){
		if( ! validateNameSuffix(nameSuffixObj.id)){
			 result = false;
		}
	}
	
	if (result) {
		// validate name
		if (!validateName(nameObj.id)) {
			result = false;
		}else if (!validateCapacity(capacityObj.id)) {
				result = false;
		}else if (!validateexceedCapacity()) {
					result = false;
		}
	}
	if(result){
		for( var i=0; i < quantityObj.value; i++){
			 if( nameSuffixObj.value == ""){
			     newName = "," + nameObj.value + ",";
			 }else{
			 	 index = parseInt(nameSuffixObj.value)+i;
		     	 newName = "," + nameObj.value + index + ",";
			 }
	
		     if( allCreatedVolumeNameStr.indexOf(newName) != -1){
		         showErrorMsg('nameMsg_tr','nameMsg_span', findDefinedName_ErrMsg);	   
		    	 result = false;
		     }
		}
	}
	if(result){
	   document.getElementById(namespace_g + "myForm:addButton").disabled=true;
	   document.getElementById(namespace_g + "myForm:createType").value = definedVolumes_page;
	   document.getElementById(namespace_g + "myForm:createStep").value = definedVolumes_confirm;
	   document.getElementById(namespace_g + "myForm:nameSuffix_value").value = document.getElementById(namespace_g + "myForm:nameSuffix").value;
	   document.getElementById(namespace_g + "myForm:actionStr").value = "prepareVolume";
	   document.getElementById(namespace_g + "myForm:load").value = "loadFinished";
	   document.getElementById(namespace_g + "myForm:clickbtn").click();
	}else{
	/*
	//comment by qiuhongyan, cannot see bellow code make sense here.
	if (document.getElementById(namespace_g + "myForm:nameSuffix").value== ""){
	   document.getElementById(namespace_g + "myForm:nameSuffix").value = "";
	   document.getElementById(namespace_g + "myForm:nameSuffix").disabled = true;	   
	   document.getElementById(namespace_g + "myForm:exampleName").innerHTML = document.getElementById(namespace_g + "myForm:name").value;}
	*/   
	}
	refreshRemoveButton();
	
	return result;	
}

function enableAddButton(){
    document.getElementById(namespace_g + "myForm:addButton").disabled=false;
}

function disableAddButton(){
    document.getElementById(namespace_g + "myForm:addButton").disabled=true;
}
/* ------- validate pool capacity ------ */
function validateCapacity(id){	
    var capacityValue = document.getElementById(id).value;
	var capNum = Number(capacityValue);
	
	if(capacityValue == ""){
	    showErrorMsg('capacityMsg_tr','capacityMsg_span', capacity_null_ErrMsg);
	    return false;
	}else if(isNaN(capNum)){
		showErrorMsg('capacityMsg_tr','capacityMsg_span', capacity_min_ErrMsg);	
		return false;
	}
	 
	if( capacityValue.indexOf(".") == 0 || capacityValue.indexOf(".") == (capacityValue.length-1)) {
		showErrorMsg('capacityMsg_tr','capacityMsg_span', non_numeric_ErrMsg);	
		return false;
	}
	
	if( capNum <= 0){
  		showErrorMsg('capacityMsg_tr','capacityMsg_span', capacity_minimum_size_ErrMsg);
  		return false;
  	}

  	if(capNum > maxCapacity){	
        showErrorMsg('capacityMsg_tr','capacityMsg_span', capacity_size_ErrMsg);
  		return false;
  	} 
	/* now the define volume support float value
	 * commented by jmzhang
	 **/
	/*
	if (capacityValue.indexOf(".") > 0 && capacityValue.substring(capacityValue.lastIndexOf(".")+1).length > 3) {
		showErrorMsg('capacityMsg_tr','capacityMsg_span', three_decima_ErrMsg);
		return false;		
	}*/
	if (capacityValue.indexOf(".") > 0){
	if (capacityValue.split("\\.").length > 2 || capacityValue.substring(capacityValue.lastIndexOf(".")+1).length > 3) {
		showErrorMsg('capacityMsg_tr','capacityMsg_span', three_decima_ErrMsg);
			return false;
		}
	}

  	clearItemErrorMsg(1);
  	return true;
}
function validateCapacityWithoutErrorMsg(id){	
    var capacityValue = document.getElementById(id).value;
	var capNum = Number(capacityValue);
	
	if(capacityValue == ""){
	    return false;
	}else if(isNaN(capNum)){
		return false;
	}
	 
	if( capacityValue.indexOf(".") == 0 || capacityValue.indexOf(".") == (capacityValue.length-1)) {
		return false;
	}
	
	if( capNum <= 0){
  		return false;
  	}

  	if(capNum > maxCapacity){	
  		return false;
  	} 	
	/* now the define volume support float value
	 * commented by jmzhang
	 **/
	/*
	if (capacityValue.indexOf(".") > 0 && capacityValue.substring(capacityValue.lastIndexOf(".")+1).length > 3) {
		return false;		
	}*/
	if (capacityValue.indexOf(".") > 0){
		if (capacityValue.split("\\.").length > 2 || capacityValue.substring(capacityValue.lastIndexOf(".")+1).length > 3) {
			return false;
		}
	}
  	return true;
}

/* ------- validate pool name suffix ------ */
function validateNameSuffix(id){
    var nameSuffixValue = document.getElementById(id).value;
	if( !validateNumber(nameSuffixValue)){
		showErrorMsg('nameSuffixMsg_tr','nameSuffixMsg_span', nameSuffix_non_numeric_ErrMsg);
		return false;
	}
	
	if( Number(nameSuffixValue) < 1){
		showErrorMsg('nameSuffixMsg_tr','nameSuffixMsg_span', nameSuffix_min_ErrMsg);
		return false;
	}
	
	clearItemErrorMsg(3);	
	return true;
}
function validateNameSuffixWithoutErrorMsg(id){
    var nameSuffixValue = document.getElementById(id).value;
	if( !validateNumber(nameSuffixValue)){
		return false;
	}
	
	if( Number(nameSuffixValue) < 1){
		return false;
	}
	
	return true;
}	
/* ------- validate pool quantity ------ */
function validateQuantity(id){
   var quantityValue = document.getElementById(id).value;
   var createdVolumeNumber = document.getElementById(namespace_g + "myForm:createdVolumeNumber").innerHTML - 0;
   var prepareVolumesNumber = document.getElementById(namespace_g + "myForm:prepareVolumesNumber").innerHTML - 0;
    
	if( quantityValue == ""){
	    showErrorMsg('quantityMsg_tr','quantityMsg_span', quantity_null_ErrMsg);
	    return false;
	}else if( !validateNumber(quantityValue) ){
		showErrorMsg('quantityMsg_tr','quantityMsg_span', quantity_non_numeric_ErrMsg);
		return false;
	}

    if( quantityValue < 1 ){
       showErrorMsg('quantityMsg_tr','quantityMsg_span', quantity_min_ErrMsg);
       return false;
    }
   
 	if( quantityValue > maxQuantity){
       showErrorMsg('quantityMsg_tr','quantityMsg_span', volumesNum_ErrMsg);
       return false;
    }

   if( quantityValue == 1 || quantityValue == 0){
       document.getElementById(namespace_g + "myForm:nameSuffix").value = "";
       document.getElementById(namespace_g + "myForm:nameSuffix").disabled = true;
   }else if(quantityValue > 1){
   		if (document.getElementById(namespace_g + "myForm:nameSuffix").value == "") {
   	   		document.getElementById(namespace_g + "myForm:nameSuffix").value = "1";
   	   	}
       document.getElementById(namespace_g + "myForm:nameSuffix").disabled = false;
   }
   
   var sum = Number(quantityValue) + Number(createdVolumeNumber) + Number(prepareVolumesNumber);;
   if( sum > maxQuantity){
       showErrorMsg('quantityMsg_tr','quantityMsg_span', volumesNum_ErrMsg);
       return false;
   }
   
   clearItemErrorMsg(2);     
   return true;   
}
function validateQuantityWithoutErrorMsg(id,fromEvent){
   var quantityValue = document.getElementById(id).value;
   var createdVolumeNumber = document.getElementById(namespace_g + "myForm:createdVolumeNumber").innerHTML - 0;
   var prepareVolumesNumber = document.getElementById(namespace_g + "myForm:prepareVolumesNumber").innerHTML - 0;
    
	if( quantityValue == ""){
	    return false;
	}else if( !validateNumber(quantityValue) ){
		return false;
	}

    if( quantityValue < 1 ){
       return false;
    }
   
 	if( quantityValue > maxQuantity){
       return false;
    }

   if( quantityValue == 1 || quantityValue == 0){
       document.getElementById(namespace_g + "myForm:nameSuffix").value = "";
       document.getElementById(namespace_g + "myForm:nameSuffix").disabled = true;
   }else if(quantityValue > 1){
   		if (document.getElementById(namespace_g + "myForm:nameSuffix").value == ""&&
   		    fromEvent=="onblur") {
   	   		document.getElementById(namespace_g + "myForm:nameSuffix").value = "1";
   	   	}
       document.getElementById(namespace_g + "myForm:nameSuffix").disabled = false;
   }
   
   var sum = Number(quantityValue) + Number(createdVolumeNumber) + Number(prepareVolumesNumber);;
   if( sum > maxQuantity){
       return false;
   }
   return true;   
}

function disableSuffixField(){
	var quantityValue = document.getElementById(namespace_g + "myForm:quantity").value;
	var nameSuffixObj = document.getElementById(namespace_g + "myForm:nameSuffix");
	if(""!=quantityValue && validateNumber(quantityValue) && quantityValue > 1){
		if(""==nameSuffixObj.value){
			nameSuffixObj.value = "1";
		}
		nameSuffixObj.disabled = false;
	}else{
		nameSuffixObj.value = "";
		nameSuffixObj.disabled = true;
	}
	
}
/* ------- validate availablecapacity ------ */
function validateexceedCapacity(){
	var newAvailableCapacity = document.getElementById(namespace_g + "myForm:newAvailableCapacity").innerHTML;
	var capacityValue = document.getElementById(namespace_g + "myForm:capacity").value;
	var quantityValue = document.getElementById(namespace_g + "myForm:quantity").value; 
	var nameSuffixValue = document.getElementById(namespace_g + "myForm:nameSuffix").value; 
	newAvailableCapacity = Number(newAvailableCapacity);
	
	if( newAvailableCapacity < quantityValue * capacityValue){
		showErrorMsg('capacityMsg_tr','capacityMsg_span', capacity_exceedAvailableCapacity_ErrMsg);
	    return false;
	}
	
	return true;
}

function validateRemove(){
	document.getElementById(namespace_g + "myForm:actionStr").value = "removeVolume";
	document.getElementById(namespace_g + "myForm:removeButton").disabled = true;	
	
	//submit the remove action
	document.getElementById(namespace_g + "myForm:load").value = "loadFinished";
	document.getElementById(namespace_g + "myForm:clickbtn").click();	
	
	// disabled radioBox in newVolumesTable when remove volume
	var tableObj = document.getElementById(namespace_g + "myForm:newVolumesTable");
	if( tableObj){
		var checkboxesobj = tableObj.getElementsByTagName("input");
		for (var i = 0;i < checkboxesobj.length;i ++) {
			 if (checkboxesobj[i].type == "checkbox" || checkboxesobj[i].checked == false) {
				 checkboxesobj[i].disabled = true;
			 }
		}
	}	
}

/* ------- show allcated bar ------ */
function overlapTables()
{
	var allocated = Number(document.getElementById(namespace_g + "myForm:allocated").innerHTML);
	
	if(allocated != 0){
		if(document.getElementById("td1").style.display != ""){
			document.getElementById("td1").style.display = "";
		}
		document.getElementById("td1").style.width = allocated;
		document.getElementById("td2").style.width = 100-allocated;
	}else{
		document.getElementById("td1").style.display = "none";
	}
	 
}

function setBasicButtonID() {
	var hiddenIDobj = document.getElementById("NextButtonID");
	hiddenIDobj.value = namespace_g + "myForm:ConfirmSubmit";
}

// start of the functions for advanced

/* -----  initialization functions ------ */
function loadAjaxB() {
	document.getElementById(namespace_g + "myForm:ajaxbuttonB").click();
}

function judgeSelectItems() {
	var drivetypeboolean = document.getElementById(namespace_g + "myForm:driveTypeSelectable").value;
	var raidlevelboolean = document.getElementById(namespace_g + "myForm:raidLevelSelectable").value;
	if (drivetypeboolean == "false") {
		document.getElementById(namespace_g + "myForm:driveType").style.display = "none";
		if (document.getElementById(namespace_g + "myForm:driveType").options != null && document.getElementById(namespace_g + "myForm:driveType").options.length > 0) {
			var obj = document.getElementById(namespace_g + "myForm:driveType");
			var strsel = obj.options[obj.selectedIndex].text;
			document.getElementById("driveTypeStatic").innerHTML = strsel;
		} else {
			document.getElementById("driveTypeStatic").innerHTML = document.getElementById(namespace_g + "myForm:no_available_option_text").innerHTML;
		}
		document.getElementById("driveTypeStatic").style.display = "";
		document.getElementById("driveTypeStatic").style.whiteSpace= "nowrap";
	} else {
		document.getElementById("driveTypeStatic").style.display = "none";
		document.getElementById(namespace_g + "myForm:driveType").style.display = "";
	}
	
	if (raidlevelboolean == "false") {
		document.getElementById(namespace_g + "myForm:raidLevel").style.display = "none";
		if (document.getElementById(namespace_g + "myForm:raidLevel").options != null && document.getElementById(namespace_g + "myForm:raidLevel").options.length > 0) {
			document.getElementById("raidLevelStatic").innerHTML = document.getElementById(namespace_g + "myForm:raidLevel").options[0].value;
		} else {
			document.getElementById("raidLevelStatic").innerHTML = document.getElementById(namespace_g + "myForm:no_available_option_text").innerHTML;
		}
		document.getElementById("raidLevelStatic").style.display = "";
	} else {
		document.getElementById(namespace_g + "myForm:raidLevel").style.display = "";
		document.getElementById("raidLevelStatic").style.display = "none";
	}
	
	showGlobalSparesLabel();
}

//show Global Spares Label according to RAID Level[CreateBasicPool.jsp and CreateBasicPoolCompletion.jsp]
function showGlobalSparesLabel(){	
	var basicPoolGlobalHotSparesValue = document.getElementById(namespace_g + "myForm:basicPoolGlobalHotSpares").innerHTML;
	var globalSpareImgObj = document.getElementById(namespace_g + "myForm:globalSpareImg");
	var globalHotSparesSubObj = document.getElementById(namespace_g + "myForm:globalHotSparesSub");
	
	if( basicPoolGlobalHotSparesValue && globalSpareImgObj && globalHotSparesSubObj){
		if( basicPoolGlobalHotSparesValue.indexOf("---") > -1){ //RAID 0
		    globalHotSparesSubObj.style.display = "none";
		    globalSpareImgObj.style.display = "none";
		}else{
			globalHotSparesSubObj.style.display = "";
			globalSpareImgObj.style.display = "";
		}
	}	
}

function init_PostLoad() {
	initButton();
	refreshRequiredDisk();
	refreshDiv();
	poolUsedDiskSizeArray = new Array();
	refreshInformation();
	refreshButton();
	document.getElementById("selectedNumber").style.display = "";	
	if (document.getElementById("leftTable")) {
	document.getElementById("leftTable").className = "dataTableBorder";
	}
	forwardNextPage("true", true);
}

function initButton() {
	var addoneButton = document.getElementById(namespace_g + "myForm:oneAddedDiskAddButton");
	var removeoneButton = document.getElementById(namespace_g + "myForm:oneAddedDiskRemoveButton");
	var addtwoupButton = document.getElementById(namespace_g + "myForm:twoAddedDiskUpAddButton");
	var addtwodownButton = document.getElementById(namespace_g + "myForm:twoAddedDiskDownAddButton");
	var removetwoupButton = document.getElementById(namespace_g + "myForm:twoAddedDiskUpRemoveButton");
	var removetwodownButton = document.getElementById(namespace_g + "myForm:twoAddedDiskDownRemoveButton");
	var okButton = document.getElementById(namespace_g + "myForm:okbutton");
	
	addoneButton.disabled = "disabled";
	removeoneButton.disabled = "disabled";
	addtwoupButton.disabled = "disabled";
	addtwodownButton.disabled = "disabled";
	removetwoupButton.disabled = "disabled";
	removetwodownButton.disabled = "disabled";
	if (okButton) {
		okButton.disabled = "disabled";
	}
}
/* ----- end of initialization ------ */


/* ----- refresh functions ------ */
function onRefreshMenu() {
	var selMenuType = document.getElementById(namespace_g + "myForm:driveType");
	var selMenuLevel = document.getElementById(namespace_g + "myForm:raidLevel");
	var hidType = document.getElementById(namespace_g + "myForm:hidDriveType");
	var hidLevel = document.getElementById(namespace_g + "myForm:hidRaidLevel");
	hidType.value = selMenuType.options[selMenuType.selectedIndex].value;
	hidLevel.value = selMenuLevel.options[selMenuLevel.selectedIndex].value;
	
	document.getElementById(namespace_g + "myForm:MenuChangeImage").style.display = "";
	document.getElementById(namespace_g + "myForm:waiting_MenuChange_text").style.display = "";	
	document.getElementById("availableDiskHTMLTable").style.display = "none";

	disablePoolNameInput();// Disable the user input on pool name
	
	loadAjaxB();
}

function refreshRequiredDisk() {
	var switches = retreiveType();
	var raidstype = retreiveRaidLevel();
	var tag = document.getElementById(namespace_g + "myForm:tag").value;
	if (tag == "CreateAdvancedPool") {
		if(switches == "1") {
			var requiredDisks = getRequiredDisks();
			var showRequireObj = document.getElementById(namespace_g + "myForm:txtMinimumNumberOfDisks");
			showRequireObj.innerHTML = requiredDisks.trim();
		}else if(switches == "2") {
			var showRequireObj = document.getElementById(namespace_g + "myForm:txtMinimumPoolConfiguration");
			showRequireObj.innerHTML = getMiniPoolConfig().trim();
		}
	}
}

function getRequiredDisks() {
	var raidsRequired = document.getElementById(namespace_g + "myForm:requiredDisks").value;
	var raidstype = retreiveRaidLevel();
	var showArray = raidsRequired.split("|");
	for (var i = 0;i < showArray.length;i ++) {
		var typeArray = showArray[i].split("_");
		if (raidstype == typeArray[0]) {
			return typeArray[1];
		}
	}
}

function getMiniPoolConfig() {
	var raidsRequired = document.getElementById(namespace_g + "myForm:miniPoolConfiguration").value;
	var raidstype = retreiveRaidLevel();
	var showArray = raidsRequired.split("|");
	for (var i = 0;i < showArray.length;i ++) {
		var typeArray = showArray[i].split("_");
		if (raidstype == typeArray[0]) {
			return typeArray[1];
		}
	}	
}	

function refreshInformation() {
	var raidLevel = retreiveRaidLevel();
	var switches = retreiveType();
	var requiredDisks = getRequiredDisks();

	//var requiredDisks = document.getElementById(namespace_g + "myForm:txtMinimumNumberOfDisks").innerHTML;
	var availablecount = countCheckBox("availableDiskTable" , false);
	var onecount = countCheckBox("oneAddedDiskTable" , false);
	var twoAcount = countCheckBox("twoAddedDiskATable" , false);
	var twoBcount = countCheckBox("twoAddedDiskBTable" , false);
	
	var singleCap = 0;
	
	var tag = document.getElementById(namespace_g + "myForm:tag").value;
	if( tag == "CreateAdvancedPool"){		
		singleCap = document.getElementById(namespace_g + "myForm:driveType");	
		singleCap = singleCap.options[singleCap.selectedIndex].value;	
		var driveTypeArray = singleCap.split("_");
		singleCap = Number(driveTypeArray[0])/1024/1024/1024;
	}else if( tag == "ExpandPool"){
	    var singleCapObject = document.getElementById(namespace_g + "myForm:driveType_key_ID");
		var GBlbl = document.getElementById(namespace_g + "myForm:GBLabel").innerHTML;
		if(singleCapObject!=null){
			singleCap = singleCapObject.innerHTML;
			var driveTypeArray = singleCap.split("_");
			singleCap = Number(driveTypeArray[0])/1024/1024/1024;
		}else{
			singleCap = 0;
		}
	}
	
	if( tag == "CreateAdvancedPool"){
		var addedNumber = document.getElementById(namespace_g + "myForm:txtAddedNumberOfDisks");	
		var txtAddedNumber = document.getElementById(namespace_g + "myForm:addedNumberOfDisks");
		var txtMinimumNumberOfDisks = document.getElementById(namespace_g + "myForm:txtMinimumNumberOfDisks");
		var minimumNumberOfDisks = document.getElementById(namespace_g + "myForm:minimumNumberOfDisks");
		var minimumPoolConfiguration = document.getElementById(namespace_g + "myForm:minimumPoolConfiguration");
		var txtMinimumPoolConfiguration = document.getElementById(namespace_g + "myForm:txtMinimumPoolConfiguration");
		var newPoolConfiguration = document.getElementById(namespace_g + "myForm:newPoolConfiguration");
		var txtNewPoolConfiguration = document.getElementById(namespace_g + "myForm:txtNewPoolConfiguration");
		
		var GBNLS = document.getElementById(namespace_g + "myForm:GBLabel").innerHTML;
		
		var totalCap = document.getElementById(namespace_g + "myForm:txtTotalNewPoolCapacity");
		var remainCap = document.getElementById(namespace_g + "myForm:txtRemainingSystemCapacity");
		
		totalCap.innerHTML = "0 " + GBNLS;
		
		document.getElementById(namespace_g + "myForm:help_addedDisk_one").style.display = "none";
		document.getElementById(namespace_g + "myForm:help_addedDisk_two").style.display = "none";
		document.getElementById("space_one").style.display = "none";
		document.getElementById("space_two").style.display = "none";
		
		if (switches == "1") {
		//added by jiaoyong
			document.getElementById("oneRowA").style.display = "";
			document.getElementById("oneRowB").style.display = "";
			document.getElementById("twoRowA").style.display = "none";
			document.getElementById("twoRowB").style.display = "none";
			
			addedNumber.innerHTML = onecount;
			if (onecount >= requiredDisks) {
				if (raidLevel == RSSM_RAID_TYPE_RAID5) {
					// calculate the capacity for RAID 5
					totalCap.innerHTML = formatDecimal(getCapacityFromSelection(RSSM_RAID_TYPE_RAID5)) + " " + GBNLS;
				} else {
					totalCap.innerHTML = formatDecimal(getCapacityFromSelection(RSSM_RAID_TYPE_RAID0)) + " " + GBNLS;
				}
			} else {
				document.getElementById("space_one").style.display = "";
				document.getElementById(namespace_g + "myForm:help_addedDisk_one").style.display = "";
			}
		} else if (switches == "2") {
			//added by jiaoyong
			// modified by Jia Ming
			document.getElementById("oneRowA").style.display = "none";
			document.getElementById("oneRowB").style.display = "none";
			document.getElementById("twoRowA").style.display = "";
			document.getElementById("twoRowB").style.display = "";
			

			txtNewPoolConfiguration.innerHTML = twoAcount + "+" + twoBcount;

			if (twoAcount >= requiredDisks / 2 && twoBcount >= requiredDisks / 2 && twoAcount == twoBcount){
				totalCap.innerHTML = formatDecimal(getCapacityFromSelection(MIROR_RAID_TPYES)) + " " + GBNLS;
			} else {
				document.getElementById("space_two").style.display = "";
				document.getElementById(namespace_g + "myForm:help_addedDisk_two").style.display = "";
			}
		}
		
		remainCap.innerHTML = getAvailableSystemCapacity(namespace_g + "myForm:availableDiskTable") + " " + GBNLS;
	}else if( tag == "ExpandPool"){	
		var totalCapacity = parseDecimalEscapeHTMLTag(document.getElementById(namespace_g + "myForm:totalCapacity").innerHTML);
		
		var availableCapacity = parseDecimalEscapeHTMLTag(document.getElementById(namespace_g + "myForm:hidden_availableCapacity").innerHTML);
		var diskNumber = document.getElementById(namespace_g + "myForm:diskNumber").innerHTML;
		var comeFrom = document.getElementById(namespace_g + "myForm:comeFrom").value;
		var neededCapacity = document.getElementById(namespace_g + "myForm:neededCapacity").value;
		var usedCapacity = totalCapacity - availableCapacity;
		var addedCapacity = 0;
		var newAvailable = 0;
		var addedDisk = 0;
		if (comeFrom == comeFrom_ExpandVolume) {
			if (switches == "1") {
				document.getElementById(namespace_g + "myForm:value_right_1").innerHTML = onecount;
				document.getElementById(namespace_g + "myForm:value_right_2").innerHTML = formatDecimal(Number(totalCapacity) + Number(singleCap * onecount));
				document.getElementById(namespace_g + "myForm:value_right_2_gb").style.display = "";
				document.getElementById(namespace_g + "myForm:value_right_4").innerHTML = formatDecimal(singleCap * availablecount);
				var tempAvailableCapacity = Number(singleCap * onecount) + Number(availableCapacity);
				if (tempAvailableCapacity > neededCapacity) {
					document.getElementById(namespace_g + "myForm:value_right_3").innerHTML = formatDecimal(tempAvailableCapacity - neededCapacity);
					newAvailable = tempAvailableCapacity - neededCapacity;
				} else {
					document.getElementById(namespace_g + "myForm:value_right_3").innerHTML = availableCapacity;
				}
				changeNeededCapacity(tempAvailableCapacity , neededCapacity);
				addedCapacity = singleCap * onecount;
				addedDisk = onecount;
			} else if (switches == "2" && twoAcount == twoBcount) {
				document.getElementById(namespace_g + "myForm:value_right_1").innerHTML = Number(diskNumber/2) + " + " + Number(diskNumber/2);
				document.getElementById(namespace_g + "myForm:value_right_2").innerHTML = Number(diskNumber/2 + twoAcount) + " + " + Number(diskNumber/2 + twoAcount);
				document.getElementById(namespace_g + "myForm:value_right_2_gb").style.display = "none";
				document.getElementById(namespace_g + "myForm:value_right_3").innerHTML = formatDecimal(Number(totalCapacity) + Number(singleCap * twoAcount));
				document.getElementById(namespace_g + "myForm:value_right_5").innerHTML = formatDecimal(singleCap * availablecount);
				
				var tempAvailableCapacity = Number(singleCap * twoAcount) + Number(availableCapacity);
				if (tempAvailableCapacity > neededCapacity) {
					document.getElementById(namespace_g + "myForm:value_right_4").innerHTML = formatDecimal(tempAvailableCapacity - neededCapacity);
					newAvailable = tempAvailableCapacity - neededCapacity;
					changeNeededCapacity(tempAvailableCapacity - neededCapacity , neededCapacity);
				} else {
					document.getElementById(namespace_g + "myForm:value_right_4").innerHTML = formatDecimal(availableCapacity);
					changeNeededCapacity(tempAvailableCapacity , neededCapacity);
				}
				addedCapacity = singleCap * twoAcount;
				addedDisk = twoAcount * 2;
			}
		} else {    // come from expand pool
			if (switches == "1") {	
			    addedDisk = onecount;
			    var newTotalCapacity = 0;	
			    	
				var diskNumber = document.getElementById(namespace_g + "myForm:diskNumber").innerHTML;
				newTotalCapacity = calculateCapacity(raidLevel, singleCap, Number(onecount) + Number(diskNumber));					
				newAvailable = newTotalCapacity - usedCapacity;
				addedCapacity = newTotalCapacity - totalCapacity;
				
				document.getElementById(namespace_g + "myForm:value_right_2").innerHTML = formatDecimal(newTotalCapacity);
				document.getElementById(namespace_g + "myForm:value_right_2_gb").style.display = "";
				document.getElementById(namespace_g + "myForm:value_right_3").innerHTML = formatDecimal(newAvailable);
				document.getElementById(namespace_g + "myForm:value_right_4").innerHTML = formatDecimal(singleCap * availablecount);
				document.getElementById(namespace_g + "myForm:value_right_1").innerHTML = formatDecimal(onecount);
			} else if (switches == "2" && twoAcount == twoBcount) {
				addedDisk = twoAcount * 2;
				var newTotalCapacity = 0;
				var diskNumber = document.getElementById(namespace_g + "myForm:diskNumber").innerHTML;
				newTotalCapacity = calculateCapacity(raidLevel, singleCap, Number(addedDisk) + Number(diskNumber));					
				newAvailable = newTotalCapacity - usedCapacity;
				addedCapacity = newTotalCapacity - totalCapacity;
				
				document.getElementById(namespace_g + "myForm:value_right_1").innerHTML = Number(diskNumber/2) + " + " + Number(diskNumber/2);
				document.getElementById(namespace_g + "myForm:value_right_2").innerHTML = Number(diskNumber/2 + twoAcount) + " + " + Number(diskNumber/2 + twoAcount);
				document.getElementById(namespace_g + "myForm:value_right_2_gb").style.display = "none";
				document.getElementById(namespace_g + "myForm:value_right_3").innerHTML = formatDecimal(newTotalCapacity);
				document.getElementById(namespace_g + "myForm:value_right_4").innerHTML = formatDecimal(newAvailable);
				document.getElementById(namespace_g + "myForm:value_right_5").innerHTML = formatDecimal(singleCap * availablecount);
			}
			document.getElementById("AvailablePoolCapacityTR").style.display = "";
		    document.getElementById("AdditionalCapacityNeededTR").style.display = "none";
		}
		
		document.getElementById(namespace_g + "myForm:originalCapacity_confirmMessage").value = totalCapacity;
		document.getElementById(namespace_g + "myForm:additionalCapacity_confirmMessage").value = formatDecimal(addedCapacity);
		document.getElementById(namespace_g + "myForm:newTotalCapacity_confirmMessage").value = formatDecimal(Number(totalCapacity) + Number(addedCapacity));
		document.getElementById(namespace_g + "myForm:newAvailableCapacity_confirmMessage").value = formatDecimal(newAvailable);
		document.getElementById(namespace_g + "myForm:additionalDisks_confirmMessage").value = addedDisk;
	}
}

function calculateCapacity(raidLevel, singleCap, diskcount){
	var capacity = 0;
	
	var R5_Efficiency_Factor_2 = 0.67;
    var R5_Efficiency_Factor_3 = 0.80;
    var R5_Efficiency_Factor_4 = 0.89;
    var R5_Efficiency_Factor_5 = 0.94;
    var R5_Bad_Block_Factor = 0.98;
    
    var Disk_Meta_Data = 0.0625;
   	var Disk_CDump = 0.125;
   	var Pool_Header_Room = 0.125;
	
	if( raidLevel == RSSM_RAID_TYPE_RAID5){
		var efficiencyFactor = 0; 
		
		if( diskcount <= 4){
			efficiencyFactor = R5_Efficiency_Factor_2;
		}else if( diskcount <= 8){
			efficiencyFactor = R5_Efficiency_Factor_3;
		}else if( diskcount <= 16){
			efficiencyFactor = R5_Efficiency_Factor_4;
		}else if( diskcount <= 25){
			efficiencyFactor = R5_Efficiency_Factor_5;
		}
	
	    capacity = diskcount * (singleCap - Disk_Meta_Data - Disk_CDump) * efficiencyFactor * R5_Bad_Block_Factor - Pool_Header_Room;
	}
	if (raidLevel == MIROR_RAID_TPYES || raidLevel == RSSM_RAID_TYPE_RAID1  || raidLevel == RSSM_RAID_TYPE_RAID10 ) {
		capacity = diskcount / 2 * (singleCap - Disk_Meta_Data - Disk_CDump) - Pool_Header_Room;
	}
	if (raidLevel == RSSM_RAID_TYPE_RAID0) {
		capacity = diskcount * (singleCap - Disk_Meta_Data - Disk_CDump) - Pool_Header_Room;
	}
	
	return capacity;
}

function refreshDiv() {
	var switches = retreiveType();
	var oneTableobj = document.getElementById("oneAddedDiskDiv");
	var twoTableobj = document.getElementById("twoAddedDiskDiv");
	clearTable();
	if (switches == "1") {
		oneTableobj.style.display = "block";
		twoTableobj.style.display = "none";
		document.getElementById("contentTableScrollDiv1").style.width = "100%";
		document.getElementById("contentTableScrollDiv1").focus();
		document.getElementById("contentTableScrollDiv1").blur();
	} else if (switches == "2") {
		oneTableobj.style.display = "none";
		twoTableobj.style.display = "block";
		document.getElementById("contentTableScrollDiv2").style.width = "100%";
		document.getElementById("contentTableScrollDiv2").focus();
		document.getElementById("contentTableScrollDiv2").blur();
		document.getElementById("contentTableScrollDiv3").style.width = "100%";
		document.getElementById("contentTableScrollDiv3").focus();
		document.getElementById("contentTableScrollDiv3").blur();
	}	
}

function refreshButton() {
    var flag = true;//return result that store the previous isNext
	var raidstype = retreiveRaidLevel();
	var requiredDisk = getRequiredDisks();
	var nameEmpty = true;
	
	var availablecount = countCheckBox("availableDiskTable" , true);
	var onecount = countCheckBox("oneAddedDiskTable" , true);
	var oneallcount = countCheckBox("oneAddedDiskTable" , false);
	var twoAcount = countCheckBox("twoAddedDiskATable" , true);
	var twoBcount = countCheckBox("twoAddedDiskBTable" , true);
	var twoAallcount = countCheckBox("twoAddedDiskATable" , false);
	var twoBallcount = countCheckBox("twoAddedDiskBTable" , false);
	
	var addoneButton = document.getElementById(namespace_g + "myForm:oneAddedDiskAddButton");
	var removeoneButton = document.getElementById(namespace_g + "myForm:oneAddedDiskRemoveButton");
	var addtwoupButton = document.getElementById(namespace_g + "myForm:twoAddedDiskUpAddButton");
	var addtwodownButton = document.getElementById(namespace_g + "myForm:twoAddedDiskDownAddButton");
	var removetwoupButton = document.getElementById(namespace_g + "myForm:twoAddedDiskUpRemoveButton");
	var removetwodownButton = document.getElementById(namespace_g + "myForm:twoAddedDiskDownRemoveButton");
		
	var raid1Error = document.getElementById("selectionErrorTR");
	
	var okButton = document.getElementById(namespace_g + "myForm:okbutton");
	var nextInd = document.getElementById(namespace_g + "myForm:isNext");
	var tag = document.getElementById(namespace_g + "myForm:tag").value;
	
	document.getElementById(namespace_g + "myForm:selectedNumber").innerHTML = countCheckBox("availableDiskTable" , true);
/*
	if (tag == "CreateAdvancedPool") {
        var theObj = document.getElementById(namespace_g + "myForm:poolName");
		var existedName = ","+document.getElementById(namespace_g + "myForm:existedPoolName").innerHTML;
		if(theObj.value.length==0){
			nextInd.value="false";		
		}
		else if(!isDeviceNameValid(theObj.value) || existedName.indexOf(","+theObj.value+",")>-1){
			nextInd.value="false";
			if(parent)
				parent.refreshNext();
			return;
		}else{
			nameEmpty = false;
		}
	}
*/
	if (raidstype == RSSM_RAID_TYPE_RAID5 || raidstype == RSSM_RAID_TYPE_RAID0) {
		
		/* --- refresh add and remove button --- */
		if (availablecount > 0) {
			addoneButton.disabled = "";
		} else {
			addoneButton.disabled = "disabled";
		}

		if (onecount > 0) {
			removeoneButton.disabled = "";
		} else {
			removeoneButton.disabled = "disabled";
		}
		/* --- end of refresh add and remove button --- */
		
		/* --- refresh ok button --- */
		if (tag == "CreateAdvancedPool") {
			if (oneallcount >= requiredDisk) {
				if (okButton) {
					okButton.disabled = "";
				}
				if(!nameEmpty)
					flag = true;
			} else {
				if (okButton) {
					okButton.disabled = "disabled";
				}
				flag = false;
			}
		} else if (tag == "ExpandPool") {
			if (document.getElementById("AdditionalCapacityNeededTR").style.display == "none" && oneallcount > 0) {
				flag = true;
			} else {
				flag = false;
			}
		}		
		/* --- end of refresh ok button --- */
		if (parent) {
			parent.refreshNext();
		}

			raid1Error.style.display='none';
		
		return flag;
	}
	
	if (raidstype == RSSM_RAID_TYPE_RAID10 || raidstype == RSSM_RAID_TYPE_RAID1) {
	
		/* --- refresh add and remove button --- */
		if (availablecount > 0) {
			addtwoupButton.disabled = "";
			addtwodownButton.disabled = "";
		} else {
			addtwoupButton.disabled = "disabled";
			addtwodownButton.disabled = "disabled";
		}
		if (twoAcount > 0) {
			removetwoupButton.disabled = "";
		} else {
			removetwoupButton.disabled = "disabled";
		}
		if (twoBcount > 0) {
			removetwodownButton.disabled = "";
		} else {
			removetwodownButton.disabled = "disabled";
		}
		/* --- end of refresh add and remove button --- */
		
		/* --- refresh ok button --- */
		if (tag == "CreateAdvancedPool") {
			if (twoAallcount >= requiredDisk / 2 && twoBallcount >= requiredDisk / 2 && twoAallcount == twoBallcount) {
				if (okButton) {
					okButton.disabled = "";
				}
				flag = true;
			} else {
				if (okButton) {
					okButton.disabled = "disabled";
				}
				flag = false;
			}
		} else if (tag == "ExpandPool") {
			if (twoAallcount == twoBallcount && twoAallcount > 0 && document.getElementById("AdditionalCapacityNeededTR").style.display == "none") {
				flag = true;
			} else {
				flag = false;
			}
		}
		/* --- end of refresh ok button --- */
		
		if (parent) {
			parent.refreshNext();
		}
		
		raid1Error.style.display='none';
		return flag;
	}	
}

function refreshTableStyle(tbodyobj) {
	var rowlen = tbodyobj.rows.length;
	for (var i = 0;i < rowlen;i ++) {
		if (i % 2 == 0) {
			tbodyobj.rows[i].className = "dmc_rowClass1";
		} else {
			tbodyobj.rows[i].className = "dmc_rowClass2";
		}
	}
}
/* ------ end of refresh functions ----- */

/* ------ button actions ------ */
function move(fromTable , toTable) {
	moveRow(fromTable , toTable , true);
	refreshInformation();
	refreshButton();
}

function getAvailableSystemCapacity(fromTable){
	var fromTableobj = document.getElementById(fromTable);
	var fromTableTbodyobj = fromTableobj.getElementsByTagName("tbody")[0]; // !
	var rowlen = fromTableTbodyobj.rows.length;
	var availableCapacity = 0;
	for (var i = 0;i < rowlen;i ++) {
		var trobj = fromTableTbodyobj.rows[i];
		availableCapacity+=parseDecimalEscapeHTMLTag(trobj.cells[1].lastChild.lastChild.innerHTML);
	}
	return availableCapacity;
}

function getCapacityFromSelection(raidLevel,diskArray){
	var capacity = 0;
	if(diskArray==null)
	   diskArray = poolUsedDiskSizeArray;
	var diskcount = diskArray.length
	var minCapacity = 0;
	for(var i=0;i<diskcount;i++){
		var cap = Number(diskArray[i]);
		if(minCapacity==0 || minCapacity>cap)
		   minCapacity = cap;
	}
	var R5_Efficiency_Factor_2 = 0.67;
    var R5_Efficiency_Factor_3 = 0.80;
    var R5_Efficiency_Factor_4 = 0.89;
    var R5_Efficiency_Factor_5 = 0.94;
    var R5_Bad_Block_Factor = 0.98;
    
    var Disk_Meta_Data = 0.0625;
   	var Disk_CDump = 0.125;
   	var Pool_Header_Room = 0.125;
	
	if( raidLevel == RSSM_RAID_TYPE_RAID5){
		var efficiencyFactor = 0; 
		
		if( diskcount <= 4){
			efficiencyFactor = R5_Efficiency_Factor_2;
		}else if( diskcount <= 8){
			efficiencyFactor = R5_Efficiency_Factor_3;
		}else if( diskcount <= 16){
			efficiencyFactor = R5_Efficiency_Factor_4;
		}else if( diskcount <= 25){
			efficiencyFactor = R5_Efficiency_Factor_5;
		}
	
	    capacity = diskcount * (minCapacity - Disk_Meta_Data - Disk_CDump) * efficiencyFactor * R5_Bad_Block_Factor - Pool_Header_Room;
	}
	if (raidLevel == MIROR_RAID_TPYES || raidLevel == RSSM_RAID_TYPE_RAID1  || raidLevel == RSSM_RAID_TYPE_RAID10 ) {
		capacity = diskcount/2*(minCapacity - Disk_Meta_Data - Disk_CDump) - Pool_Header_Room;
	}
	if (raidLevel == RSSM_RAID_TYPE_RAID0) {
		capacity = diskcount*(minCapacity - Disk_Meta_Data - Disk_CDump) - Pool_Header_Room;
	}
	return capacity;
}
var poolUsedDiskSizeArray = new Array();
function removeDiskCapacity(cap){
	for(var i=0;i<poolUsedDiskSizeArray.length;i++){
		if((Number(poolUsedDiskSizeArray[i])-cap)==0){
			poolUsedDiskSizeArray.splice(i,1);
			return;
		}		
	}
}

function moveRow(fromTable , toTable , ifcheck) {
	var widthArray = new Array()
	widthArray[0] = "10%"
	widthArray[1] = "40%"
	widthArray[2] = "25%"
	widthArray[3] = "25%";
	var fromTableobj = document.getElementById(fromTable);
	var fromTableTbodyobj = fromTableobj.getElementsByTagName("tbody")[0];
	var toTableobj = document.getElementById(toTable);
	var toTableTbodyobj = toTableobj.getElementsByTagName("tbody")[0];
	var rowlen = fromTableTbodyobj.rows.length;
	var trarray = new Array();
	for (var i = 0;i < rowlen;i ++) {
		var trobj = fromTableTbodyobj.rows[i];
		var inputobj = trobj.getElementsByTagName("input")[0];
		if (inputobj.type == "checkbox" && (inputobj.checked == ifcheck)) {
			trarray.push(trobj);
			if(fromTable==namespace_g + "myForm:availableDiskTable"){
				poolUsedDiskSizeArray.push(parseDecimalEscapeHTMLTag(trobj.cells[1].lastChild.lastChild.innerHTML));
			}else{
				removeDiskCapacity(parseDecimalEscapeHTMLTag(trobj.cells[1].lastChild.lastChild.innerHTML));
			}
			var classstyle = toTableTbodyobj.rows.length % 2 == 0 ? "dmc_rowClass1" : "dmc_rowClass2";
			var newrow = toTableTbodyobj.insertRow(toTableTbodyobj.rows.length);
			newrow.className = classstyle;
			newrow.valign = "top";
			//newrow.align = "left";
			inputobj.checked = false;
			
			for (var k = 0;k < trobj.cells.length;k ++) {
				var cell = document.createElement("td");
				newrow.appendChild(cell);
				cell.width = widthArray[k];
				cell.align = "left";
				cell.innerHTML = trobj.cells[k].innerHTML;
			}
		}
	}
	
	for (var j = 0;j < trarray.length;j ++) {
		fromTableTbodyobj.removeChild(trarray[j]);
	}
	refreshTableStyle(fromTableTbodyobj);
	saveData();
}

function clearTable() {
	var onetableobj = document.getElementById(namespace_g + "myForm:oneAddedDiskTable");
	var twotableAobj = document.getElementById(namespace_g + "myForm:twoAddedDiskATable");
	var twotableBobj = document.getElementById(namespace_g + "myForm:twoAddedDiskBTable");
	var tableTbodyobj = onetableobj.getElementsByTagName("tbody")[0];
	var rowlen = tableTbodyobj.rows.length;
	for (var i = 0;i < rowlen;i ++) {
		tableTbodyobj.deleteRow(0);
	}
	var twoAtableTbodyobj = twotableAobj.getElementsByTagName("tbody")[0];
	var twoArowlen = twoAtableTbodyobj.rows.length;
	for (var j = 0;j < twoArowlen;j ++) {
		twoAtableTbodyobj.deleteRow(0);
	}
	var twoBtableTbodyobj = twotableBobj.getElementsByTagName("tbody")[0];
	var twoBrowlen = twoBtableTbodyobj.rows.length;
	for (var k = 0;k < twoBrowlen;k ++) {
		twoBtableTbodyobj.deleteRow(0);
	}
}

function saveData() {
	var oneTablehidden = document.getElementById(namespace_g + "myForm:oneAddedDiskTableData");
	var twoATablehidden = document.getElementById(namespace_g + "myForm:twoAddedDiskATableData");
	var twoBTablehidden = document.getElementById(namespace_g + "myForm:twoAddedDiskBTableData");
	oneTablehidden.value = "";
	twoATablehidden.value = "";
	twoBTablehidden.value = "";
	
	var switches = retreiveType();
	if (switches == "1") {
		var oneTableobj = document.getElementById(namespace_g + "myForm:oneAddedDiskTable");
		var oneTableTbodyobj = oneTableobj.getElementsByTagName("tbody")[0];
		var rowlen = oneTableTbodyobj.rows.length;
		for (var i = 0;i < rowlen;i ++) {
			var onetrobj = oneTableTbodyobj.rows[i];
			var oneinputobj = onetrobj.getElementsByTagName("input");
			for (var kk = 0;kk < oneinputobj.length;kk ++) {
				if (oneinputobj[kk].type == "hidden") {
					oneTablehidden.value += oneinputobj[kk].value + "|";
				}
			}
		}
		oneTablehidden.value = oneTablehidden.value.substring(0 , oneTablehidden.value.length - 1);
		return;
	}
	
	if (switches == "2") {
		var twoATableobj = document.getElementById(namespace_g + "myForm:twoAddedDiskATable");
		var twoATableTbodyobj = twoATableobj.getElementsByTagName("tbody")[0];
		var rowAlen = twoATableTbodyobj.rows.length;
		for (var k = 0;k < rowAlen;k ++) {
			var twoAtrobj = twoATableTbodyobj.rows[k];
			var twoAinputobj = twoAtrobj.getElementsByTagName("input");
			for (var ii = 0;ii < twoAinputobj.length;ii ++) {
				if (twoAinputobj[ii].type == "hidden") {
					twoATablehidden.value += twoAinputobj[ii].value + "|";
				}
			}
		}
		
		twoATablehidden.value = twoATablehidden.value.substring(0 , twoATablehidden.value.length - 1);
		
		var twoBTableobj = document.getElementById(namespace_g + "myForm:twoAddedDiskBTable");
		var twoBTableTbodyobj = twoBTableobj.getElementsByTagName("tbody")[0];
		var rowBlen = twoBTableTbodyobj.rows.length;
		for (var j = 0;j < rowBlen;j ++) {
			var twoBtrobj = twoBTableTbodyobj.rows[j];
			var twoBinputobj = twoBtrobj.getElementsByTagName("input")[1];
			if (twoBinputobj.type == "hidden") {
				twoBTablehidden.value += twoBinputobj.value + "|";
			}
		}
		
		twoBTablehidden.value = twoBTablehidden.value.substring(0 , twoBTablehidden.value.length - 1);
		return;
	}
}
/* ------ end of button actions ------ */

/* ------ utility of page count ------ */
function countCheckBox(tableid , needcheck) {
	var tblobj = document.getElementById(namespace_g + "myForm:" + tableid);
	var tbodyobj = tblobj.getElementsByTagName("tbody")[0];
	
	var rowlen = tbodyobj.rows.length;
	var count = 0;
	var inputobjs = tbodyobj.getElementsByTagName("input");
	for (var i = 0;i < inputobjs.length;i ++) {
		if (inputobjs[i].type == "checkbox" && (needcheck ? inputobjs[i].checked : true)) {
			count ++;
		}
	}
	
	return count;
}

function retreiveElement(types) {
	var tag = document.getElementById(namespace_g + "myForm:tag").value;
	var selectValue = null;
	if( tag == "CreateAdvancedPool"){
		var selectValueobj = document.getElementById(namespace_g + "myForm:raidLevel");
		selectValue = selectValueobj.options[selectValueobj.selectedIndex].value;		
	}else if( tag == "ExpandPool"){
	    selectValue = document.getElementById(namespace_g + "myForm:raidLevel").value;	    	
	}
	
	if (types == "raid") {
		return selectValue;
	}

	var availableValue = document.getElementById(namespace_g + "myForm:tableTypeIndicator").value;
	var availableArray = availableValue.split("|");

	for (var i = 0;i < availableArray.length;i ++) {
		var mayvalue = availableArray[i].split("_")[0];
		var mayindicate = availableArray[i].split("_")[1];
		if (selectValue == mayvalue) {
			if (types == "type") {
				return mayindicate;
			}
		}
	}
}

function retreiveType() {
	return retreiveElement("type");
}

function retreiveRaidLevel() {
	return retreiveElement("raid");

}
/* ------- end of utility functions of page count ------- */

function submitForm() {
	document.getElementById(namespace_g + "myForm:btnSubmit").click();
}
// end of the functions for advanced

/* ------- click Next button   ------- */
function expandPoolDirect(_event){	
	 var expandType = document.getElementById(namespace_g + "myForm:expandType").value;
	 if( expandType == "advanced"){
	 	document.getElementById(namespace_g + "myForm:SelectDrivesButton").click();	 	
	 }else if( expandType == "easy"){ 
	    document.getElementById(namespace_g + "myForm:ExpandPoolConfirmButton").click();
	 }
}

function validateAddButton(){
	var nameObj = document.getElementById(namespace_g + "myForm:name");
	var capacityObj = document.getElementById(namespace_g + "myForm:capacity");
	var quantityObj = document.getElementById(namespace_g + "myForm:quantity");	
	var nameSuffixObj = document.getElementById(namespace_g + "myForm:nameSuffix");
	
	if(nameObj.value == "" || capacityObj.value == "" || quantityObj.value == ""){
		document.getElementById(namespace_g + "myForm:addButton").disabled=true;
		return;
	}
	
	var name = nameObj.value;
	var nameSuffix = nameSuffixObj.value;
	var sumLength = name.length + nameSuffix.length;
	if( sumLength > 12 || sumLength < 1 || name.length == 0 || !isDeviceNameValid(name)){
		document.getElementById(namespace_g + "myForm:addButton").disabled=true;
		return;
	}
	
	var capacityValue = capacityObj.value;
	var capNum = Number(capacityValue);
	if(isNaN(capNum) || capacityValue.indexOf(".") == 0 || capacityValue.indexOf(".") == (capacityValue.length-1)) {
		document.getElementById(namespace_g + "myForm:addButton").disabled=true;
		return;
	} 
	/* The capacity now support float value
	 * commented by jmzhang
	 **/
	/*
	if (capacityValue.indexOf(".") > 0 && capacityValue.substring(capacityValue.lastIndexOf(".")+1).length > 3) {
		document.getElementById(namespace_g + "myForm:addButton").disabled=true;
		return;
	}*/
	if (capacityValue.split("\\.").length > 2 || capacityValue.substring(capacityValue.lastIndexOf(".")+1).length > 3) {
		document.getElementById(namespace_g + "myForm:addButton").disabled = true;
		return ;
	}
	
	if( capNum <= 0 || capNum > maxCapacity){
		document.getElementById(namespace_g + "myForm:addButton").disabled=true;
		return;
	}  
	
	var nameSuffixValue = nameSuffixObj.value;
	if( nameSuffixValue != ""){
		if( !validateNumber(nameSuffixValue)){
			document.getElementById(namespace_g + "myForm:addButton").disabled=true;
			return;
		}
	} 
	
	var quantityValue = quantityObj.value;
	var createdVolumeNumber = document.getElementById(namespace_g + "myForm:createdVolumeNumber").innerHTML - 0;
	var prepareVolumesNumber = document.getElementById(namespace_g + "myForm:prepareVolumesNumber").innerHTML - 0;
	    
	if( !validateNumber(quantityValue) ){
		document.getElementById(namespace_g + "myForm:addButton").disabled=true;
		return;
	}
	
	if( quantityValue < 1 || quantityValue > maxQuantity){
		document.getElementById(namespace_g + "myForm:addButton").disabled=true;
		return;
	}
	
	if( ! validateMaxInteger(nameSuffixValue) || ! validateMaxInteger(Number(quantityValue-1) + Number(nameSuffixValue))){
		document.getElementById(namespace_g + "myForm:addButton").disabled=true;
		return;
	}
	
	var sum = Number(quantityValue) + Number(createdVolumeNumber) + Number(prepareVolumesNumber);;
	if( sum > maxQuantity){
		document.getElementById(namespace_g + "myForm:addButton").disabled=true;
		return;
	}
	   	
	document.getElementById(namespace_g + "myForm:addButton").disabled=false;
}

//if user input .5 as capacity, change to 0.5 instead
function addZeroIfNeeded(){
   var capacity = document.getElementById(namespace_g + "myForm:capacity").value;	
   if(capacity.indexOf(".") == 0){
       document.getElementById(namespace_g + "myForm:capacity").value = "0"+capacity;
   } 
}

function generateVolumeName(fromEvent){
	var allCreatedVolumeNameStr = "," + document.getElementById(namespace_g + "myForm:allCreatedVolumeNameStr").innerHTML;
	var nameObj = document.getElementById(namespace_g + "myForm:name");
	var quantityObj = document.getElementById(namespace_g + "myForm:quantity");	
	var nameSuffixObj = document.getElementById(namespace_g + "myForm:nameSuffix");
	var result = true;
	var newName = "";
	if( nameObj.value != ""){
		
		if( nameSuffixObj.value != ""){
			if( ! validateNameSuffixWithoutErrorMsg(nameSuffixObj.id)){
			 	result = false;
			}
			
			if( ! validateMaxIntegerWithoutErrorMsg(nameSuffixObj.value)){
			    result = false;
			}
		}
		if( quantityObj.value != ""){
			if( ! validateQuantityWithoutErrorMsg(quantityObj.id,fromEvent)){
	     		result = false;
			}				
		}
		if (result) {
			if (!validateNameWithoutErrorMsg(nameObj.id)) {
				result = false;
			}
		}
		if( result){
			if( nameSuffixObj.value == ""){
				newName = nameObj.value;
			}else if(quantityObj.value != ""){
				var beginName = nameObj.value + parseInt(nameSuffixObj.value);					
				var index = parseInt(nameSuffixObj.value) + parseInt(quantityObj.value - 1);
				if( ! validateMaxInteger(index)){
				    newName = nameObj.value;
				}else{
					var endName = nameObj.value + index;
					newName = beginName + "-" + endName; 		
				}					
			}			
		}
	}

	document.getElementById(namespace_g + "myForm:exampleName").innerHTML = newName;
	return result;
}

function validateMaxInteger(_value){
	var Integer_MAX_VALUE = 2147483647;
	
 	if( Number(_value) > Integer_MAX_VALUE){
		showErrorMsg('nameSuffixMsg_tr','nameSuffixMsg_span', nameSuffix_max_ErrMsg);
		return false;
	}else{
	    return true;
	}
}

function validateMaxIntegerWithoutErrorMsg(_value){
	var Integer_MAX_VALUE = 2147483647;
	
 	if( Number(_value) > Integer_MAX_VALUE){
		return false;
	}else{
	    return true;
	}
}

/*
 * select checkbox action in DefineVolumes page
 */
function selectCheckBox_defineVolumes(){	
	refreshRemoveButton();
	//selectOnlyOneCheckBox(_object.id);
	//selectedCheckBoxID = _object.id; 
}

/*
 * count the selected checkbox in DefineVolumes page
 */
function countSelectedCheckBox(tableID){
	var count = 0;
	var tableObj = document.getElementById(tableID);	
	var inputobjs = tableObj.getElementsByTagName("input");
	for (var i = 0;i < inputobjs.length;i ++) {
		if (inputobjs[i].type == "checkbox" && inputobjs[i].checked ) {
			count ++;
		}
	}
	return count;
}

function refreshRemoveButton(){
	var count = countSelectedCheckBox(namespace_g + "myForm:newVolumesTable");
	if( count > 0){
	    document.getElementById(namespace_g + 'myForm:removeButton').disabled = false;
	}else{
		document.getElementById(namespace_g + 'myForm:removeButton').disabled = true;
	}
}

//defect 7170,check wether pool name valid,---start
function checkPoolNameInCreateBasicPool(){
	var poolName = document.getElementById(namespace_g + "myForm:poolName").value;
	var allPoolName = "," + document.getElementById(namespace_g + "myForm:allExistingPoolNameStr").innerHTML;
	var errMsg = null;
	var result = false;
	if(poolName.trim() == ""){
		errMsg = document.getElementById(namespace_g + "myForm:poolNameEmptyMessage").innerHTML;
	}else if( !isDeviceNameValid(poolName)){ 
	    errMsg = document.getElementById(namespace_g + "myForm:poolNameErrorMessage").innerHTML;
	}else if( poolName.length > 12){	    
	   	errMsg = document.getElementById(namespace_g + "myForm:nameLength_ErrMsg").innerHTML;	    
	}else if( allPoolName != null && allPoolName.indexOf(","+poolName+",") != -1){
	    errMsg = document.getElementById(namespace_g + "myForm:findDefinedPoolName_ErrMsg").innerHTML;
	}else{
	    result = true;
	}
	if(!result){
	    showErrorMsg('poolNameMsg_tr',namespace_g + 'myForm:poolName_errMsg', errMsg);
	}
	
	parent.refreshNext();
	return result;	 	
}

function checkPoolNameInCreateAdvancedPool() {
    //defect 7170,add a flag to indicate whether poolname pass validation.
    //if valid, return true;otherwise,return false
    var flag = false;
    var poolName = document.getElementById(namespace_g + "myForm:poolName").value;
	var existedName = ","+document.getElementById(namespace_g + "myForm:existedPoolName").innerHTML;
	if (poolName == "") {
		var errMsg = document.getElementById(namespace_g + "myForm:CreatePoolAdvanced_ErrMsg_PoolNameNull").innerHTML;
		document.getElementById(namespace_g + "myForm:poolName_errMsg").innerHTML = errMsg;
		document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display="";
	}
    else if(!isDeviceNameValid(poolName))	{
		var errMsg = document.getElementById(namespace_g + "myForm:CreatePoolAdvanced_ErrMsg_PoolNameInvalid").innerHTML;
		document.getElementById(namespace_g + "myForm:poolName_errMsg").innerHTML = errMsg;
		document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display="";
	}else if (existedName.indexOf(","+poolName+",") != -1) {
		var errMsg = document.getElementById(namespace_g + "myForm:CreatePoolAdvanced_ErrMsg_PoolNameExisted").innerHTML;
		document.getElementById(namespace_g + "myForm:poolName_errMsg").innerHTML = errMsg;
		document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display="";
	}else{
		document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display="none";
		flag = true;
	}
	parent.refreshNext();
	return flag;
}
	
function validateSubmitInCreateBasicPool(event){
    clearErrorMsgInCreatBasicPool();
    var flag1 = checkPoolNameInCreateBasicPool();
    if(flag1){
        flag1 = validateSubmit('CreateBasicPool',event, '', 450, 280);
    }
    return flag1;
}
	
function validateSubmitInCreateAdvancedPool(){
    clearErrorMsgInCreateAdvancePool();
    var flag1 = checkPoolNameInCreateAdvancedPool();
    var flag2= refreshButton();
    var flag = flag1&&flag2;

    if(flag1&&!flag2){
        document.getElementById(namespace_g + "myForm:disk_errMsg").style.display="";
    }
    //defect 10385, add a popup dialog to indicate error happen, support accessbility
    if(!flag){
        document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
    }
    
    if(flag){
        document.getElementById(namespace_g + "myForm:disk_errMsg").style.display="none";
        popup_dialog(500, 270);
    }
    return flag;
}
function validateSubmitInExpandAdvancedPool(){
    //clearErrorMsgInCreateAdvancePool();
    var flag= refreshButton();
    //1.not pass validation
    if(!flag){
        document.getElementById(namespace_g + "myForm:disk_errMsg").style.display="";
        //defect 10385, add a popup dialog to indicate error happen, support accessbility
        document.getElementById(namespace_g + "myForm:validation_subview:showValidationBtn").click();
        
    }else{
        document.getElementById(namespace_g + "myForm:disk_errMsg").style.display="none";
        document.getElementById(namespace_g + 'myForm:chkSubmit').click();
    }
    return flag;
    
}
function clearErrorMsgInCreatBasicPool(){
    var theObj = document.getElementById(namespace_g + "myForm:poolName");
    var existedName = ","+document.getElementById(namespace_g + "myForm:allExistingPoolNameStr").innerHTML;
    if(isDeviceNameValid(theObj.value) && existedName.indexOf(","+theObj.value+",")==-1 
      && document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display != 'none'){
        document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display="none";
        document.getElementById("poolNameMsg_tr").style.display="none";
    }
}

function clearErrorMsgInCreateAdvancePool(){
    var theObj = document.getElementById(namespace_g + "myForm:poolName");
	var existedName = ","+document.getElementById(namespace_g + "myForm:existedPoolName").innerHTML;
	if(isDeviceNameValid(theObj.value) && existedName.indexOf(","+theObj.value+",")==-1
	  && document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display != "none"){
	    document.getElementById(namespace_g + "myForm:poolName_errMsg").style.display="none";
	}
}
//defect 7170,add by qiuhongyan,---end

/**
 * Function for the column link of the pool tab
 *
 */
function clickPoolColumnLink(thisObj) {
	document.getElementById(thisObj.id).href="javascript:;";
	syncCheckbox(true, "rowLinkHidden");
	syncCheckbox(false, "rowLinkSelectHidden");
	
	var cns = thisObj.parentNode.parentNode.parentNode.firstChild.firstChild.childNodes;		
	for(var i=0; i<cns.length; i++){
		var field = cns[i];
		if (field.type == "checkbox" && field.id.indexOf("rowLinkSelectHidden") > -1) {
			field.checked = true;
			break;
		}
	}
	document.getElementById(namespace_g + 'myForm:viewProperties').click();
	parent.setStorageUtilTitle('poolPropertiesTitle');
}

	var expandaImgURL = document.global_context_path + '/images/common/help/expandahelp.gif';
	var collapseaImgURL = document.global_context_path + '/images/common/help/collapseahelp.gif';
	
	function showRaidLevelHelp(imgObj){
		var raidLevelHelpExpanded = document.getElementById(namespace_g + "myForm:isRaidLevelHelpExpanded").innerHTML;
		if (raidLevelHelpExpanded=='true') {
			imgObj.src = collapseaImgURL;
			imgObj.alt = document.getElementById(namespace_g + "myForm:collapse_alt").innerHTML;
			imgObj.title = document.getElementById(namespace_g + "myForm:collapse_alt").innerHTML;
			document.getElementById('RAIDLevelHelp').style.display = '';
			document.getElementById(namespace_g + "myForm:isRaidLevelHelpExpanded").innerHTML = 'false';
		}else{
			imgObj.src = expandaImgURL;
			imgObj.alt = document.getElementById(namespace_g + "myForm:expand_alt").innerHTML;
			imgObj.title = document.getElementById(namespace_g + "myForm:expand_alt").innerHTML;
			document.getElementById('RAIDLevelHelp').style.display = 'none';
			document.getElementById(namespace_g + "myForm:isRaidLevelHelpExpanded").innerHTML = 'true';
		}
	}
	
	function showAvailablePoolCapacityHelp(imgObj){
		var availablePoolCapacityHelpExpanded = document.getElementById(namespace_g + "myForm:isAvailablePoolCapacityHelpExpanded").innerHTML;
		if (availablePoolCapacityHelpExpanded=='true') {
			imgObj.src = collapseaImgURL;
			imgObj.alt = document.getElementById(namespace_g + "myForm:collapse_alt").innerHTML;
			imgObj.title = document.getElementById(namespace_g + "myForm:collapse_alt").innerHTML;
			document.getElementById('AvailablePoolCapacityHelp').style.display = '';
			document.getElementById(namespace_g + "myForm:isAvailablePoolCapacityHelpExpanded").innerHTML = 'false';
		}else{
			imgObj.src = expandaImgURL;
			imgObj.alt = document.getElementById(namespace_g + "myForm:expand_alt").innerHTML;
			imgObj.title = document.getElementById(namespace_g + "myForm:expand_alt").innerHTML;
			document.getElementById('AvailablePoolCapacityHelp').style.display = 'none';
			document.getElementById(namespace_g + "myForm:isAvailablePoolCapacityHelpExpanded").innerHTML = 'true';
		}
	}
	
	
function click_confirm_OKBut(OkButID, CancelButID, submitCommandButID){
	if( submitCommandButID && submitCommandButID != ''){
	    var submitCommandBut = document.getElementById(namespace_g + "myForm:"+submitCommandButID);
	    if( null != submitCommandBut){
	    	submitCommandBut.click();
	    }
	}

	var OkButObj = document.getElementById(namespace_g + 'myForm:'+OkButID);
	if( null != OkButObj){
		OkButObj.disabled = true;
	}
	
	var CancelButObj = document.getElementById(namespace_g + 'myForm:'+CancelButID);
	if( null != CancelButObj){
		CancelButObj.disabled = true;
	}

	var parentCloserBut = parent.document.getElementById(parent.namespace_g + 'myForm:dialog_closer');
	if( null != parentCloserBut){
		parentCloserBut.click();
	}	
}

function refreshVolumeNext() {
	if(document.getElementById(namespace_g + 'myForm:isMandatory').value == 'true'){
		if(document.getElementById(namespace_g + 'myForm:newVolumesTable').rows.length > 0) {
			document.getElementById(namespace_g + 'myForm:isNext').value='true';
			
		} else {
			document.getElementById(namespace_g + 'myForm:isNext').value='false';
			
		}
		parent.refreshNext();
	}
	
	document.getElementById(namespace_g + 'myForm:name').value='';
	document.getElementById(namespace_g + 'myForm:capacity').value='';
	document.getElementById(namespace_g + 'myForm:quantity').value='1';
	document.getElementById(namespace_g + 'myForm:nameSuffix').value='';
	
	disableSuffixField();
}


function enablePoolNameInput(){
	// Enable the name input filed.
	document.getElementById(namespace_g + "myForm:poolName").disabled = false;	
	document.getElementById(namespace_g + "myForm:driveType").disabled = false;
	document.getElementById(namespace_g + "myForm:raidLevel").disabled = false;
}

function disablePoolNameInput(){
	var poolnametext = document.getElementById(namespace_g + "myForm:poolName");
	poolnametext.disabled = true;
}


// When page load first,the pool name should be set by default.[CreateBasicPool]
function setDefaultPoolName(){
	var poolnametext = document.getElementById(namespace_g + "myForm:poolName");
	var poolname_submit = document.getElementById(namespace_g + "myForm:poolName_submit");

	if( poolnametext && poolname_submit){
		if( poolnametext.value == ""){
			poolnametext.value = poolname_submit.value;	 
		}
	}	
}
/******************************Zhang Xiang added for descope Expand pool (defect 8323/11163)***********************************/
function checkExpandPoolTask(){
	var finishFlag = document.getElementById(namespace_g + 'myForm:finishFlag');
	if(finishFlag && "false"==document.getElementById(namespace_g + 'myForm:finishFlag').innerHTML){
		setTimeout(lazyDo ,1000);	
	}else{
		setTimeout(delayFinishExpandPool,1000);		
	}
}

function delayFinishExpandPool(){
	document.getElementById(namespace_g + 'myForm:NextButton').click();
}

function initExpandPoolCompletion(){
	//success or failure, the Next button is disabled, the Finish botton is enabled.
	var stepFrame = parent.getFrame("step_iframe");
	stepFrame.document.getElementById(namespace_g + "myForm:isNext").value = false;
	parent.document.getElementById(namespace_g + "myForm:hidden_showFinish").value = true;
	
    var expandResult = document.getElementById(namespace_g + "myForm:expandResult").innerHTML;
    
	if( expandResult == "false"){
        //fail to expand pool,back button enable, next button disable
        parent.document.getElementById(parent.namespace_g + "myForm:hidden_showPrev").value = true;
    }else if( expandResult == "true"){
        //success to create pool,back button disable
        parent.document.getElementById(parent.namespace_g + "myForm:hidden_showPrev").value = false;
    }
    parent.refreshNext();    
}
/****************************End of defect 8323/11163********************************************************************/

function basicPoolDiskOptionAjaxCompleted(){
	enableSelectMenu();
	setDefaultSelectedOption();
	enablePoolNameInput();
	setDefaultPoolName();
	beepWhenRefresh();
	innerMessagesInstance.display();
	setTimeout(lazyAdjutBasicPoolCreationTableWidth,100);
}
function lazyAdjutBasicPoolCreationTableWidth(){
	alignHeaderTableAndContentTable('headerTableDivId','view:myForm:poolCapacityTable');
}

function expandPoolAdvancePathAjaxCompleted(){
	innerMessagesInstance.display();
	init_PostLoad();
	beepWhenRefresh();
	alignHeaderTableAndContentTable('headerTableDivId','availableDiskTable');
	alignHeaderTableAndContentTable('headerTableDivId1','oneAddedDiskTable');
	alignHeaderTableAndContentTable('headerTableDivId2','twoAddedDiskATable');
	alignHeaderTableAndContentTable('headerTableDivId3','twoAddedDiskBTable');
	SCMJsManager.getAttrManager().executeBinding();
}
