/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
 
 // Define the package

com.ibm.sysmgmt.rbce.gui.storage.ValueChangeListener = function(){
	this.valueChanged= function(newValue){}
}

 	
/*
 * Get the elements in the document by tag and the name
 * tag: the tag name of finding elments
 * name: the name of finding elements
 * @Note add this function as IE can not correctly support getElementsByName().
 */
function getElementsByTagAndName(tag,name){
	 var elem = document.getElementsByTagName(tag);
     var arr = new Array();
     for(i = 0,iarr = 0; i < elem.length; i++) {
          att = elem[i].getAttribute("name");
          if(att == name) {
               arr[iarr] = elem[i];
               iarr++;
          }
     }
     return arr;
}
 
com.ibm.sysmgmt.rbce.gui.storage.treetable = function(){
	// ************************************************************************ 
	// Private Fields
	// *********************************************************************** 
	
	var selectedRowObject = null;
	var selectedRow = null;
 	var valueChangeListenerList = new Array();
 	valueChangeListenerCount =0;
 		
	// ************************************************************************ 
	// Public Methods
	// *********************************************************************** 

	/*
	 * diplay/undisplay all braches of the treetable. 
	 * @param display display all if true, or undiplay all if false.
	 */
 	this.setAllDisplays = function(display){
		// NOTE: the prefix 'treetable_folder' is defined in the TreeTableController.
		var imgName ="treetable_folder_IMG";	
	
		var treetableFolderIMGs=getElementsByTagAndName("IMG",imgName);
		for(x = 0; x < treetableFolderIMGs.length; x++)
		{		
			if(true == display && treetableFolderIMGs[x].src.endWith('/expand_obj.gif'))
			{
				click(treetableFolderIMGs[x]);
			}
			else if(false == display && treetableFolderIMGs[x].src.endWith('/collapse_obj.gif'))
			{
				click(treetableFolderIMGs[x]);				
			}
		} 	
	 	
	 	if(display == false)
		{
			allCollapsedFixSelected();
		}
		 	
	}
 	
 	this.addValueChangeListener = function(valueChangeListener){
 		valueChangeListenerList[valueChangeListenerCount++]=valueChangeListener;
 	}

	// ************************************************************************ 
	// Package Methods: should only be used in current module
	// *********************************************************************** 
	
	/*
	 */
	this._clickRow = function(_object,_rowId){
	
		if(selectedRow != null)
		{
			//document.getElementById(selectedRow).className = "nbceTableUnselectedRow";
		}
	
		//document.getElementById(_rowId).className = "nbceTableSelectedRow";

		// Setting the new selected row
		selectedRow = _rowId;
		
		
//		setSelectedSwitchIpAddress(_object.ipAddress);
		
		fireValueChange(_object);
	} 

	
	
	/*
	 * Define the actions when the 'collapse' or 'expand' image is clicked
	 */
 	this._toggle = function(curRowId, childrenGroupId, image, event){
 		//value is not a standard attribute for <img>, so access its value in the way below
		var imageValue = image.attributes.value.value;
 		if(document.getElementById(childrenGroupId).style.display == "none")
		{
			document.getElementById(childrenGroupId).style.display = "block";
			var elems = getElementsByIdSuffix(":collapse_alt", "span");
			if(elems.length > 0)
			{
				image.alt = elems[0].innerHTML + " " + imageValue;
				image.title = elems[0].innerHTML + " " + imageValue;
			}
			image.src = document.global_context_path + "/images/common/tree/collapse_obj.gif";
		}
		else
		{
			document.getElementById(childrenGroupId).style.display = "none";
			var elems = getElementsByIdSuffix(":expand_alt", "span");
			if(elems.length > 0)
			{
				image.alt = elems[0].innerHTML + " " + imageValue;
				image.title = elems[0].innerHTML + " " + imageValue;
			}
			image.src = document.global_context_path + "/images/common/tree/expand_obj.gif";
		
			// Unselecting the selected row, in case an ancestor is collapsed
			elementCollapsedFixSelected(curRowId);
		}
	
		// So that the row isnt selected by toggling
		stopPropagation(event);
 	}
 

 
	// ************************************************************************ 
	// Private Methods
	// *********************************************************************** 

	/*
	 */
 	function fireValueChange(value){
 		for (i = 0; i < valueChangeListenerCount; i++)
	   {
	   		valueChangeListenerList[i].valueChanged(value);
	   }
 	} 

	/*
	 */
	function elementCollapsedFixSelected(collapsedId){
		// If nothing is selected, nothing needs to be fixed
		if(selectedRow == null)
			return;
		
		// Since the id of an element keeps its ancestor trace
		// We check if the selected row is a descendant of the collapsed row
		// by checking if the selected row id starts with the collapsed row id
		// We also make sure that the selected row wasnt collapsed
		if(selectedRow.indexOf(collapsedId) == 0 && selectedRow != collapsedId)
		{
			document.getElementById(selectedRow).className = "nbceTableUnselectedRow";
			selectedRow = null;
			selectRowValues = null;
			
			fireValueChange(null);
			//changeMenuOptions("Default");
		}
	}
	
	/*
	 * Todo this method can be private
	 * Update selectd row when collapse the tree table.
	 * in this situation, the select row in the treetable will be changed without clicking. 
	 */
 	function allCollapsedFixSelected() {
 		//alert(selectedRow);
 		
	 	// If nothing is selected, nothing needs to be fixed
		if(selectedRow == null)
			return;
			
		// If a root node is selected, then we dont need to do anything
		// Root nodes will not have dashes in the id
		if(selectedRow.substr(14).indexOf("_") == -1)
		{
			return;
		}
		else
		{
			// Here we need to unselect
			//document.getElementById(selectedRow).className = "nbceTableUnselectedRow";
			selectedRow = null;
			selectRowValues = null;
			
			fireValueChange(null);
			//changeMenuOptions("Default");
		}
 	}
 	
	/*
	 */
	function stopPropagation(thisEvent){
		// For IE
		if(!thisEvent)
			thisEvent = window.event;
	
			
		thisEvent.cancelBubble = true;
			
		// For Mozilla
		if(thisEvent.stopPropagation)
			thisEvent.stopPropagation();
	}


 	
 }
 
 // ************************************************************************ 
// Static Methods&Fields
// *********************************************************************** 
com.ibm.sysmgmt.rbce.gui.storage.treetable._instance=null;

/*
 * singleton of treeTable
 */
com.ibm.sysmgmt.rbce.gui.storage.treetable.getInstance = function(){
	if(com.ibm.sysmgmt.rbce.gui.storage.treetable._instance == null){
		com.ibm.sysmgmt.rbce.gui.storage.treetable._instance = new com.ibm.sysmgmt.rbce.gui.storage.treetable();
	}
	
	return com.ibm.sysmgmt.rbce.gui.storage.treetable._instance;
};
 
 
